<?php
/**
* Class newsletter
*
* Newsletter module class
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>
* @module		Newsletter
* @modulegroup	modules
* @access		public
* @version		1.0.0
*/

class newsletter
{
	var $_objTpl;
	var $_pageTitle;
	var $_strErrMessage = '';
	var $_strOkMessage = '';

	var $_arrMailFormat = array(
		'text'		=> 'TXT_NEWSLETTER_ONLY_TEXT',
		'html'		=> 'TXT_NEWSLETTER_HTML_UC',
		'html/text'	=> 'TXT_NEWSLETTER_MULTIPART_TXT'
	);

	var $_stdMailFormat = 'text';

	var $_arrMailPriority = array(
		1	=> 'TXT_NEWSLETTER_VERY_HIGH',
		2	=> 'TXT_NEWSLETTER_HIGH',
		3	=> 'TXT_NEWSLETTER_MEDIUM',
		4	=> 'TXT_NEWSLETTER_LOW',
		5	=> 'TXT_NEWSLETTER_VERY_LOW'
	);

	var $_stdMailPriority = 3;

	var $_attachmentPath = '/images/attach/';

	/**
	* Constructor
	*/
	function newsletter()
	{
		$this->__construct();
	}

	/**
	* PHP5 constructor
	*
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/
	function __construct()
	{
		global $objTemplate, $_ARRAYLANG;

		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/newsletter/template');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);

    	if(!isset($_REQUEST['standalone'])){

    		$objTemplate->setVariable("CONTENT_NAVIGATION", "
    										<a href='index.php?cmd=newsletter'>".$_ARRAYLANG['TXT_NEWSLETTER_ADMINISTRATION']."</a>
    										<a href='index.php?cmd=newsletter&amp;act=lists'>".$_ARRAYLANG['TXT_NEWSLETTER_LISTS']."</a>
    										<a href='index.php?cmd=newsletter&amp;act=mails'>".$_ARRAYLANG['TXT_NEWSLETTER_EMAILS']."</a>
    										<a href='index.php?cmd=newsletter&amp;act=templates'>".$_ARRAYLANG['TXT_NEWSLETTER_TEMPLATES']."</a>
    										<a href='index.php?cmd=newsletter&amp;act=users'>".$_ARRAYLANG['TXT_NEWSLETTER_RECIPIENTS']."</a>
    										<a href='index.php?cmd=newsletter&amp;act=news'>".$_ARRAYLANG['TXT_NEWSLETTER_NEWS']."</a>
    										<a href='index.php?cmd=newsletter&amp;act=dispatch'>".$_ARRAYLANG['TXT_SETTINGS']."</a>");
		}
	}

	/**
	* Set the backend page
	*
	* @access public
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/

	function getPage() {
		global $objTemplate, $_ARRAYLANG;

		if (!isset($_GET['act'])) {
			$_GET['act'] = '';
		}

		switch ($_GET['act']){
			case "lists":
				$this->_lists();
				break;
				
			case "editlist":
				$this->_editList();
				break;
				
			case "changeListStatus":
				$this->_changeListStatus();
				$this->_lists();
				break;
				
			case "deleteList":
				$this->_deleteList();
				$this->_lists();
				break;
				
			case "gethtml":
				$this->_getHTML();
				break;
				
			case "mails":
				$this->_mails();
				break;

			case "deleteMail":
				$this->_deleteMail();
				break;
				
			case "copyMail":
				$this->_copyMail();
				break;
				
			case "editMail":
				$this->_editMail();
				break;
				
			case "showMail":
				$this->_showMail();
				break;
				
			case "sendMail":
				$this->_sendMailPage();
				break;
				
			case "send":
				$this->_sendMail();
				break;
				
			case "newsletter":
				$this->newsletterOverview();
				break;
				
			case "news":
				$this->_getNewsPage();
				break;
				
			case "users":
				$this->_users();
				break;
				
			case "config":
				$this->configOverview();
				break;
			//case "adduser":
			//	$this->adduser();
			//	break;
			//case "edituser":
			//	$this->edituser();
			//	break;
			//case "detailuser":
			//	$this->detailuser();
			//	break;
			//case "updateuser":
			//	$this->updateuser();
			//	break;
			//case "importuser":
			//	$this->importuser();
			//	break;
			//case "exportuser":
			//	$this->exportuser();
			//	break;
			case "editusersort":
				$this->edituserSort();
    			break;
			case "newslettersend":
				$this->newslettersend();
				break;
			case "dispatch":
				$this->ConfigDispatch();
				break;
			case "confightml":
				$this->ConfigHTML();
				break;
			case "templates":
				$this->_templates();
				break;
			case "tpledit":
				$this->_editTemplate();
				break;

			case "tpldel":
				$this->delTemplate();
				$this->_templates();
				break;
			case "confirmmail":
				$this->ConfirmMail();
				break;
			case "activatemail":
				$this->ActivateMail();
				break;
			case "update":
				$this->_update();
				break;
			default:
				$this->overview();
			break;
		}

		if (!isset($_REQUEST['standalone'])) {
			$objTemplate->setVariable(array(
				'CONTENT_TITLE'				=> $this->_pageTitle,
				'CONTENT_OK_MESSAGE'		=> $this->_strOkMessage,
				'CONTENT_STATUS_MESSAGE'	=> $this->_strErrMessage,
				'ADMIN_CONTENT'				=> $this->_objTpl->get()
			));
		}else{
			$this->_objTpl->show();
			exit;
		}
	}
	
	
	/**
	 * Lists
	 *
	 * Display the list administration page
	 *
	 * @access private
	 * @global array $_ARRAYLANG
	 */
	function _lists()
	{
		global $_ARRAYLANG;

		$arrLists = &$this->_getLists();

		$this->_objTpl->loadTemplateFile('module_newsletter_lists.html');
		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_LISTS'];
		$rowNr = 0;

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_CONFIRM_DELETE_LIST'		=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRM_DELETE_LIST'],
			'TXT_NEWSLETTER_CANNOT_UNDO_OPERATION'		=> $_ARRAYLANG['TXT_NEWSLETTER_CANNOT_UNDO_OPERATION'],
			'TXT_NEWSLETTER_LISTS'						=> $_ARRAYLANG['TXT_NEWSLETTER_LISTS'],
			'TXT_NEWSLETTER_ID_UC'						=> $_ARRAYLANG['TXT_NEWSLETTER_ID_UC'],
			'TXT_NEWSLETTER_STATUS'						=> $_ARRAYLANG['TXT_NEWSLETTER_STATUS'],
			'TXT_NEWSLETTER_NAME'						=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
			'TXT_NEWSLETTER_LAST_EMAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_LAST_EMAIL'],
			'TXT_NEWSLETTER_RECIPIENTS'					=> $_ARRAYLANG['TXT_NEWSLETTER_RECIPIENTS'],
			'TXT_NEWSLETTER_FUNCTIONS'					=> $_ARRAYLANG['TXT_NEWSLETTER_FUNCTIONS'],
			'TXT_NEWSLETTER_CONFIRM_CHANGE_LIST_STATUS'	=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRM_CHANGE_LIST_STATUS'],
			'TXT_NEWSLETTER_ADD_NEW_LIST'				=> $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_LIST']
		));

		$this->_objTpl->setGlobalVariable(array(
			'TXT_NEWSLETTER_MODIFY'						=> $_ARRAYLANG['TXT_NEWSLETTER_MODIFY'],
			'TXT_NEWSLETTER_DELETE'						=> $_ARRAYLANG['TXT_NEWSLETTER_DELETE'],
			'TXT_NEWSLETTER_GENERATE_HTML_SOURCE_CODE'	=> $_ARRAYLANG['TXT_NEWSLETTER_GENERATE_HTML_SOURCE_CODE'],
			'TXT_NEWSLETTER_SHOW_LAST_SENT_EMAIL'		=> $_ARRAYLANG['TXT_NEWSLETTER_SHOW_LAST_SENT_EMAIL'],
			'TXT_NEWSLETTER_CREATE_NEW_EMAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_CREATE_NEW_EMAIL']
		));

		foreach ($arrLists as $id => $arrList) {
			$this->_objTpl->setVariable(array(
				'NEWSLETTER_LIST_ID'			=> $id,
				'NEWSLETTER_ROW_CLASS'			=> $rowNr % 2 == 1 ? "row1" : "row2",
				'NEWSLETTER_LIST_STATUS_IMG'	=> $arrList['status'] == 1 ? "folder_on.gif" : "folder_off.gif",
				'NEWSLETTER_LIST_NAME'			=> htmlentities($arrList['name'], ENT_QUOTES),
				'NEWSLETTER_LAST_MAIL_ID'		=> $arrList['mail_id'],
				'NEWSLETTER_LIST_RECIPIENT'		=> $arrList['recipients'] > 0 ? '<a href="index.php?cmd=newsletter&amp;act=users&amp;newsletterListId='.$id.'" title="'.sprintf($_ARRAYLANG['TXT_NEWSLETTER_SHOW_RECIPIENTS_OF_LIST'], $arrList['name']).'">'.$arrList['recipients'].'</a>' : '-',
				'NEWSLETTER_LIST_STATUS_MSG'	=> $arrList['status'] == 1 ? $_ARRAYLANG['TXT_NEWSLETTER_VISIBLE_STATUS_TXT'] : $_ARRAYLANG['TXT_NEWSLETTER_INVISIBLE_STATUS_TXT']
			));

			if ($arrList['mail_sent'] > 0) {
				$this->_objTpl->setVariable('NEWSLETTER_LIST_LAST_MAIL', date(ASCMS_DATE_SHORT_FORMAT, $arrList['mail_sent'])." (".htmlentities($arrList['mail_name'], ENT_QUOTES).")");
				$this->_objTpl->touchBlock('newsletter_list_last_mail');
				$this->_objTpl->hideBlock('newsletter_list_no_last_mail');
			} else {
				$this->_objTpl->hideBlock('newsletter_list_last_mail');
				$this->_objTpl->touchBlock('newsletter_list_no_last_mail');
			}

			$this->_objTpl->parse('newsletter_lists');
			$rowNr++;
		}
	}

	function _deleteList()
	{
		global $objDatabase, $_ARRAYLANG;
$objDatabase->debug=true;
		$listId = isset($_GET['id']) ? intval($_GET['id']) : 0;
		if ($listId > 0) {
			if (($arrList = &$this->_getList($listId)) !== false) {
				$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_cat_news WHERE category=".$listId);
				$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_user_cat WHERE category=".$listId);

				if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_category WHERE id=".$listId) !== false) {
					$this->_strOkMessage .= sprintf($_ARRAYLANG['TXT_NEWSLETTER_LIST_SUCCESSFULLY_DELETED'], $arrList['name']);
				} else {
					$this->_strErrMessage .= sprintf($_ARRAYLANG['TXT_NEWSLETTER_COULD_NOT_DELETE_LIST'], $arrList['name']);
				}
			}
		}
	}

	function _getLists($orderBy = '')
	{
		global $objDatabase;

		if (!isset($arrLists)) {
			$arrLists = array();
			$objList = $objDatabase->Execute("SELECT tblCategory.id,
				tblCategory.status,
				tblCategory.name,
				COUNT(tblRel.id) as recipients
				FROM ".DBPREFIX."module_newsletter_category AS tblCategory
				LEFT JOIN ".DBPREFIX."module_newsletter_rel_user_cat AS tblRel ON tblRel.category = tblCategory.id
				GROUP BY tblCategory.id".(!empty($orderBy) ? " ORDER BY ".$orderBy : ""));
			if ($objList !== false) {
				while (!$objList->EOF) {
					$objMail = $objDatabase->SelectLimit("	SELECT tblNewsletter.id, tblNewsletter.subject, tblNewsletter.date_sent
					                                      	FROM ".DBPREFIX."module_newsletter AS tblNewsletter
					                                      	LEFT JOIN ".DBPREFIX."module_newsletter_rel_cat_news AS tblRel
					                                      	ON tblRel.newsletter = tblNewsletter.id
					                                        WHERE tblRel.category=".$objList->fields['id']."
					                                        ORDER BY date_sent DESC", 1);

					if ($objMail !== false && $objMail->RecordCount() == 1) {
						$mailId = $objMail->fields['id'];
						$mailSend = $objMail->fields['date_sent'];
						$mailName = $objMail->fields['subject'];
					} else {
						$mailId = 0;
						$mailSend = 0;
						$mailName = '';
					}

					$arrLists[$objList->fields['id']] = array(
						'status'		=> $objList->fields['status'],
						'name'			=> $objList->fields['name'],
						'recipients'	=> $objList->fields['recipients'],
						'mail_sent'		=> $mailSend,
						'mail_name'		=> $mailName,
						'mail_id'		=> $mailSend > 0 ? $mailId : 0
					);
					$objList->MoveNext();
				}
			}
		}

		return $arrLists;
	}

	function _getList($listId)
	{
		global $objDatabase;

		$objList = $objDatabase->SelectLimit("SELECT `status`, `name` FROM ".DBPREFIX."module_newsletter_category WHERE id=".$listId, 1);
		if ($objList !== false && $objList->RecordCount() == 1) {
			return array(
				'status'	=> $objList->fields['status'],
				'name'		=> $objList->fields['name']
			);
		} else {
			return false;
		}
	}

	function _changeListStatus()
	{
		global $objDatabase;

		$listId = isset($_GET['id']) ? intval($_GET['id']) : 0;
		if ($listId > 0) {
			if (($arrList = &$this->_getList($listId)) !== false) {
				$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_category SET `status`=".($arrList['status'] == 1 ? "0" : "1")." WHERE id=".$listId);
			}
		}
	}

	function _editList()
	{
		global $_ARRAYLANG;

		$listId = isset($_REQUEST['id']) ? intval($_REQUEST['id']) : 0;

		if (isset($_POST['back'])) {
			return $this->_lists();
		} elseif (isset($_POST['save'])) {
			$listName = isset($_POST['newsletter_list_name']) ? contrexx_addslashes($_POST['newsletter_list_name']) : '';
			$listStatus = (isset($_POST['newsletter_list_status']) && intval($_POST['newsletter_list_status']) == '1') ? intval($_POST['newsletter_list_status']) : 0;

			if (!empty($listName)) {
				if ($this->_checkUniqueListName($listId, $listName) !== false) {
					if ($listId == 0) {
						if ($this->_addList($listName, $listStatus) !== false) {
							$this->_strOkMessage .= sprintf($_ARRAYLANG['TXT_NEWSLETTER_LIST_SUCCESSFULLY_CREATED'], $listName);
							return $this->_lists();
						} else {
							$this->_strErrMessage .= sprintf($_ARRAYLANG['TXT_NEWSLETTER_COULD_NOT_CREATE_LIST'], $listName);
						}
					} else {
						if ($this->_updateList($listId, $listName, $listStatus) !== false) {
							$this->_strOkMessage .= sprintf($_ARRAYLANG['TXT_NEWSLETTER_LIST_SUCCESSFULLY_UPDATED'], $listName);
							return $this->_lists();
						} else {
							$this->_strErrMessage .= sprintf($_ARRAYLANG['TXT_NEWSLETTER_COULD_NOT_UPDATE_LIST'], $listName);
						}
					}
				} else {
					$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_DUPLICATE_LIST_NAME_MSG'];
				}
			} else {
				$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_DEFINE_LIST_NAME_MSG'];
			}
		} elseif ($listId > 0 && ($arrList = &$this->_getList($listId)) !== false) {
			$listName = $arrList['name'];
			$listStatus = $arrList['status'];
		} else {
			$listName = isset($_POST['newsletter_list_name']) ? contrexx_addslashes($_POST['newsletter_list_name']) : '';
			$listStatus = (isset($_POST['newsletter_list_status']) && intval($_POST['newsletter_list_status']) == '1') ? intval($_POST['newsletter_list_status']) : 0;
		}

		$this->_objTpl->loadTemplateFile('module_newsletter_list_edit.html');
		$this->_pageTitle = $listId > 0 ? $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_LIST'] : $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_LIST'];

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_NAME'		=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
			'TXT_NEWSLETTER_STATUS'		=> $_ARRAYLANG['TXT_NEWSLETTER_STATUS'],
			'TXT_NEWSLETTER_VISIBLE'	=> $_ARRAYLANG['TXT_NEWSLETTER_VISIBLE'],
			'TXT_NEWSLETTER_BACK'		=> $_ARRAYLANG['TXT_NEWSLETTER_BACK'],
			'TXT_NEWSLETTER_SAVE'		=> $_ARRAYLANG['TXT_NEWSLETTER_SAVE'],

		));

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_LIST_TITLE'		=> $listId > 0 ? $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_LIST'] : $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_LIST'],
			'NEWSLETTER_LIST_ID'		=> $listId,
			'NEWSLETTER_LIST_NAME'		=> htmlentities($listName, ENT_QUOTES),
			'NEWSLETTER_LIST_STATUS'	=> $listStatus == 1 ? 'checked="checked"' : ''
		));
	}



	function _updateList(&$listId, &$listName, &$listStatus)
	{
		global $objDatabase;

		if ($objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_category SET `name`='".$listName."', `status`=".$listStatus." WHERE id=".$listId) !== false) {
			return true;
		} else {
			return false;
		}
	}



	function _addList($listName, $listStatus)
	{
		global $objDatabase;

		if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_category (`name`, `status`) VALUES ('".$listName."', ".$listStatus.")") !== false) {
			return true;
		} else {
			return false;
		}
	}

	function _editMail($copy = false)
	{
		global $objDatabase, $_ARRAYLANG;

		if (isset($_POST['newsletter_mail_back'])) {
			return $this->_mails();
		}

		$mailId = isset($_REQUEST['id']) ? intval($_REQUEST['id']) : 0;
		$arrAttachment = array();
		$attachmentNr = 0;
		$arrAssociatedLists = array();
		$status = true;

		$mailSubject = isset($_POST['newsletter_mail_subject']) ? htmlentities($_POST['newsletter_mail_subject'], ENT_QUOTES) : '';

		$arrTemplates = $this->_getTemplates();
		$mailTemplate = isset($_POST['newsletter_mail_template']) ? intval($_POST['newsletter_mail_template']) : key($arrTemplates);

		if (isset($_POST['newsletter_mail_html_content'])) {
			$mailHtmlContent = preg_replace('/\[\[([A-Z0-9_]*?)\]\]/', '{\\1}' , $_POST['newsletter_mail_html_content']);
			$mailHtmlContent = $this->_getBodyContent($mailHtmlContent);
		} else {
			$mailHtmlContent = '';
		}
		if (isset($_POST['newsletter_mail_text_content'])) {
			$mailTextContent = preg_replace('/\[\[([A-Z0-9_]*?)\]\]/', '{\\1}' , $_POST['newsletter_mail_text_content']);
			$mailTextContent = $this->_getBodyContent($mailTextContent);
		} else {
			$mailTextContent = '';
		}
		if (isset($_POST['newsletter_mail_attachment']) && is_array($_POST['newsletter_mail_attachment'])) {
			foreach ($_POST['newsletter_mail_attachment'] as $attachment) {
				array_push($arrAttachment, contrexx_addslashes($attachment));
			}
		}

		$mailFormat = isset($_POST['newsletter_mail_format']) ? $_POST['newsletter_mail_format'] : $this->_stdMailFormat;

		if (isset($_POST['newsletter_mail_priority'])) {
			$mailPriority = intval($_POST['newsletter_mail_priority']);
			if ($mailPriority < 1 || $mailPriority > 5) {
				$mailPriority = $this->_stdMailPriority;
			}
		} else {
			$mailPriority = $this->_stdMailPriority;
		}

		if (isset($_POST['newsletter_mail_associated_list'])) {
			foreach ($_POST['newsletter_mail_associated_list'] as $listId => $status) {
				if (intval($status) == 1) {
					array_push($arrAssociatedLists, intval($listId));
				}
			}
		}

		$arrSettings = $this->_getSettings();
		$mailSenderMail = isset($_POST['newsletter_mail_sender_mail']) ? $_POST['newsletter_mail_sender_mail'] : $arrSettings['sender_mail']['setvalue'];
		$mailSenderName = isset($_POST['newsletter_mail_sender_name']) ? $_POST['newsletter_mail_sender_name'] : $arrSettings['sender_name']['setvalue'];
		$mailReply = isset($_POST['newsletter_mail_sender_reply']) ? $_POST['newsletter_mail_sender_reply'] : $arrSettings['reply_mail']['setvalue'];


		$this->_objTpl->loadTemplateFile('module_newsletter_mail_edit.html');
		$this->_pageTitle = $mailId > 0 ? ($copy ? $_ARRAYLANG['TXT_NEWSLETTER_COPY_EMAIL'] : $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_EMAIL']) : $_ARRAYLANG['TXT_NEWSLETTER_CREATE_NEW_EMAIL'];

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MAIL_EDIT_TITLE'	=> $mailId > 0 ? ($copy ? $_ARRAYLANG['TXT_NEWSLETTER_COPY_EMAIL'] : $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_EMAIL']) : $_ARRAYLANG['TXT_NEWSLETTER_CREATE_NEW_EMAIL']
		));

		if (isset($_POST['newsletter_mail_save'])) {
			$objAttachment = $objDatabase->Execute("SELECT file_name FROM ".DBPREFIX."module_newsletter_attachment WHERE newsletter=".$mailId);
			if ($objAttachment !== false) {
				$arrCurrentAttachments = array();
				while (!$objAttachment->EOF) {
					array_push($arrCurrentAttachments, ASCMS_NEWSLETTER_ATTACH_WEB_PATH.'/'.$objAttachment->fields['file_name']);
					$objAttachment->MoveNext();
				}

				$arrNewAttachments = array_diff($arrAttachment, $arrCurrentAttachments);
				$arrRemovedAttachments = array_diff($arrCurrentAttachments, $arrAttachment);
			}

			if ($mailId > 0) {
				$status = $this->_updateMail($mailId, $mailSubject, $mailFormat, $mailTemplate, $mailSenderMail, $mailSenderName, $mailReply, $mailPriority, $arrAttachment, $mailHtmlContent, $mailTextContent);
			} else {
				$mailId = $this->_addMail($mailSubject, $mailFormat, $mailTemplate, $mailSenderMail, $mailSenderName, $mailReply, $mailPriority, $arrAttachment, $mailHtmlContent, $mailTextContent);
				if ($mailId === false) {
					$status = false;
				}
			}

			if ($status) {
				$this->_setMailLists($mailId, $arrAssociatedLists);

				foreach ($arrNewAttachments as $attachment) {
					$this->_addMailAttachment($attachment, $mailId);
				}

				foreach ($arrRemovedAttachments as $attachment) {
					$this->_removeMailAttachment($attachment, $mailId);
				}

				$this->_strOkMessage .= "Das E-Mail wurde erfolgreich gespeichert!";

				if (isset($_GET['sendMail']) && $_GET['sendMail'] == '1') {
					return $this->_sendMailPage();
				} else {
					return $this->_mails();
				}
			}
		} elseif ((!isset($_GET['setFormat']) || $_GET['setFormat'] != '1') && $mailId > 0) {
			$objMail = $objDatabase->SelectLimit("SELECT
				subject,
				template,
				content,
				content_text,
				attachment,
				format,
				priority,
				sender_email,
				sender_name,
				return_path
				FROM ".DBPREFIX."module_newsletter
				WHERE id=".$mailId, 1);
			if ($objMail !== false) {
				if ($objMail->RecordCount() == 1) {
					$mailSubject = $objMail->fields['subject'];
					$mailTemplate = $objMail->fields['template'];
					$mailHtmlContent = $objMail->fields['content'];
					$mailTextContent = $objMail->fields['content_text'];
					$mailFormat = $objMail->fields['format'];
					$mailPriority = $objMail->fields['priority'];
					$mailSenderMail = $objMail->fields['sender_email'];
					$mailSenderName = $objMail->fields['sender_name'];
					$mailReply = $objMail->fields['return_path'];

					$objList = $objDatabase->Execute("SELECT category FROM ".DBPREFIX."module_newsletter_rel_cat_news WHERE newsletter=".$mailId);
					if ($objList !== false) {
						while (!$objList->EOF) {
							array_push($arrAssociatedLists, $objList->fields['category']);
							$objList->MoveNext();
						}

					}

					if ($objMail->fields['attachment'] == '1') {
						$objAttachment = $objDatabase->Execute("SELECT file_name FROM ".DBPREFIX."module_newsletter_attachment WHERE newsletter=".$mailId);
						if ($objAttachment !== false) {
							while (!$objAttachment->EOF) {
								array_push($arrAttachment, ASCMS_NEWSLETTER_ATTACH_WEB_PATH.'/'.$objAttachment->fields['file_name']);
								$objAttachment->MoveNext();
							}
						}
					}
				} else {
					return $this->_mails();
				}
			}
		} else {
			$arrSettings = $this->_getSettings();

			$mailSenderMail = $arrSettings['sender_mail']['setvalue'];
			$mailSenderName = $arrSettings['sender_name']['setvalue'];
			$mailReply = $arrSettings['reply_mail']['setvalue'];

			if (!empty($_POST['textfield'])) {
				$mailHtmlContent =  nl2br($_POST['textfield']);
				$mailTextContent =  $_POST['textfield'];
			}
		}

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MAIL_ID'					=> $copy ? 0 : $mailId,
			'NEWSLETTER_MAIL_SUBJECT'				=> htmlentities($mailSubject, ENT_QUOTES),
			'NEWSLETTER_MAIL_HTML_CONTENT'			=> $mailFormat != 'text' ? str_replace('[[content]]', get_wysiwyg_editor('newsletter_mail_html_content', $mailHtmlContent), nl2br(htmlentities($arrTemplates[$mailTemplate]['html'], ENT_QUOTES))) : '<input type="hidden" name="newsletter_mail_html_content" value="'.htmlentities($mailHtmlContent, ENT_QUOTES).'" />',
			'NEWSLETTER_MAIL_TEXT_CONTENT'			=> str_replace('[[content]]', '<textarea name="newsletter_mail_text_content" style="width: 100%; height: 447px;">'.htmlentities($mailTextContent, ENT_QUOTES).'</textarea>', nl2br(htmlentities($arrTemplates[$mailTemplate]['text'], ENT_QUOTES))),
			'NEWSLETTER_MAIL_HTML_CONTENT_STAUTS'	=> $mailFormat != 'text' ? 'block' : 'none',
			'NEWSLETTER_MAIL_TEXT_CONTENT_STAUTS'	=> $mailFormat == 'text' ? 'block' : 'none',
			'NEWSLETTER_MAIL_HTML_CONTENT_CLASS'	=> $mailFormat != 'text' ? 'active' : '',
			'NEWSLETTER_MAIL_TEXT_CONTENT_CLASS'	=> $mailFormat == 'text' ? 'active' : '',
			'NEWSLETTER_MAIL_FORMAT_MENU'			=> $this->_getMailFormatMenu($mailFormat, 'name="newsletter_mail_format" id="newsletter_mail_format" onchange="document.getElementById(\'newsletter_mail_form\').action=\'index.php?cmd=newsletter&amp;act=editMail&amp;id='.$mailId.'&amp;setFormat=1\';document.getElementById(\'newsletter_mail_form\').submit()" style="width:300px;"'),
			'NEWSLETTER_MAIL_PRIORITY_MENU'			=> $this->_getMailPriorityMenu($mailPriority, 'name="newsletter_mail_priority" style="width:300px;"'),
			'NEWSLETTER_MAIL_TEMPLATE_MENU'			=> $this->_getTemplateMenu($mailTemplate, 'name="newsletter_mail_template" style="width:300px;" onchange="document.getElementById(\'newsletter_mail_form\').action=\'index.php?cmd=newsletter&amp;act=editMail&amp;id='.$mailId.'&amp;setFormat=1\';document.getElementById(\'newsletter_mail_form\').submit()"'),
			'NEWSLETTER_MAIL_SENDER_MAIL'			=> htmlentities($mailSenderMail, ENT_QUOTES),
			'NEWSLETTER_MAIL_SENDER_NAME'			=> htmlentities($mailSenderName, ENT_QUOTES),
			'NEWSLETTER_MAIL_REPLY'					=> htmlentities($mailReply, ENT_QUOTES),
			'NEWSLETTER_MAIL_SEND'					=> $_GET['act'] == 'sendMail' ? 1 : 0
		));

		if ($mailFormat == 'text') {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_TEXT', $_ARRAYLANG['TXT_NEWSLETTER_TEXT']);
			$this->_objTpl->touchBlock('newsletter_mail_text_content');
			$this->_objTpl->hideBlock('newsletter_mail_html_content');
		} elseif ($mailFormat == 'html') {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_HTML_UC', $_ARRAYLANG['TXT_NEWSLETTER_HTML_UC']);
			$this->_objTpl->touchBlock('newsletter_mail_html_content');
			$this->_objTpl->hideBlock('newsletter_mail_text_content');
		} else {
			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_HTML_UC'	=> $_ARRAYLANG['TXT_NEWSLETTER_HTML_UC'],
				'TXT_NEWSLETTER_TEXT'		=> $_ARRAYLANG['TXT_NEWSLETTER_TEXT']
			));
			$this->_objTpl->touchBlock('newsletter_mail_html_content');
			$this->_objTpl->touchBlock('newsletter_mail_text_content');
		}

		$arrLists = &$this->_getLists('tblCategory.name');
		$listNr = 0;
		foreach ($arrLists as $listId => $arrList) {
			$column = $listNr % 3;
			$this->_objTpl->setVariable(array(
				'NEWSLETTER_LIST_ID'						=> $listId,
				'NEWSLETTER_LIST_NAME'						=> $arrList['name'],
				'NEWSLETTER_SHOW_RECIPIENTS_OF_LIST_TXT'	=> sprintf($_ARRAYLANG['TXT_NEWSLETTER_SHOW_RECIPIENTS_OF_LIST'], $arrList['name']),
				'NEWSLETTER_LIST_ASSOCIATED'				=> in_array($listId, $arrAssociatedLists) ? 'checked="checked"' : ''
			));
			$this->_objTpl->parse('newsletter_mail_associated_list_'.$column);

			$listNr++;
		}

		if (count($arrAttachment) > 0) {
			foreach ($arrAttachment as $attachment) {
				$this->_objTpl->setVariable(array(
					'NEWSLETTER_MAIL_ATTACHMENT_NR'		=> $attachmentNr,
					'NEWSLETTER_MAIL_ATTACHMENT_NAME'	=> substr($attachment, strrpos($attachment, '/')+1),
					'NEWSLETTER_MAIL_ATTACHMENT_URL'	=> $attachment
				));
				$this->_objTpl->parse('newsletter_mail_attachment_list');
				$attachmentNr++;
			}
		} else {
			$this->_objTpl->hideBlock('newsletter_mail_attachment_list');
		}

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MAIL_ATTACHMENT_NR'	=> $attachmentNr,
			'NEWSLETTER_MAIL_ATTACHMENT_BOX'	=> $attachmentNr > 0 ? 'block' : 'none'
		));

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_SUBJECT'				=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'TXT_NEWSLETTER_SEND_AS'				=> $_ARRAYLANG['TXT_NEWSLETTER_SEND_AS'],
			'TXT_NEWSLETTER_TEMPLATE'				=> $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE'],
			'TXT_NEWSLETTER_SENDER'					=> $_ARRAYLANG['TXT_NEWSLETTER_SENDER'],
			'TXT_NEWSLETTER_EMAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL'],
			'TXT_NEWSLETTER_NAME'					=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
			'TXT_NEWSLETTER_REPLY_ADDRESS'			=> $_ARRAYLANG['TXT_NEWSLETTER_REPLY_ADDRESS'],
			'TXT_NEWSLETTER_PRIORITY'				=> $_ARRAYLANG['TXT_NEWSLETTER_PRIORITY'],
			'TXT_NEWSLETTER_PRIORITY'				=> $_ARRAYLANG['TXT_NEWSLETTER_PRIORITY'],
			'TXT_NEWSLETTER_ASSOCIATED_LISTS'		=> $_ARRAYLANG['TXT_NEWSLETTER_ASSOCIATED_LISTS'],
			'TXT_NEWSLETTER_ATTACH'					=> $_ARRAYLANG['TXT_NEWSLETTER_ATTACH'],
			'TXT_NEWSLETTER_DISPLAY_FILE'			=> $_ARRAYLANG['TXT_NEWSLETTER_DISPLAY_FILE'],
			'TXT_NEWSLETTER_REMOVE_FILE'			=> $_ARRAYLANG['TXT_NEWSLETTER_REMOVE_FILE'],
			'TXT_NEWSLETTER_ATTACH_FILE'			=> $_ARRAYLANG['TXT_NEWSLETTER_ATTACH_FILE'],
			'TXT_NEWSLETTER_HTML_CONTENT'			=> $_ARRAYLANG['TXT_NEWSLETTER_HTML_CONTENT'],
			'TXT_NEWSLETTER_TEXT_CONTENT'			=> $_ARRAYLANG['TXT_NEWSLETTER_TEXT_CONTENT'],
			'TXT_NEWSLETTER_PLACEHOLDER_DIRECTORY'	=> $_ARRAYLANG['TXT_NEWSLETTER_PLACEHOLDER_DIRECTORY'],
			'TXT_NEWSLETTER_USER_DATA'				=> $_ARRAYLANG['TXT_NEWSLETTER_USER_DATA'],
			'TXT_NEWSLETTER_EMAIL_ADDRESS'			=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_TITLE'					=> $_ARRAYLANG['TXT_NEWSLETTER_TITLE'],
			'TXT_NEWSLETTER_LASTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_LASTNAME'],
			'TXT_NEWSLETTER_FIRSTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
			'TXT_NEWSLETTER_STREET'					=> $_ARRAYLANG['TXT_NEWSLETTER_STREET'],
			'TXT_NEWSLETTER_ZIP'					=> $_ARRAYLANG['TXT_NEWSLETTER_ZIP'],
			'TXT_NEWSLETTER_CITY'					=> $_ARRAYLANG['TXT_NEWSLETTER_CITY'],
			'TXT_NEWSLETTER_COUNTRY'				=> $_ARRAYLANG['TXT_NEWSLETTER_COUNTRY'],
			'TXT_NEWSLETTER_PHONE'					=> $_ARRAYLANG['TXT_NEWSLETTER_PHONE'],
			'TXT_NEWSLETTER_BIRTHDAY'				=> $_ARRAYLANG['TXT_NEWSLETTER_BIRTHDAY'],
			'TXT_NEWSLETTER_GENERAL'				=> $_ARRAYLANG['TXT_NEWSLETTER_GENERAL'],
			'TXT_NEWSLETTER_MODIFY_PROFILE'			=> $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_PROFILE'],
			'TXT_NEWSLETTER_UNSUBSCRIBE'			=> $_ARRAYLANG['TXT_NEWSLETTER_UNSUBSCRIBE'],
			'TXT_NEWSLETTER_DATE'					=> $_ARRAYLANG['TXT_NEWSLETTER_DATE'],
			'TXT_NEWSLETTER_SAVE'					=> $_ARRAYLANG['TXT_NEWSLETTER_SAVE'],
			'TXT_NEWSLETTER_BACK'					=> $_ARRAYLANG['TXT_NEWSLETTER_BACK']
		));
	}

	function _showMail()
	{
		global $objDatabase, $_ARRAYLANG;

		if (isset($_POST['newsletter_mail_back'])) {
			return $this->_mails();
		}

		$mailId = isset($_REQUEST['id']) ? intval($_REQUEST['id']) : 0;
		$mailSubject = '';
		$mailTemplate = '';
		$mailHtmlContent = '';
		$mailTextContent = '';
		$arrAttachment = array();
		$attachmentNr = 0;
		$mailFormat = $this->_stdMailFormat;
		$mailPriority = $this->_stdMailPriority;
		$mailSenderMail = '';
		$mailSenderName = '';
		$mailReply = '';
		$arrAssociatedLists = array();
		$status = true;


		$this->_objTpl->loadTemplateFile('module_newsletter_mail_show.html');
		$this->_pageTitle = 'E-Mail anzeigen';

		$objMail = $objDatabase->SelectLimit("SELECT
			subject,
			template,
			content,
			content_text,
			attachment,
			format,
			priority,
			sender_email,
			sender_name,
			return_path
			FROM ".DBPREFIX."module_newsletter
			WHERE id=".$mailId, 1);
		if ($objMail !== false) {
			if ($objMail->RecordCount() == 1) {
				$mailSubject = $objMail->fields['subject'];
				$mailTemplate = $objMail->fields['template'];
				$mailHtmlContent = $objMail->fields['content'];
				$mailTextContent = $objMail->fields['content_text'];
				$mailFormat = $objMail->fields['format'];
				$mailPriority = $objMail->fields['priority'];
				$mailSenderMail = $objMail->fields['sender_email'];
				$mailSenderName = $objMail->fields['sender_name'];
				$mailReply = $objMail->fields['return_path'];

				$objList = $objDatabase->Execute("SELECT category FROM ".DBPREFIX."module_newsletter_rel_cat_news WHERE newsletter=".$mailId);
				if ($objList !== false) {
					while (!$objList->EOF) {
						array_push($arrAssociatedLists, $objList->fields['category']);
						$objList->MoveNext();
					}

				}

				if ($objMail->fields['attachment'] == '1') {
					$objAttachment = $objDatabase->Execute("SELECT file_name FROM ".DBPREFIX."module_newsletter_attachment WHERE newsletter=".$mailId);
					if ($objAttachment !== false) {
						while (!$objAttachment->EOF) {
							array_push($arrAttachment, ASCMS_NEWSLETTER_ATTACH_WEB_PATH.'/'.$objAttachment->fields['file_name']);
							$objAttachment->MoveNext();
						}
					}
				}
			} else {
				return $this->_mails();
			}
		}

		$arrTemplates = &$this->_getTemplates();
		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MAIL_SUBJECT'		=> htmlentities($mailSubject, ENT_QUOTES),
			'NEWSLETTER_MAIL_HTML_CONTENT'	=> nl2br(htmlentities(str_replace('[[content]]', $mailHtmlContent, $arrTemplates[$mailTemplate]['html']), ENT_QUOTES)),
			'NEWSLETTER_MAIL_TEXT_CONTENT'	=> nl2br(htmlentities(str_replace('[[content]]', $mailTextContent, $arrTemplates[$mailTemplate]['text']), ENT_QUOTES)),
			'NEWSLETTER_MAIL_FORMAT'		=> $_ARRAYLANG[$this->_arrMailFormat[$mailFormat]],
			'NEWSLETTER_MAIL_PRIORITY'		=> $_ARRAYLANG[$this->_arrMailPriority[$mailPriority]],
			'NEWSLETTER_MAIL_TEMPLATE'		=> htmlentities($arrTemplates[$mailTemplate]['name'], ENT_QUOTES).' ('.htmlentities($arrTemplates[$mailTemplate]['description'], ENT_QUOTES).')',
			'NEWSLETTER_MAIL_SENDER_MAIL'	=> htmlentities($mailSenderMail, ENT_QUOTES),
			'NEWSLETTER_MAIL_SENDER_NAME'	=> htmlentities($mailSenderName, ENT_QUOTES),
			'NEWSLETTER_MAIL_REPLY'			=> htmlentities($mailReply, ENT_QUOTES),
			'NEWSLETTER_MAIL_HTML_CONTENT_STAUTS'	=> $mailFormat != 'text' ? 'block' : 'none',
			'NEWSLETTER_MAIL_TEXT_CONTENT_STAUTS'	=> $mailFormat == 'text' ? 'block' : 'none',
			'NEWSLETTER_MAIL_HTML_CONTENT_CLASS'	=> $mailFormat != 'text' ? 'active' : '',
			'NEWSLETTER_MAIL_TEXT_CONTENT_CLASS'	=> $mailFormat == 'text' ? 'active' : ''
		));

		if ($mailFormat == 'text') {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_TEXT', $_ARRAYLANG['TXT_NEWSLETTER_TEXT']);
			$this->_objTpl->touchBlock('newsletter_mail_text_content');
			$this->_objTpl->hideBlock('newsletter_mail_html_content');
		} elseif ($mailFormat == 'html') {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_HTML_UC', $_ARRAYLANG['TXT_NEWSLETTER_HTML_UC']);
			$this->_objTpl->touchBlock('newsletter_mail_html_content');
			$this->_objTpl->hideBlock('newsletter_mail_text_content');
		} else {
			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_HTML_UC'			=> $_ARRAYLANG['TXT_NEWSLETTER_HTML_UC'],
				'TXT_NEWSLETTER_TEXT'				=> $_ARRAYLANG['TXT_NEWSLETTER_TEXT']
			));
			$this->_objTpl->touchBlock('newsletter_mail_html_content');
			$this->_objTpl->touchBlock('newsletter_mail_text_content');
		}

		$arrLists = &$this->_getLists();
		$listNr = 0;
		foreach ($arrLists as $listId => $arrList) {
			if (in_array($listId, $arrAssociatedLists)) {
				$column = $listNr % 3;
				$this->_objTpl->setVariable(array(
					'NEWSLETTER_LIST_ID'	=> $listId,
					'NEWSLETTER_LIST_NAME'	=> $arrList['name'],
					'NEWSLETTER_SHOW_RECIPIENTS_OF_LIST_TXT'	=> sprintf($_ARRAYLANG['TXT_NEWSLETTER_SHOW_RECIPIENTS_OF_LIST'], $arrList['name'])
				));
				$this->_objTpl->parse('newsletter_mail_associated_list_'.$column);

				$listNr++;
			}
		}

		if (count($arrAttachment) > 0) {
			foreach ($arrAttachment as $attachment) {
				$this->_objTpl->setVariable(array(
					'NEWSLETTER_MAIL_ATTACHMENT_NAME'	=> substr($attachment, strrpos($attachment, '/')+1),
					'NEWSLETTER_MAIL_ATTACHMENT_URL'	=> $attachment
				));
				$this->_objTpl->parse('newsletter_mail_attachment_list');
			}
		} else {
			$this->_objTpl->hideBlock('newsletter_mail_attachment_list');
		}

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_DISPLAY_EMAIL'	=> $_ARRAYLANG['TXT_NEWSLETTER_DISPLAY_EMAIL'],
			'TXT_NEWSLETTER_SUBJECT'		=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'TXT_NEWSLETTER_SEND_AS'		=> $_ARRAYLANG['TXT_NEWSLETTER_SEND_AS'],
			'TXT_NEWSLETTER_TEMPLATE'		=> $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE'],
			'TXT_NEWSLETTER_SENDER'			=> $_ARRAYLANG['TXT_NEWSLETTER_SENDER'],
			'TXT_NEWSLETTER_EMAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL'],
			'TXT_NEWSLETTER_NAME'			=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
			'TXT_NEWSLETTER_REPLY_ADDRESS'	=> $_ARRAYLANG['TXT_NEWSLETTER_REPLY_ADDRESS'],
			'TXT_NEWSLETTER_PRIORITY'		=> $_ARRAYLANG['TXT_NEWSLETTER_PRIORITY'],
			'TXT_NEWSLETTER_ASSOCIATED_LISTS'	=> $_ARRAYLANG['TXT_NEWSLETTER_ASSOCIATED_LISTS'],
			'TXT_NEWSLETTER_HTML_CONTENT'		=> $_ARRAYLANG['TXT_NEWSLETTER_HTML_CONTENT'],
			'TXT_NEWSLETTER_Text_CONTENT'		=> $_ARRAYLANG['TXT_NEWSLETTER_Text_CONTENT'],
			'TXT_NEWSLETTER_PLACEHOLDER_DIRECTORY'	=> $_ARRAYLANG['TXT_NEWSLETTER_PLACEHOLDER_DIRECTORY'],
			'TXT_NEWSLETTER_USER_DATA'				=> $_ARRAYLANG['TXT_NEWSLETTER_USER_DATA'],
			'TXT_NEWSLETTER_EMAIL_ADDRESS'			=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_TITLE'					=> $_ARRAYLANG['TXT_NEWSLETTER_TITLE'],
			'TXT_NEWSLETTER_LASTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_LASTNAME'],
			'TXT_NEWSLETTER_FIRSTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
			'TXT_NEWSLETTER_STREET'					=> $_ARRAYLANG['TXT_NEWSLETTER_STREET'],
			'TXT_NEWSLETTER_ZIP'					=> $_ARRAYLANG['TXT_NEWSLETTER_ZIP'],
			'TXT_NEWSLETTER_CITY'					=> $_ARRAYLANG['TXT_NEWSLETTER_CITY'],
			'TXT_NEWSLETTER_COUNTRY'				=> $_ARRAYLANG['TXT_NEWSLETTER_COUNTRY'],
			'TXT_NEWSLETTER_PHONE'					=> $_ARRAYLANG['TXT_NEWSLETTER_PHONE'],
			'TXT_NEWSLETTER_BIRTHDAY'				=> $_ARRAYLANG['TXT_NEWSLETTER_BIRTHDAY'],
			'TXT_NEWSLETTER_GENERAL'				=> $_ARRAYLANG['TXT_NEWSLETTER_GENERAL'],
			'TXT_NEWSLETTER_MODIFY_PROFILE'			=> $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_PROFILE'],
			'TXT_NEWSLETTER_UNSUBSCRIBE'			=> $_ARRAYLANG['TXT_NEWSLETTER_UNSUBSCRIBE'],
			'TXT_NEWSLETTER_DATE'					=> $_ARRAYLANG['TXT_NEWSLETTER_DATE'],
			'TXT_NEWSLETTER_BACK'					=> $_ARRAYLANG['TXT_NEWSLETTER_BACK']
		));
	}

	function _recipientOverview($limit = 10)
	{
		global $objDatabase, $_ARRAYLANG;

		$rowNr = 0;

		$this->_objTpl->setVariable('TXT_NEWSLETTER_NEWEST_RECIPIENTS', $_ARRAYLANG['TXT_NEWSLETTER_NEWEST_RECIPIENTS']);
		$this->_objTpl->setGlobalVariable('TXT_NEWSLETTER_MODIFY_RECIPIENT', $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_RECIPIENT']);

		$objUser = $objDatabase->SelectLimit("SELECT id, email, title, lastname, firstname, street, zip, city, country, status, emaildate FROM ".DBPREFIX."module_newsletter_user ORDER BY emaildate DESC", $limit);
		if ($objUser !== false && $objUser->RecordCount() > 0) {
			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_STATUS'							=> $_ARRAYLANG['TXT_NEWSLETTER_STATUS'],
				'TXT_NEWSLETTER_EMAIL_ADDRESS'					=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'],
				'TXT_NEWSLETTER_LASTNAME'						=> $_ARRAYLANG['TXT_NEWSLETTER_LASTNAME'],
				'TXT_NEWSLETTER_FIRSTNAME'						=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
				'TXT_NEWSLETTER_STREET'							=> $_ARRAYLANG['TXT_NEWSLETTER_STREET'],
				'TXT_NEWSLETTER_ZIP'							=> $_ARRAYLANG['TXT_NEWSLETTER_ZIP'],
				'TXT_NEWSLETTER_CITY'							=> $_ARRAYLANG['TXT_NEWSLETTER_CITY'],
				'TXT_NEWSLETTER_COUNTRY'						=> $_ARRAYLANG['TXT_NEWSLETTER_COUNTRY'],
				'TXT_NEWSLETTER_REGISTRATION_DATE'				=> $_ARRAYLANG['TXT_NEWSLETTER_REGISTRATION_DATE'],
				'TXT_NEWSLETTER_GO_TO_RECIPIENT_ADMINISTRATION'	=> $_ARRAYLANG['TXT_NEWSLETTER_GO_TO_RECIPIENT_ADMINISTRATION']
			));


			while (!$objUser->EOF) {
				$this->_objTpl->setVariable(array(
					'NEWSLETTER_RECIPIENT_ROW_CLASS'			=> $rowNr % 2 == 1 ? 'row1' : 'row2',
					'NEWSLETTER_RECIPIENT_STATUS_IMG'			=> $objUser->fields['status'] == 1 ? 'led_green.gif' : 'led_red.gif',
					'NEWSLETTER_RECIPIENT_STATUS'				=> $objUser->fields['status'] == 1 ? 'Aktiv' : 'Pendent',
					'NEWSLETTER_RECIPIENT_ID'					=> $objUser->fields['id'],
					'NEWSLETTER_RECIPIENT_EMAIL'				=> htmlentities($objUser->fields['email'], ENT_QUOTES),
					'NEWSLETTER_RECIPIENT_LASTNAME'				=> !empty($objUser->fields['lastname']) ? htmlentities($objUser->fields['lastname'], ENT_QUOTES) : '-',
					'NEWSLETTER_RECIPIENT_FIRSTNAME'			=> !empty($objUser->fields['firstname']) ? htmlentities($objUser->fields['firstname'], ENT_QUOTES) : '-',
					'NEWSLETTER_RECIPIENT_STREET'				=> !empty($objUser->fields['street']) ? htmlentities($objUser->fields['street'], ENT_QUOTES) : '-',
					'NEWSLETTER_RECIPIENT_ZIP'					=> !empty($objUser->fields['zip']) ? htmlentities($objUser->fields['zip'], ENT_QUOTES) : '-',
					'NEWSLETTER_RECIPIENT_CITY'					=> !empty($objUser->fields['city']) ? htmlentities($objUser->fields['city'], ENT_QUOTES) : '-',
					'NEWSLETTER_RECIPIENT_COUNTRY'				=> !empty($objUser->fields['country']) ? htmlentities($objUser->fields['country'], ENT_QUOTES) : '-',
					'NEWSLETTER_RECIPIENT_REGISTRATION_DATE'	=> date(ASCMS_DATE_FORMAT, $objUser->fields['emaildate'])
				));

				$this->_objTpl->parse('newsletter_recipients');

				$rowNr++;
				$objUser->MoveNext();
			}

			$this->_objTpl->touchBlock('newsletter_recipients_list');
			$this->_objTpl->hideBlock('newsletter_recipients_no_data');
		} else {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_NO_RECIPIENTS_MSG', $_ARRAYLANG['TXT_NEWSLETTER_NO_RECIPIENTS_MSG']);

			$this->_objTpl->touchBlock('newsletter_recipients_no_data');
			$this->_objTpl->hideBlock('newsletter_recipients_list');
		}

	}
	

	function _update()
	{
		global $objDatabase;



		$objColumns = $objDatabase->MetaColumns(DBPREFIX."module_newsletter");

		if ($objColumns !== false) {
			if ($objColumns['DATE_CREATE']->type != 'int') {
				$query = "SELECT `id`, `date_create` FROM ".DBPREFIX."module_newsletter";
				$objNewsletter = $objDatabase->Execute($query);
				if ($objNewsletter !== false) {
					$arrNewsletter = array();
					while (!$objNewsletter->EOF) {
						$arrNewsletter[$objNewsletter->fields['id']] = $objNewsletter->fields['date_create'];
						$objNewsletter->MoveNext();
					}

					$query = "ALTER TABLE ".DBPREFIX."module_newsletter CHANGE `date_create` `date_create` INT( 14 ) UNSIGNED NOT NULL";
					if ($objDatabase->Execute($query) === false) {
						die('DB error: '.$query);
					}

					foreach ($arrNewsletter as $id => $dateCreate) {
						$date = mktime(0,0,0,intval(substr($dateCreate,5,2)),intval(substr($dateCreate,8,2)),intval(substr($dateCreate,0,4)));
						$query = "UPDATE ".DBPREFIX."module_newsletter SET `date_create`=".$date." WHERE `id`=".$id;
						if ($objDatabase->Execute($query) === false) {
							print "DB error: ".$query."<br />";
						}
					}
				}
			}

			if ($objColumns['DATE_SENT']->type != 'int') {
				$query = "SELECT `id`, `date_sent` FROM ".DBPREFIX."module_newsletter";
				$objNewsletter = $objDatabase->Execute($query);
				if ($objNewsletter !== false) {
					$arrNewsletter = array();
					while (!$objNewsletter->EOF) {
						$arrNewsletter[$objNewsletter->fields['id']] = $objNewsletter->fields['date_sent'];
						$objNewsletter->MoveNext();
					}

					$query = "ALTER TABLE ".DBPREFIX."module_newsletter CHANGE `date_sent` `date_sent` INT( 14 ) UNSIGNED NOT NULL";
					if ($objDatabase->Execute($query) === false) {
						die('DB error: '.$query);
					}

					foreach ($arrNewsletter as $id => $dateSent) {
						$date = mktime(0,0,0,intval(substr($dateSent,5,2)),intval(substr($dateSent,8,2)),intval(substr($dateSent,0,4)));
						$query = "UPDATE ".DBPREFIX."module_newsletter SET `date_sent`=".$date." WHERE `id`=".$id;
						if ($objDatabase->Execute($query) === false) {
							print "DB error: ".$query."<br />";
						}
					}
				}
			}
		}
	}




	function _mails()
	{
		global $objDatabase, $_ARRAYLANG, $_CONFIG;

		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_EMAILS'];
		$this->_objTpl->loadTemplateFile('module_newsletter_mails.html');
		$rowNr = 0;
		$pos = isset($_GET['pos']) ? intval($_GET['pos']) : 0;

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_SUBJECT'						=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'TXT_NEWSLETTER_EMAILS'							=> $_ARRAYLANG['TXT_NEWSLETTER_EMAILS'],
			'TXT_NEWSLETTER_SENT'							=> $_ARRAYLANG['TXT_NEWSLETTER_SENT'],
			'TXT_NEWSLETTER_SENDER'							=> $_ARRAYLANG['TXT_NEWSLETTER_SENDER'],
			'TXT_NEWSLETTER_FORMAT'							=> $_ARRAYLANG['TXT_NEWSLETTER_FORMAT'],
			'TXT_NEWSLETTER_TEMPLATE'						=> $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE'],
			'TXT_NEWSLETTER_DATE'							=> $_ARRAYLANG['TXT_NEWSLETTER_DATE'],
			'TXT_NEWSLETTER_FUNCTIONS'						=> $_ARRAYLANG['TXT_NEWSLETTER_FUNCTIONS'],
			'TXT_NEWSLETTER_CHECK_ALL'						=> $_ARRAYLANG['TXT_NEWSLETTER_CHECK_ALL'],
			'TXT_NEWSLETTER_UNCHECK_ALL'					=> $_ARRAYLANG['TXT_NEWSLETTER_UNCHECK_ALL'],
			'TXT_NEWSLETTER_WITH_SELECTED'					=> $_ARRAYLANG['TXT_NEWSLETTER_WITH_SELECTED'],
			'TXT_NEWSLETTER_DELETE'							=> $_ARRAYLANG['TXT_NEWSLETTER_DELETE'],
			'TXT_NEWSLETTER_CREATE_NEW_EMAIL'				=> $_ARRAYLANG['TXT_NEWSLETTER_CREATE_NEW_EMAIL'],
			'TXT_NEWSLETTER_CONFIRM_DELETE_MAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRM_DELETE_MAIL'],
			'TXT_NEWSLETTER_CANNOT_UNDO_OPERATION'			=> $_ARRAYLANG['TXT_NEWSLETTER_CANNOT_UNDO_OPERATION'],
			'TXT_NEWSLETTER_CONFIRM_DELETE_CHECKED_EMAILS'	=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRM_DELETE_CHECKED_EMAILS']
		));

		$this->_objTpl->setGlobalVariable(array(
			'TXT_NEWSLETTER_SEND_EMAIL'						=> $_ARRAYLANG['TXT_NEWSLETTER_SEND_EMAIL'],
			'TXT_NEWSLETTER_MODIFY_EMAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_EMAIL'],
			'TXT_NEWSLETTER_DISPLAY_EMAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_DISPLAY_EMAIL'],
			'TXT_NEWSLETTER_COPY_EMAIL'						=> $_ARRAYLANG['TXT_NEWSLETTER_COPY_EMAIL'],
			'TXT_NEWSLETTER_DELETE_EMAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_DELETE_EMAIL']
		));

		$objMailCount = $objDatabase->SelectLimit("SELECT COUNT(1) AS mail_count FROM ".DBPREFIX."module_newsletter", 1);
		if ($objMailCount !== false) {
			$mailCount = $objMailCount->fields['mail_count'];
		} else {
			$mailCount = 0;
		}

		if ($mailCount > $_CONFIG['corePagingLimit']) {
			$paging = getPaging($mailCount, $pos, "&amp;cmd=newsletter&amp;act=mails", "", false, $_CONFIG['corePagingLimit']);
		}

		$arrTemplates = &$this->_getTemplates();

		$objMail = $objDatabase->SelectLimit("SELECT
			tblMail.id,
			tblMail.subject,
			tblMail.format,
			tblMail.date_create,
			tblMail.sender_email,
			tblMail.sender_name,
			tblMail.template,
			tblMail.status,
			tblMail.`count`,
			tblMail.date_sent
			FROM ".DBPREFIX."module_newsletter AS tblMail
			ORDER BY status, id DESC", $_CONFIG['corePagingLimit'], $pos);
		if ($objMail !== false) {
			while (!$objMail->EOF) {
				$this->_objTpl->setVariable(array(
					'NEWSLETTER_MAIL_ROW_CLASS'		=> $rowNr % 2 == 1 ? 'row1' : 'row2',
	                'NEWSLETTER_MAIL_SUBJECT'		=> htmlentities($objMail->fields['subject'], ENT_QUOTES),
	                'NEWSLETTER_MAIL_SENDER_NAME'	=> htmlentities($objMail->fields['sender_name'], ENT_QUOTES),
	                'NEWSLETTER_MAIL_SENDER_EMAIL'	=> htmlentities($objMail->fields['sender_email'], ENT_QUOTES),
	                'NEWSLETTER_MAIL_SENT_DATE'		=> $objMail->fields['date_sent'] > 0 ? date(ASCMS_DATE_FORMAT, $objMail->fields['date_sent']) : '-',
	                'NEWSLETTER_MAIL_FORMAT'		=> $objMail->fields['format'],
	                'NEWSLETTER_MAIL_TEMPLATE'		=> htmlentities($arrTemplates[$objMail->fields['template']]['name'], ENT_QUOTES),
	                'NEWSLETTER_MAIL_DATE'			=> date(ASCMS_DATE_FORMAT, $objMail->fields['date_create']),
	                'NEWSLETTER_MAIL_COUNT'			=> $objMail->fields['count'],
					'NEWSLETTER_MAIL_USERS'			=> $this->_getMailRecipientCount($objMail->fields['id'])
				));

				$this->_objTpl->setGlobalVariable('NEWSLETTER_MAIL_ID', $objMail->fields['id']);

				if ($objMail->fields['date_sent'] > 0) {
					$this->_objTpl->touchBlock('newsletter_mail_show');
					$this->_objTpl->hideBlock('newsletter_mail_edit');
				} else {
					$this->_objTpl->touchBlock('newsletter_mail_edit');
					$this->_objTpl->hideBlock('newsletter_mail_show');
				}

				$this->_objTpl->parse("newsletter_list");
				$objMail->MoveNext();
				$rowNr++;
			}
			if ($rowNr > 0) {
				$this->_objTpl->touchBlock("newsletter_list_multiAction");

				$this->_objTpl->setVariable('NEWSLETTER_MAILS_PAGING', "<br />".$paging."<br />");
			} else {
				$this->_objTpl->hideBlock("newsletter_list_multiAction");
			}
		}
	}
	
	function _deleteMail()
	{
		global $objDatabase, $_ARRAYLANG;

		$status = true;
		$arrMailIds = array();
		if (isset($_GET['id'])) {
			array_push($arrMailIds, intval($_GET['id']));
		} elseif (isset($_POST['newsletter_mail_selected'])) {
			foreach ($_POST['newsletter_mail_selected'] as $mailId) {
				array_push($arrMailIds, intval($mailId));
			}
		}

		if (count($arrMailIds) > 0) {
			foreach ($arrMailIds as $mailId) {
				if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_attachment where newsletter=".$mailId) !== false &&
					$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_cat_news where newsletter=".$mailId) !== false &&
					$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_tmp_sending where newsletter=".$mailId) !== false &&
					$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter where id=".$mailId)) {
				} else {
					$status = false;
				}
			}

			if ($status) {
				$this->_strOkMessage = count($arrMailIds) > 1 ? $_ARRAYLANG['TXT_NEWSLETTER_EMAILS_DELETED'] : $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_DELETED'];
			} else {
				$this->_strErrMessage = count($arrMailIds) > 1 ? $_ARRAYLANG['TXT_NEWSLETTER_ERROR_DELETE_EMAILS'] : $_ARRAYLANG['TXT_NEWSLETTER_ERROR_DELETE_EMAIL'];
			}
		}
		$this->_mails();
	}


	function _copyMail()
	{
		$this->_editMail(true);
	}

	function _getBodyContent($fullContent)
    {
	    $res=false;
	    $posBody=0;
	    $posStartBodyContent=0;
	    $res=preg_match_all("/<body[^>]*>/i", $fullContent, $arrayMatches);
	    if ($res==true) {
            $bodyStartTag = $arrayMatches[0][0];
            // Position des Start-Tags holen
            $posBody = strpos($fullContent, $bodyStartTag, 0);
            // Beginn des Contents ohne Body-Tag berechnen
            $posStartBodyContent = $posBody + strlen($bodyStartTag);
	    }
	    $posEndTag=strlen($fullContent);
	    $res=preg_match_all("/<\/body>/i",$fullContent, $arrayMatches);
	    if ($res==true) {
            $bodyEndTag=$arrayMatches[0][0];
            // Position des End-Tags holen
            $posEndTag = strpos($fullContent, $bodyEndTag, 0);
            // Content innerhalb der Body-Tags auslesen
	     }
	     $content = substr($fullContent, $posStartBodyContent, $posEndTag  - $posStartBodyContent);
         return $content;
    }



	function _addMailAttachment($attachment, $mailId = 0)
	{
		global $objDatabase;

		$fileName = substr($attachment, strrpos($attachment, '/')+1);

		$objAttachment = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter_attachment WHERE file_name='".$fileName."'", 1);
		if ($objAttachment !== false) {
			if ($objAttachment->RecordCount() == 1) {
				$md5Current = @md5_file(ASCMS_NEWSLETTER_ATTACH_PATH.'/'.$fileName);
				$md5New = @md5_file(ASCMS_PATH.$attachment);

				if ($md5Current !== false && $md5Current === $md5New) {
					if ($objDatabase->Execute("	INSERT INTO ".DBPREFIX."module_newsletter_attachment (`newsletter`, `file_name`)
												VALUES (".$mailId.", '".$fileName."')") !== false) {
						return true;
					}
				}
			}

			$nr = 0;
			$fileNameTmp = $fileName;
			while (file_exists(ASCMS_NEWSLETTER_ATTACH_PATH.'/'.$fileNameTmp)) {
				$md5Current = @md5_file(ASCMS_NEWSLETTER_ATTACH_PATH.'/'.$fileNameTmp);
				$md5New = @md5_file(ASCMS_PATH.$attachment);

				if ($md5Current !== false && $md5Current === $md5New) {
					if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_attachment (`newsletter`, `file_name`) VALUES (".$mailId.", '".$fileNameTmp."')") !== false) {
						return true;
					}
				}
				$nr++;
				$fileNameTmp = $fileName.$nr;
			}

			if (copy(ASCMS_PATH.$attachment, ASCMS_NEWSLETTER_ATTACH_PATH.'/'.$fileNameTmp)) {
				if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_attachment (`newsletter`, `file_name`) VALUES (".$mailId.", '".$fileNameTmp."')") !== false) {
					return true;
				}
			}
		}
		return false;
	}

	function _removeMailAttachment($attachment, $mailId = 0)
	{
		global $objDatabase;

		$fileName = substr($attachment, strrpos($attachment, '/')+1);
		$objAttachment = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter_attachment WHERE file_name='".$fileName."'", 2);
		if ($objAttachment !== false) {
			if ($objAttachment->RecordCount() < 2) {
				@unlink(ASCMS_NEWSLETTER_ATTACH_PATH.'/'.$fileName);
			}

			if ($objDatabase->SelectLimit("DELETE FROM ".DBPREFIX."module_newsletter_attachment WHERE file_name='".$fileName."' AND newsletter=".$mailId, 1) !== false) {
				return true;
			}
		}
		return false;
	}

	function _getMailPriorityMenu($selectedPriority = 3, $attributes = '')
	{
		global $_ARRAYLANG;

		$menu = "<select".(!empty($attributes) ? " ".$attributes : "").">\n";
		foreach ($this->_arrMailPriority as $priorityId => $priority) {
			$menu .= "<option value=\"".$priorityId."\"".($selectedPriority == $priorityId ? "selected=\"selected\"" : "").">".$_ARRAYLANG[$priority]."</option>\n";
		}
		$menu .= "</select>\n";

		return $menu;
	}

	function _getMailFormatMenu($selectedFormat = '', $attributes = '')
	{
		global $_ARRAYLANG;

		$menu = "<select".(!empty($attributes) ? " ".$attributes : "").">\n";
		foreach ($this->_arrMailFormat as $format => $formatTXT) {
			$menu .= "<option value=\"".$format."\"".($selectedFormat == $format ? " selected=\"selected\"" : "").">".$_ARRAYLANG[$formatTXT]."</option>\n";
		}
		$menu .= "</select>\n";

		return $menu;
	}

	function _addMail($subject, $format, $template, $senderMail, $senderName, $replyMail, $priority, $arrAttachment, $htmlContent, $textContent)
	{
		global $objDatabase;

		if (!empty($subject)) {
			$objSubject = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter WHERE subject='".contrexx_addslashes($subject)."'", 1);
			if ($objSubject !== false) {
				if ($objSubject->RecordCount() == 0) {
					if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter
						(subject,
						template,
						content,
						content_text,
						attachment,
						format,
						priority,
						sender_email,
						sender_name,
						return_path,
						date_create
						) VALUES (
						'".contrexx_addslashes($subject)."',
						".intval($template).",
						'".contrexx_addslashes($htmlContent)."',
						'".contrexx_addslashes($textContent)."',
						'".(count($arrAttachment) > 0 ? '1' : '0')."',
						'".contrexx_addslashes($format)."',
						".intval($priority).",
						'".contrexx_addslashes($senderMail)."',
						'".contrexx_addslashes($senderName)."',
						'".contrexx_addslashes($replyMail)."',
						".time().")") !== false) {
						$mailId = $objDatabase->Insert_ID();
						return $mailId;
					} else {
						$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_SAVE_RETRY'];
					}
				} else {
					$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT_ALREADY_EXISTS'];
				}
			} else {
				$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_SAVE_RETRY'];
			}
		} else {
			$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_NO_SUBJECT'];
		}
		return false;
	}

	function _updateMail($mailId, $subject, $format, $template, $senderMail, $senderName, $replyMail, $priority, $arrAttachment, $htmlContent, $textContent)
	{
		global $objDatabase, $_ARRAYLANG;

		if (!empty($subject)) {
			$objSubject = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter WHERE subject='".contrexx_addslashes($subject)."' AND id!=".$mailId, 1);
			if ($objSubject !== false) {
				if ($objSubject->RecordCount() == 0) {
					if ($objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter
						SET subject='".contrexx_addslashes($subject)."',
						template=".intval($template).",
						content='".contrexx_addslashes($htmlContent)."',
						content_text='".contrexx_addslashes($textContent)."',
						attachment='".(count($arrAttachment) > 0 ? '1' : '0')."',
						format='".contrexx_addslashes($format)."',
						priority=".intval($priority).",
						sender_email='".contrexx_addslashes($senderMail)."',
						sender_name='".contrexx_addslashes($senderName)."',
						return_path='".contrexx_addslashes($replyMail)."'
						WHERE id=".$mailId) !== false) {
						return true;
					} else {
						$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_SAVE_RETRY'];
					}
				} else {
					$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT_ALREADY_EXISTS'];
				}
			} else {
				$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_SAVE_RETRY'];
			}
		} else {
			$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_NO_SUBJECT'];
		}
		return false;
	}

	function _setMailLists($mailId, $arrLists)
	{
		global $objDatabase;

		$arrCurrentList = array();

		$objRelList = $objDatabase->Execute("SELECT category FROM ".DBPREFIX."module_newsletter_rel_cat_news WHERE newsletter=".$mailId);
		if ($objRelList !== false) {

			while (!$objRelList->EOF) {
				array_push($arrCurrentList, $objRelList->fields['category']);
				$objRelList->MoveNext();
			}

			$arrNewLists = array_diff($arrLists, $arrCurrentList);
			$arrRemovedLists = array_diff($arrCurrentList, $arrLists);

			foreach ($arrNewLists as $listId) {
				if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_cat_news (`newsletter`, `category`) VALUES (".$mailId.", ".$listId.")") === false) {
					// could not add to list $listId
				}
			}

			foreach ($arrRemovedLists as $listId) {
				if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_cat_news WHERE newsletter=".$mailId." AND category=".$listId) === false) {
					// could not remove from list $listId
				}
			}

			return true;
		}
		return false;
	}
	
	function _setRecipientLists($recipientId, $arrLists)
	{
		global $objDatabase;

		$arrCurrentList = array();

		$objRelList = $objDatabase->Execute("SELECT category FROM ".DBPREFIX."module_newsletter_rel_user_cat WHERE user=".$recipientId);
		if ($objRelList !== false) {
			while (!$objRelList->EOF) {
				array_push($arrCurrentList, $objRelList->fields['category']);
				$objRelList->MoveNext();
			}

			$arrNewLists = array_diff($arrLists, $arrCurrentList);
			$arrRemovedLists = array_diff($arrCurrentList, $arrLists);

			foreach ($arrNewLists as $listId) {
				if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat (`user`, `category`) VALUES (".$recipientId.", ".$listId.")") === false) {
					// could not add to list $listId
				}
			}

			foreach ($arrRemovedLists as $listId) {
				if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_user_cat WHERE user=".$recipientId." AND category=".$listId) === false) {
					// could not remove from list $listId
				}
			}

			return true;
		}
		return false;
	}

	function _checkUniqueListName($listId, $listName) {
		global $objDatabase;

		$result = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter_category WHERE `name`='".$listName."' AND `id`!=".$listId, 1);
		if ($result !== false) {
			if ($result->RecordCount() == 0) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function ConfigHTML(){
		global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = $_ARRAYLANG['TXT_SETTINGS'];
		$this->_objTpl->loadTemplateFile('newsletter_config_html.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_GENERATE_HTML']);

		$query 		= "SELECT id, name FROM ".DBPREFIX."module_newsletter_category WHERE status='1' order by name";
		$objResult 	= $objDatabase->Execute($query);
		$count 		= $objResult->RecordCount();
		if($count<1){
			$this->_objTpl->setVariable('TXT_NO_CATEGORIES', $_ARRAYLANG['TXT_NO_CATEGORIES']);
		}else{
			$NoCats = "";
		}
		if ($objResult !== false) {
			$html_code = '<form name="newsletter" action="?section=newsletter&act=subscribe" method="post">'.chr(13).chr(10);
			$html_code .= '<input type="hidden" name="subscribe" value="exe" />'.chr(13).chr(10);
			$html_code .= '<input type="hidden" name="block" value="1" />'.chr(13).chr(10);
			while (!$objResult->EOF) {

				if($count==1){
					$html_code .= '<input type="hidden" name="category_'.$objResult->fields['id'].'" value="1" />'.chr(13).chr(10);
				}else{
					$html_code .= '<input type="checkbox" name="category_'.$objResult->fields['id'].'" value="1"  /> '.$objResult->fields['name'].'<br/>'.chr(13).chr(10);
				}

				$objResult->MoveNext();
			}
			$html_code .= '<input type="text" onfocus="this.value=\'\'" name="email" value=" E-mail Adresse" style="width: 165px;" maxlength="250" /><br/><br/>'.chr(13).chr(10).'<input type="submit" value="Eintragen" />'.chr(13).chr(10).'</form>';
		}

		$this->_objTpl->setVariable(array(	'HTML_CODE' 						=> $html_code,
											'TXT_SELECT_ALL' 					=> $_ARRAYLANG['TXT_SELECT_ALL'],
											'TXT_DISPATCH_SETINGS' 				=> $_ARRAYLANG['TXT_DISPATCH_SETINGS'],
											'TXT_GENERATE_HTML'					=> $_ARRAYLANG['TXT_GENERATE_HTML'],
											'TXT_PLACEHOLDER'					=> $_ARRAYLANG['TXT_PLACEHOLDER'],
											'TXT_CONFIRM_MAIL' 					=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_EMAIL'],
											'TXT_ACTIVATE_MAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_EMAIL']
								));	
	}

	function ConfigDispatch(){
		global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = $_ARRAYLANG['TXT_SETTINGS'];
		$this->_objTpl->loadTemplateFile('newsletter_config_dispatch.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_DISPATCH_SETINGS']);

		if($_POST["update"]=="exe"){
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".contrexx_addslashes($_POST['sender_email'])."' WHERE setname='sender_mail'");
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".contrexx_addslashes($_POST['sender_name'])."' WHERE setname='sender_name'");
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".contrexx_addslashes($_POST['return_path'])."' WHERE setname='reply_mail'");
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".intval($_POST['mails_per_run'])."' WHERE setname='mails_per_run'");
			//$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".contrexx_addslashes($_POST['bcc_mail'])."' WHERE setname='bcc_mail'");
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".contrexx_addslashes($_POST['test_mail'])."' WHERE setname='test_mail'");
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".intval($_POST['overview_entries'])."' WHERE setname='overview_entries_limit'");
			$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_settings SET setvalue='".intval($_POST['text_break_after'])."' WHERE setname='text_break_after'");
		}

		// Load Values
		// -------------
		$objSettings = $objDatabase->Execute("SELECT setname, setvalue FROM ".DBPREFIX."module_newsletter_settings");
		if ($objSettings !== false) {
			while (!$objSettings->EOF) {
				$arrSettings[$objSettings->fields['setname']] = $objSettings->fields['setvalue'];
				$objSettings->MoveNext();
			}
		}
		$this->_objTpl->setVariable(array(
			'TXT_SETTINGS'					=> $_ARRAYLANG['TXT_SETTINGS'],
			'TXT_SENDER' 					=> $_ARRAYLANG['TXT_SENDER'],
			'TXT_LASTNAME' 					=> $_ARRAYLANG['TXT_LASTNAME'],
			'TXT_RETURN_PATH' 				=> $_ARRAYLANG['TXT_RETURN_PATH'],
			'TXT_SEND_LIMIT' 				=> $_ARRAYLANG['TXT_SEND_LIMIT'],
			'TXT_SAVE'						=> $_ARRAYLANG['TXT_SAVE'],
			'TXT_FILL_OUT_ALL_REQUIRED_FIELDS' => $_ARRAYLANG['TXT_FILL_OUT_ALL_REQUIRED_FIELDS'],
			'SENDERMAIL_VALUE'				=> $arrSettings['sender_mail'],
			'SENDERNAME_VALUE'				=> $arrSettings['sender_name'],
			'RETURNPATH_VALUE'				=> $arrSettings['reply_mail'],
			'MAILSPERRUN_VALUE'				=> $arrSettings['mails_per_run'],
			//'BCC_VALUE'					=> $arrSettings['bcc_mail'],
			'OVERVIEW_ENTRIES_VALUE'		=> $arrSettings['overview_entries_limit'],
			'TEST_MAIL_VALUE'				=> $arrSettings['test_mail'],
			'BREAK_AFTER_VALUE'				=> $arrSettings['text_break_after'],
			'TXT_WILDCART_INFOS'			=> $_ARRAYLANG['TXT_WILDCART_INFOS'],
			'TXT_USER_DATA'					=> $_ARRAYLANG["TXT_USER_DATA"],
			'TXT_EMAIL_ADDRESS'				=> $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
			'TXT_LASTNAME'					=> $_ARRAYLANG['TXT_LASTNAME'],
			'TXT_FIRSTNAME'					=> $_ARRAYLANG['TXT_FIRSTNAME'],
			'TXT_STREET'					=> $_ARRAYLANG['TXT_STREET'],
			'TXT_ZIP'						=> $_ARRAYLANG['TXT_ZIP'],
			'TXT_CITY'						=> $_ARRAYLANG['TXT_CITY'],
			'TXT_COUNTRY'					=> $_ARRAYLANG['TXT_COUNTRY'],
			'TXT_PHONE'						=> $_ARRAYLANG['TXT_PHONE'],
			'TXT_BIRTHDAY'					=> $_ARRAYLANG['TXT_BIRTHDAY'],
			'TXT_GENERALLY'					=> $_ARRAYLANG['TXT_GENERALLY'],
			'TXT_DATE'						=> $_ARRAYLANG['TXT_DATE'],
			'TXT_NEWSLETTER_CONTENT'		=> $_ARRAYLANG['TXT_NEWSLETTER_CONTENT'],
			'TXT_CONFIRM_MAIL'  			=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_EMAIL'],
   			'TXT_ACTIVATE_MAIL' 			=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_EMAIL'],
			'TXT_DISPATCH_SETINGS'			=> $_ARRAYLANG['TXT_DISPATCH_SETINGS'],
			'TXT_GENERATE_HTML'				=> $_ARRAYLANG['TXT_GENERATE_HTML'],
			'TXT_BREAK_AFTER'				=> $_ARRAYLANG['TXT_NEWSLETTER_BREAK_AFTER'],
			'TXT_TEST_MAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_TEST_RECIPIENT'],
			'TXT_FAILED'					=> $_ARRAYLANG['TXT_NEWSLETTER_FAILED'],
//			'TXT_BCC'						=> $_ARRAYLANG['TXT_NEWSLETTER_BCC'],
			'TXT_NEWSLETTER_OVERVIEW_ENTRIES'   => $_ARRAYLANG['TXT_NEWSLETTER_OVERVIEW_ENTRIES'],
			'TXT_NEWSLETTER_REPLY_EMAIL'		=> $_ARRAYLANG['TXT_NEWSLETTER_REPLY_EMAIL']
		));

	}

	function _getSettings()
	{
		global $objDatabase;

		static $arrSettings = array();

		if (count($arrSettings) == 0) {
			$objSettings = $objDatabase->Execute("SELECT setid, setname, setvalue, status FROM ".DBPREFIX."module_newsletter_settings");
			if ($objSettings !== false) {
				while (!$objSettings->EOF) {
					$arrSettings[$objSettings->fields['setname']] = array(
						'setid'		=> $objSettings->fields['setid'],
						'setvalue'	=> $objSettings->fields['setvalue'],
						'setatus'	=> $objSettings->fields['status']
					);

					$objSettings->MoveNext();
				}
			}
		}

		return $arrSettings;
	}

	function _templates()
	{
		global $objDatabase, $_ARRAYLANG;

		$rowNr = 0;
		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATES'];
		$this->_objTpl->loadTemplateFile('module_newsletter_templates.html');

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_CANNOT_UNDO_OPERATION'		=> $_ARRAYLANG['TXT_NEWSLETTER_CANNOT_UNDO_OPERATION'],
			'TXT_NEWSLETTER_CONFIRM_DELETE_TEMPLATE'	=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRM_DELETE_TEMPLATE'],
			'TXT_NEWSLETTER_TEMPLATES'					=> $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATES'],
			'TXT_NEWSLETTER_ID_UC'						=> $_ARRAYLANG['TXT_NEWSLETTER_ID_UC'],
			'TXT_NEWSLETTER_NAME'						=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
			'TXT_NEWSLETTER_DESCRIPTION'				=> $_ARRAYLANG['TXT_NEWSLETTER_DESCRIPTION'],
			'TXT_NEWSLETTER_FUNCTIONS'					=> $_ARRAYLANG['TXT_NEWSLETTER_FUNCTIONS'],
			'TXT_TEMPLATE_ADD_NEW_TEMPLATE'				=> $_ARRAYLANG['TXT_TEMPLATE_ADD_NEW_TEMPLATE']
		));

		$this->_objTpl->setGlobalVariable(array(
			'TXT_NEWSLETTER_MODIFY_TEMPLATE'	=> $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_TEMPLATE'],
			'TXT_NEWSLETTER_DELETE_TEMPLATE'	=> $_ARRAYLANG['TXT_NEWSLETTER_DELETE_TEMPLATE']
		));

		$objTemplate = $objDatabase->Execute("SELECT id, name, required, description FROM ".DBPREFIX."module_newsletter_template ORDER BY id DESC");
		if ($objTemplate !== false) {
			while (!$objTemplate->EOF) {
				if ($objTemplate->fields['required'] == 0) {
					$this->_objTpl->touchBlock('newsletter_template_delete');
					$this->_objTpl->hideBlock('newsletter_templalte_spacer');
				} else {
					$this->_objTpl->hideBlock('newsletter_template_delete');
					$this->_objTpl->touchBlock('newsletter_templalte_spacer');
				}

				$this->_objTpl->setVariable(array(
					'NEWSLETTER_TEMPLATE_ROW_CLASS'		=> $rowNr % 2 == 1 ? 'row1' : 'row2',
					'NEWSLETTER_TEMPLATE_ID' 			=> $objTemplate->fields['id'],
					'NEWSLETTER_TEMPLATE_NAME'			=> $objTemplate->fields['name'],
					'NEWSLETTER_TEMPLATE_DESCRIPTION'	=> $objTemplate->fields['description'],

				));

				$rowNr++;
				$this->_objTpl->parse("templates_row");
				$objTemplate->MoveNext();
			}
		}
	}


	function _updateTemplate($id, $name, $description, $html, $text)
	{
		global $objDatabase;
		if ($objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_template SET name='".contrexx_addslashes($name)."', description='".contrexx_addslashes($description)."', html='".contrexx_addslashes($html)."', text='".contrexx_addslashes($text)."' WHERE id=".$id) !== false) {
			return true;
		} else {
		 	return false;
		}
	}

	function _addTemplate($name, $description, $html, $text)
	{
		global $objDatabase;
		if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_template (`name`, `description`, `html`, `text`) VALUES ('".contrexx_addslashes($name)."', '".contrexx_addslashes($description)."', '".contrexx_addslashes($html)."', '".contrexx_addslashes($text)."')") !== false) {
			return true;
		} else {
		 	return false;
		}
	}

	function _editTemplate()
	{
		global $objDatabase, $_ARRAYLANG;

		$id = isset($_REQUEST['id']) ? intval($_REQUEST['id']) : 0;
		$name = '';
		$description = '';
		$html = "<html>\n<head>\n<title>[[subject]]</title>\n</head>\n<body>\n[[content]]\n<br />\n<br />\n[[profile_setup]]\n[[unsubscribe]]\n</body>\n</html>";
		$text = "[[content]]\n\n\n[[profile_setup]]\n[[unsubscribe]]";
		$saveStatus = true;

		if (isset($_POST['newsletter_template_save'])) {
			if (!empty($_POST['template_edit_name'])) {
				$name = $_POST['template_edit_name'];
			} else {
				$saveStatus = false;
				$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_DEFINE_TEMPLATE_NAME']."<br />";
			}

			if (isset($_POST['template_edit_description'])) {
				$description = $_POST['template_edit_description'];
			}

			if (isset($_POST['template_edit_html'])) {
				$html = $_POST['template_edit_html'];
			}
			if (preg_match_all('/\[\[content\]\]/', $html, $arrContentMatches)) {
				if (count($arrContentMatches[0]) > 1) {
					$saveStatus = false;
					$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_MAX_CONTENT_PLACEHOLDER_HTML_MSG']."<br />";
				}
			} else {
				$saveStatus = false;
				$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_MIN_CONTENT_PLACEHOLDER_HTML_MSG']."<br />";
			}

			if (isset($_POST['template_edit_text'])) {
				$text = $_POST['template_edit_text'];
			}
			if (preg_match_all('/\[\[content\]\]/', $text, $arrContentMatches)) {
				if (count($arrContentMatches[0]) > 1) {
					$saveStatus = false;
					$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_MAX_CONTENT_PLACEHOLDER_TEXT_MSG']."<br />";
				}
			} else {
				$saveStatus = false;
				$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_MIN_CONTENT_PLACEHOLDER_TEXT_MSG']."<br />";
			}

			if ($saveStatus) {
				$objTemplate = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter_template WHERE id!=".$id." AND name='".contrexx_addslashes($name)."'", 1);
				if ($objTemplate !== false && $objTemplate->RecordCount() == 0) {
					if ($id > 0) {
						$this->_updateTemplate($id, $name, $description, $html, $text);
					} else {
						$this->_addTemplate($name, $description, $html, $text);
					}

					return $this->_templates();
				} else {
					$this->_strErrMessage = $_ARRAYLANG['TXT_NEWSLETTER_DUPLICATE_LIST_NAME_MSG'];
				}
			}
		} elseif ($id > 0) {
			$objTemplate = $objDatabase->SelectLimit("SELECT id, name, description, html, text FROM ".DBPREFIX."module_newsletter_template WHERE id=".$id, 1);
			if ($objTemplate !== false && $objTemplate->RecordCount() == 1) {
				$name = $objTemplate->fields['name'];
				$description = $objTemplate->fields['description'];
				$html = $objTemplate->fields['html'];
				$text = $objTemplate->fields['text'];
			}
		}

		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATES'];
		$this->_objTpl->loadTemplateFile('module_newsletter_template_edit.html');

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_PLACEHOLDER_DIRECTORY'	=> $_ARRAYLANG['TXT_NEWSLETTER_PLACEHOLDER_DIRECTORY'],
			'TXT_NEWSLETTER_NAME'					=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
			'TXT_NEWSLETTER_DESCRIPTION'			=> $_ARRAYLANG['TXT_NEWSLETTER_DESCRIPTION'],
			'TXT_NEWSLETTER_HTML_TEMPLATE'			=> $_ARRAYLANG['TXT_NEWSLETTER_HTML_TEMPLATE'],
			'TXT_NEWSLETTER_TEXT_TEMPLATE'			=> $_ARRAYLANG['TXT_NEWSLETTER_TEXT_TEMPLATE'],
			'TXT_NEWSLETTER_BACK'					=> $_ARRAYLANG['TXT_NEWSLETTER_BACK'],
			'TXT_NEWSLETTER_SAVE'					=> $_ARRAYLANG['TXT_NEWSLETTER_SAVE'],
			'TXT_NEWSLETTER_USER_DATA'				=> $_ARRAYLANG['TXT_NEWSLETTER_USER_DATA'],
			'TXT_NEWSLETTER_EMAIL_ADDRESS'			=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_TITLE'					=> $_ARRAYLANG['TXT_NEWSLETTER_TITLE'],
			'TXT_NEWSLETTER_LASTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_LASTNAME'],
			'TXT_NEWSLETTER_FIRSTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
			'TXT_NEWSLETTER_STREET'					=> $_ARRAYLANG['TXT_NEWSLETTER_STREET'],
			'TXT_NEWSLETTER_ZIP'					=> $_ARRAYLANG['TXT_NEWSLETTER_ZIP'],
			'TXT_NEWSLETTER_CITY'					=> $_ARRAYLANG['TXT_NEWSLETTER_CITY'],
			'TXT_NEWSLETTER_COUNTRY'				=> $_ARRAYLANG['TXT_NEWSLETTER_COUNTRY'],
			'TXT_NEWSLETTER_PHONE'					=> $_ARRAYLANG['TXT_NEWSLETTER_PHONE'],
			'TXT_NEWSLETTER_BIRTHDAY'				=> $_ARRAYLANG['TXT_NEWSLETTER_BIRTHDAY'],
			'TXT_NEWSLETTER_GENERAL'				=> $_ARRAYLANG['TXT_NEWSLETTER_GENERAL'],
			'TXT_NEWSLETTER_CONTENT'				=> $_ARRAYLANG['TXT_NEWSLETTER_CONTENT'],
			'TXT_NEWSLETTER_PROFILE_SETUP'			=> $_ARRAYLANG['TXT_NEWSLETTER_PROFILE_SETUP'],
			'TXT_NEWSLETTER_UNSUBSCRIBE'			=> $_ARRAYLANG['TXT_NEWSLETTER_UNSUBSCRIBE'],
			'TXT_NEWSLETTER_DATE'					=> $_ARRAYLANG['TXT_NEWSLETTER_DATE']
		));

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_TEMPLATE_ID'			=> $id,
			'NEWSLETTER_TEMPLATE_NAME'			=> htmlentities($name, ENT_QUOTES),
			'NEWSLETTER_TEMPLATE_DESCRIPTION'	=> htmlentities($description, ENT_QUOTES),
			'NEWSLETTER_TEMPLATE_HTML' 			=> htmlentities($html, ENT_QUOTES),
			'NEWSLETTER_TEMPLATE_TEXT' 			=> htmlentities($text, ENT_QUOTES),
			'NEWSLETTER_TEMPLATE_TITLE_TEXT'	=> $id > 0 ? $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_TEMPLATE'] : $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE_ADD']
		));
	}

	function delTemplate()
	{
		global $objDatabase, $_ARRAYLANG;

		$id = isset($_GET['id']) ? intval($_GET['id']) : 0;

		if ($id > 0) {
			$objResult = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter WHERE template=".$id, 1);
			if ($objResult !== false) {
				if ($objResult->RecordCount() == 1) {
					$this->_strErrMessage = $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE_STILL_IN_USE'];
					return false;
				} else {
					if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_template WHERE required=0 AND id=".$id) !== false) {
						$this->_strOkMessage = $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE_DELETED'];
						return true;
					}
				}
			}
		}

		$this->_strErrMessage = $_ARRAYLANG['TXT_NEWSLETTER_TEMPLATE_DELETE_ERROR'];
		return false;
	}

	function ActivateMail(){
		global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = $_ARRAYLANG['TXT_SETTINGS'];
		$this->_objTpl->loadTemplateFile('newsletter_config_activatemail.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_DISPATCH_SETINGS']);

		if($_POST["update"]=="exe"){
			$objResultUPDATE 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_confirm_mail
															SET title='".contrexx_addslashes($_POST["mailSubject"])."',
															  content='".contrexx_addslashes($_POST["mailContent"])."'
															 WHERE id=1");
		}

		$query 		= "SELECT id, title, content FROM ".DBPREFIX."module_newsletter_confirm_mail WHERE id='1'";
		$objResult 	= $objDatabase->Execute($query);
		if ($objResult !== false) {
			$subject = $objResult->fields['title'];
			$content = $objResult->fields['content'];
		}

		$this->_objTpl->setVariable(array(
			'TXT_LASTNAME' 				=> $_ARRAYLANG['TXT_LASTNAME'],
			'TXT_WILDCART_INFOS'		=> $_ARRAYLANG['TXT_WILDCART_INFOS'],
			'TXT_U_TITLE'				=> $_ARRAYLANG['TXT_NEWSLETTER_TITLE'],
			'TXT_FIRSTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
			'TXT_DATE'					=> $_ARRAYLANG['TXT_NEWSLETTER_REGISTRATION_DATE'],
			'TXT_CONTENT'				=> $_ARRAYLANG['TXT_NEWSLETTER_CONTENT'],
			'TXT_SUBJECT'				=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'TXT_TEXT'					=> $_ARRAYLANG['TXT_NEWSLETTER_TEXT'],
			'TXT_URL'					=> $_ARRAYLANG['TXT_NEWSLETTER_URL'],
			'TXT_CONFIRMMAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_EMAIL'],
			'TXT_CODE'					=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_CODE'],
			'TXT_SAVE'					=> $_ARRAYLANG['TXT_SAVE'],
			'MAIL_SUBJECT'				=> $subject,
			'MAIL_CONTENT'				=> $content,
			'TXT_CONFIRM_MAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_EMAIL'],
			'TXT_ACTIVATE_MAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_EMAIL'],
			'TXT_DISPATCH_SETINGS'		=> $_ARRAYLANG['TXT_DISPATCH_SETINGS'],
			'TXT_GENERATE_HTML'			=> $_ARRAYLANG['TXT_GENERATE_HTML'],
		));
	}

	function ConfirmMail(){
		global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = $_ARRAYLANG['TXT_SETTINGS'];
		$this->_objTpl->loadTemplateFile('newsletter_config_confirmmail.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_DISPATCH_SETINGS']);

		//Update
		if($_POST["update"]=="exe"){
			if ($objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_confirm_mail SET title='".contrexx_addslashes($_POST["mailSubject"])."', content='".contrexx_addslashes($_POST["mailContent"])."' WHERE id=2") !== false) {
				$this->_strOkMessage = $_ARRAYLANG['TXT_NEWSLETTER_CONFIRM_MAIL_UPDATED_SUCCESSFULLY'];
			} else {
				$this->_strErrMessage = $_ARRAYLANG['TXT_NEWSLETTER_ERROR_SAVE_CONFIRM_MAIL'];
			}
		}

		$query 		= "SELECT id, title, content FROM ".DBPREFIX."module_newsletter_confirm_mail WHERE id='2'";
		$objResult 	= $objDatabase->Execute($query);
		if ($objResult !== false) {
			$subject = $objResult->fields['title'];
			$content = $objResult->fields['content'];
		}

		$this->_objTpl->setVariable(array(
			'TXT_LASTNAME' 				=> $_ARRAYLANG['TXT_NEWSLETTER_LASTNAME'],
			'TXT_WILDCART_INFOS'		=> $_ARRAYLANG['TXT_WILDCART_INFOS'],
			'TXT_U_TITLE'				=> $_ARRAYLANG['TXT_NEWSLETTER_TITLE'],
			'TXT_FIRSTNAME'				=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
			'TXT_DATE'					=> $_ARRAYLANG['TXT_NEWSLETTER_DATE'],
			'TXT_CONTENT'				=> $_ARRAYLANG['TXT_NEWSLETTER_CONTENT'],
			'TXT_SUBJECT'				=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'TXT_TEXT'					=> $_ARRAYLANG['TXT_NEWSLETTER_TEXT'],
			'TXT_URL'					=> $_ARRAYLANG['TXT_NEWSLETTER_URL'],
			'TXT_CONFIRMMAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_EMAIL'],
			'TXT_SAVE'					=> $_ARRAYLANG['TXT_SAVE'],
			'MAIL_SUBJECT'				=> $subject,
			'MAIL_CONTENT'				=> $content,
			'TXT_CONFIRM_MAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_EMAIL'],
			'TXT_ACTIVATE_MAIL'			=> $_ARRAYLANG['TXT_NEWSLETTER_ACTIVATION_EMAIL'],
			'TXT_DISPATCH_SETINGS'		=> $_ARRAYLANG['TXT_DISPATCH_SETINGS'],
			'TXT_GENERATE_HTML'			=> $_ARRAYLANG['TXT_GENERATE_HTML'],
		));
	}

	function _sendMailPage()
	{
		global $_ARRAYLANG;
		if (isset($_POST['newsletter_mail_edit'])) {
			return $this->_editMail();
		} elseif (!isset($_REQUEST['id'])) {
			return $this->_mails();
		}

		$mailId = intval($_REQUEST['id']);
		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_SEND_EMAIL'];

		$this->_objTpl->loadTemplateFile('module_newsletter_mail_send.html');

		$arrSettings = &$this->_getSettings();
		$testmail = $arrSettings['test_mail']['setvalue'];

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_EMAIL_ADDRESS'	=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_SEND'			=> $_ARRAYLANG['TXT_NEWSLETTER_SEND']
		));

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MAIL_ID'			=> $mailId,
			'NEWSLETTER_MAIL_TEST_EMAIL'	=> $testmail
		));

		if (isset($_POST['newsletter_mail_send_test'])) {
			$this->_sendTestMail($mailId);
		}

		$mailRecipientCount = &$this->_getMailRecipientCount($mailId);
		if ($mailRecipientCount > 0) {
			$this->_objTpl->touchBlock('newsletter_mail_send_status');
			$this->_objTpl->hideBlock('newsletter_mail_list_required');
		} else {
			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_MAIL_LIST_REQUIRED_TXT'	=> $_ARRAYLANG['TXT_CATEGORY_ERROR']
			));

			$this->_objTpl->touchBlock('newsletter_mail_list_required');
			$this->_objTpl->hideBlock('newsletter_mail_send_status');
		}
	}

	function _sendTestMail($mailId)
	{
		global $_ARRAYLANG;

		$objValidator = &new FWValidator();

		if (!empty($_POST['newsletter_test_mail']) && $objValidator->isEmail($_POST["newsletter_test_mail"])) {
			if ($this->SendEmail(0, $mailId, $_POST["newsletter_test_mail"], 0)) {
				$this->_strOkMessage = str_replace("%s", $_POST["newsletter_test_mail"], $_ARRAYLANG['TXT_TESTMAIL_SEND_SUCCESSFUL']);
			} else {
				$this->_strErrMessage = $_ARRAYLANG['TXT_SENDING_MESSAGE_ERROR'];
			}
		} else {
			$this->_strErrMessage = $_ARRAYLANG['TXT_INVALID_EMAIL_ADDRESS'];
		}
	}

	function _getMailRecipientCount($mailId)
	{
		global $objDatabase;

		$objMail = $objDatabase->SelectLimit("SELECT COUNT(1) AS mailCount
			FROM ".DBPREFIX."module_newsletter_rel_cat_news AS tblRelListMail right
			JOIN ".DBPREFIX."module_newsletter_rel_user_cat AS tblRelUserList ON tblRelListMail.category=tblRelUserList.category
			RIGHT JOIN ".DBPREFIX."module_newsletter_user AS tblUsers ON tblRelUserList.user=tblUsers.id AND tblUsers.status = 1
			WHERE newsletter=".$mailId."
			GROUP BY tblRelListMail.id", 1);
		if ($objMail !== false && $objMail->RecordCount() > 0) {
			return $objMail->fields['mailCount'];
		} else {
			return 0;
		}
	}

	function _sendMail()
	{
		global $objDatabase, $_ARRAYLANG;

		if (!isset($_REQUEST['id'])) {
			die($_ARRAYLANG['TXT_NEWSLETTER_INVALID_EMAIL']);
		}
		$mailId = intval($_REQUEST['id']);

		$mailRecipientCount = &$this->_getMailRecipientCount($mailId);
		if ($mailRecipientCount == 0) {
			die($_ARRAYLANG['TXT_CATEGORY_ERROR']);
		}

		$this->_objTpl->loadTemplateFile('module_newsletter_mail_send_status.html');

		$objMail = $objDatabase->SelectLimit("SELECT
			id,
			subject,
			status,
			`count`,
			tmp_copy
			FROM ".DBPREFIX."module_newsletter WHERE id=".$mailId, 1);
		if ($objMail !== false) {
			$subject 		= $objMail->fields['subject'];
			$status 		= $objMail->fields['status'];
			$count 			= $objMail->fields['count'];
			$tmp_copy 		= $objMail->fields['tmp_copy'];
		}

		$statusBarWidth = round(200 / $mailRecipientCount * $count, 0);

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_SUBJECT'			=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'TXT_NEWSLETTER_MAILS_SENT'			=> $_ARRAYLANG['TXT_NEWSLETTER_SENT_EMAILS']
		));

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MAIL_ID'			=> $mailId,
			'NEWSLETTER_MAIL_USERES'		=> $mailRecipientCount,
			'NEWSLETTER_SENDT'				=> $count,
			'NEWSLETTER_MAIL_SUBJECT'		=> $subject,
			'NEWSLETTER_STATUSBAR_WIDTH'	=> $statusBarWidth
		));

		if ($status == 0) {
			if (isset($_GET['send']) && $_GET['send'] == '1') {
				if ($tmp_copy==0) {
					$objMail = $objDatabase->Execute("SELECT email
						FROM ".DBPREFIX."module_newsletter_rel_cat_news AS tblRelListMail
						RIGHT JOIN ".DBPREFIX."module_newsletter_rel_user_cat AS tblRelUserList ON tblRelListMail.category=tblRelUserList.category
						RIGHT JOIN ".DBPREFIX."module_newsletter_user AS tblUser ON tblRelUserList.user=tblUser.id AND tblUser.status = 1
						WHERE newsletter=".$mailId."
						GROUP BY tblRelUserList.user");
					if ($objMail !== false) {
						while (!$objMail->EOF) {
							$objSend = $objDatabase->Execute("SELECT
								newsletter,
								email
								FROM ".DBPREFIX."module_newsletter_tmp_sending
								WHERE email='".$objMail->fields['email']."' AND newsletter=".$mailId);
							if ($objSend->RecordCount() == 0) {
								$objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_tmp_sending (`newsletter`, `email`) VALUES (".$mailId.", '".$objMail->fields['email']."')");
							}
							$objMail->MoveNext();
						}

						$date = time();
						$objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter SET tmp_copy=1, date_sent=".$date." WHERE id=".$mailId);
						$this->_objTpl->setVariable('NEWSLETTER_MAIL_RELOAD_SEND_STATUS_FRAME', '<script type="text/javascript" language="javascript">setTimeout("newsletterSendMail()",1000);</script>');
					}
				} else {
					$arrSettings = &$this->_getSettings();
					$mails_per_run = $arrSettings['mails_per_run']['setvalue'];

					//hier muss der fehler sien
					$objSend = $objDatabase->SelectLimit("SELECT tblUser.id, tblUser.email FROM ".DBPREFIX."module_newsletter_tmp_sending AS tblSend
					RIGHT JOIN ".DBPREFIX."module_newsletter_user AS tblUser ON tblUser.email=tblSend.email
					WHERE tblSend.sendt=0", $mails_per_run, 0);
					if ($objSend !== false) {
						while (!$objSend->EOF) {
							if ($this->SendEmail($objSend->fields['id'], $mailId, ''.$objSend->fields['email'].'', 1)) {
								$this->_objTpl->setVariable('NEWSLETTER_MAIL_RELOAD_SEND_STATUS_FRAME', '<script type="text/javascript" language="javascript">setTimeout("newsletterSendMail()",1000);</script>');
							}
							$objSend->MoveNext();
						}
					}
				}

				$this->_objTpl->touchBlock('newsletter_mail_stop_button');
				$this->_objTpl->hideBlock('newsletter_mail_send_button');
				$this->_objTpl->setVariable(array(
					'TXT_SENDING'							=> $_ARRAYLANG['TXT_SENDING']
				));
			} else {
				$this->_objTpl->touchBlock('newsletter_mail_send_button');
				$this->_objTpl->hideBlock('newsletter_mail_stop_button');
			}
		} else {
			$this->_objTpl->hideBlock('newsletter_mail_stop_button');
			$this->_objTpl->hideBlock('newsletter_mail_send_button');
		}
	}

	function newslettersend(){
		global $objDatabase, $_ARRAYLANG;

		$mailId = isset($_REQUEST['id']) ? intval($_REQUEST['id']) : 0;
		if ($mailId == 0) {
			return $this->_mails();
		}



		// Send Testmail
		// -------------------------------
		$objValidator = &new FWValidator();
		if($_POST["sendtestmail"]=="exe"){
			if ($objValidator->isEmail($_POST["testemail"])) {
				if($this->SendEmail(0, $mailId, $_POST["testemail"], 0)){
					$this->_strOkMessage = str_replace("%s", $_POST["testemail"], $_ARRAYLANG['TXT_TESTMAIL_SEND_SUCCESSFUL']);
				}else{
					$this->_strErrMessage = $_ARRAYLANG['TXT_SENDING_MESSAGE_ERROR'];
				}

			}else{
				$this->_strErrMessage = $_ARRAYLANG['TXT_INVALID_EMAIL_ADDRESS'];
			}
		}
		// -------------------------------

		$this->_pageTitle = $_ARRAYLANG['TXT_SEND_NEWSLETTER'];

		if($_GET["standalone"]=="true"){
			$this->_objTpl->loadTemplateFile('module_newsletter_mail_send_status.html');
		}else{
			$this->_objTpl->loadTemplateFile('module_newsletter_mail_send.html');
		}

		$queryNU 		= "SELECT * FROM ".DBPREFIX."module_newsletter_rel_cat_news right join ".DBPREFIX."module_newsletter_rel_user_cat on ".DBPREFIX."module_newsletter_rel_cat_news.category=".DBPREFIX."module_newsletter_rel_user_cat.category right join ".DBPREFIX."module_newsletter_user on ".DBPREFIX."module_newsletter_rel_user_cat.user=".DBPREFIX."module_newsletter_user.id and ".DBPREFIX."module_newsletter_user.status = 1 where newsletter=".$mailId." group by ".DBPREFIX."module_newsletter_rel_user_cat.user";
		$objResultNU 	= $objDatabase->Execute($queryNU);
		$countNU 		= $objResultNU->RecordCount();

		$queryNewsletterValues = "select id, subject, template, content, content_text, attachment, format, priority, sender_email, sender_name, return_path, status, count, date_create, date_sent, tmp_copy from ".DBPREFIX."module_newsletter where id=".$mailId."";
		$objResultNewsletterValues = $objDatabase->Execute($queryNewsletterValues);
		if ($objResultNewsletterValues !== false) {
			$subject 		= $objResultNewsletterValues->fields['subject'];
			$template 		= $objResultNewsletterValues->fields['template'];
			$content 		= $objResultNewsletterValues->fields['content'];
			$content_text 	= $objResultNewsletterValues->fields['content_text'];
			$attachment 	= $objResultNewsletterValues->fields['attachment'];
			$format 		= $objResultNewsletterValues->fields['format'];
			$priority 		= $objResultNewsletterValues->fields['priority'];
			$sender_email 	= $objResultNewsletterValues->fields['sender_email'];
			$sender_name 	= $objResultNewsletterValues->fields['sender_name'];
			$return_path 	= $objResultNewsletterValues->fields['return_path'];
			$status 		= $objResultNewsletterValues->fields['status'];
			$count 			= $objResultNewsletterValues->fields['count'];
			$date_create 	= $objResultNewsletterValues->fields['date_create'];
			$date_sent 		= $objResultNewsletterValues->fields['date_sent'];
			$tmp_copy 		= $objResultNewsletterValues->fields['tmp_copy'];
		}

		$StatusPixelWidth = 200/$countNU;
		$StatusBarWidth = round($StatusPixelWidth * $count, 0);

		$querySettings = "select setvalue from ".DBPREFIX."module_newsletter_settings where setname='test_mail'";
		$objResulSettings = $objDatabase->Execute($querySettings);
		if ($objResulSettings !== false) {
			$testmail 		= $objResulSettings->fields['setvalue'];
		}

		$this->_objTpl->setVariable('TXT_SEND_TEST_EMAIL', $_ARRAYLANG['TXT_SEND_TEST_EMAIL']);
		$this->_objTpl->setVariable('TEST_EMAIL_ADDRESS', $testmail);


		$this->_objTpl->setVariable(array(
			'TXT_EMAIL_ADDRESS'	=> $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
			'TXT_SUBMIT'		=> $_ARRAYLANG['TXT_SUBMIT'],
			'TXT_SEND_NEWSLETTER'=> $_ARRAYLANG['TXT_SEND_NEWSLETTER'],
			'TXT_NEWSLETTER_SENT_NEWSLETTERS'=> $_ARRAYLANG['TXT_NEWSLETTER_SENT_NEWSLETTERS'],
			'NEWSLETTER_ID'		=> $mailId,
			'NEWSLETTER_USERES'	=> $countNU,
			'NEWSLETTER_SENDT'	=> $count,
			'TXT_NEWSLETTER_SUBJECT'=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
			'VALUE_SUBJECT'		=> $subject,
			'STATUSBAR_WIDTH'	=> $StatusBarWidth,
			'SENDING_BUTTON'	=> '<input type="button" value="'.$_ARRAYLANG['TXT_SEND_NEWSLETTER'].'" onclick="Sending();" />'
			));
		if($status==0){
			if($_GET["sending"]=="exe"){
				if($tmp_copy==0){
					$queryNU 		= "SELECT * FROM ".DBPREFIX."module_newsletter_rel_cat_news right join ".DBPREFIX."module_newsletter_rel_user_cat on ".DBPREFIX."module_newsletter_rel_cat_news.category=".DBPREFIX."module_newsletter_rel_user_cat.category right join ".DBPREFIX."module_newsletter_user on ".DBPREFIX."module_newsletter_rel_user_cat.user=".DBPREFIX."module_newsletter_user.id and ".DBPREFIX."module_newsletter_user.status = 1 where newsletter=".$mailId." group by ".DBPREFIX."module_newsletter_rel_user_cat.user";
					$objResultNU 	= $objDatabase->Execute($queryNU);
					if ($objResultNU !== false) {
						while (!$objResultNU->EOF) {
							$queryCheck 	= "SELECT newsletter, email FROM ".DBPREFIX."module_newsletter_tmp_sending where email='".$objResultNU->fields['email']."' and newsletter=".$mailId."";
							$objResultCheck = $objDatabase->Execute($queryCheck);
							$countCheck 	= $objResultCheck->RecordCount();
							if ($countCheck == 0) {
								$objResultIM = $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_tmp_sending
													(newsletter, email)
													VALUES (".$mailId.", '".$objResultNU->fields['email']."')");
							}
							$objResultNU->MoveNext();
						}

						$date = time();
						$objResultUPDATE 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter
															SET tmp_copy=1,
															   date_sent='".$date."'
															WHERE id=".$mailId."");
						$this->_objTpl->setVariable('RELOAD_SENDING_FRAME', '<script language="javascript">setTimeout("Sending()",1000);</script>');

					}
				}else{
					$query 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setname='mails_per_run'";
					$objResult 	= $objDatabase->Execute($query);
					if ($objResult !== false) {
						$mails_per_run = $objResult->fields['setvalue'];
					}

					$queryNU 		= "SELECT * FROM ".DBPREFIX."module_newsletter_tmp_sending right join ".DBPREFIX."module_newsletter_user on ".DBPREFIX."module_newsletter_user.email=".DBPREFIX."module_newsletter_tmp_sending.email where sendt=0 LIMIT 0, ".$mails_per_run."";
					$objResultNU 	= $objDatabase->Execute($queryNU);
					if ($objResultNU !== false) {
						while (!$objResultNU->EOF) {
							$this->SendEmail($objResultNU->fields['id'], $mailId, ''.$objResultNU->fields['email'].'', 1);
							$objResultNU->MoveNext();
						}
					}
				}
				$this->_objTpl->setVariable('TXT_SENDING', $_ARRAYLANG['TXT_SENDING']);
			}
		}

	}

	function SendEmail($UserID, $NewsletterID, $TargetEmail, $TmpEntry){
		global $objDatabase, $_ARRAYLANG;

		require_once ASCMS_LIBRARY_PATH . '/phpmailer/class.phpmailer.php';

		$queryNewsletterValues = "select id, subject, template, content, content_text, attachment, format, priority, sender_email, sender_name, return_path, status, count, date_create, date_sent from ".DBPREFIX."module_newsletter where id=".$NewsletterID."";
		$objResultNewsletterValues = $objDatabase->Execute($queryNewsletterValues);
		if ($objResultNewsletterValues !== false) {
			$subject 		= $objResultNewsletterValues->fields['subject'];
			$template 		= $objResultNewsletterValues->fields['template'];
			$content 		= $objResultNewsletterValues->fields['content'];
			$content_text 	= $objResultNewsletterValues->fields['content_text'];
			$attachment 	= $objResultNewsletterValues->fields['attachment'];
			$format 		= $objResultNewsletterValues->fields['format'];
			$priority 		= $objResultNewsletterValues->fields['priority'];
			$sender_email 	= $objResultNewsletterValues->fields['sender_email'];
			$sender_name 	= $objResultNewsletterValues->fields['sender_name'];
			$return_path 	= $objResultNewsletterValues->fields['return_path'];
			$status 		= $objResultNewsletterValues->fields['status'];
			$count 			= $objResultNewsletterValues->fields['count'];
			$date_create 	= $objResultNewsletterValues->fields['date_create'];
			$date_sent 		= $objResultNewsletterValues->fields['date_sent'];
		}
		/* 
		$queryBCC = "select setvalue from ".DBPREFIX."module_newsletter_settings where setvalue='bcc_mail'";
		$objResultBCC = $objDatabase->Execute($queryBCC);
		if ($objResultBCC !== false) {
			$bcc 		= $objResultBCC->fields['setvalue'];
		}
		*/
		$queryBreak = "select setvalue from ".DBPREFIX."module_newsletter_settings where setvalue='text_break_after'";
		$objResultBreak = $objDatabase->Execute($queryBreak);
		if ($objResultBreak !== false) {
			$break 		= $objResultBreak->fields['setvalue'];
		}
		$break = (intval($break)==0) ? 80 : $break;

		$HTML_TemplateSource = $this->GetTemplateSource($template, 'html');
		$TEXT_TemplateSource = $this->GetTemplateSource($template, 'text');

		$NewsletterBody_HTML = $this->ParseNewsletter($UserID, $subject, $content, $HTML_TemplateSource, "html", $TargetEmail);
		$NewsletterBody_TEXT = $this->ParseNewsletter($UserID, $subject, $content_text, $TEXT_TemplateSource, "text", $TargetEmail);
		$NewsletterBody_TEXT = wordwrap($NewsletterBody_TEXT, $break);


		$mail = new phpmailer();
		$mail->From 	= $sender_email;
		$mail->FromName = $sender_name;
		$mail->AddReplyTo($return_path);
		$mail->Subject 	= $subject;
		$mail->Priority = $priority;
		//$mail->AddBCC($bcc, '');
		switch ($format){
			case "text/html":
				$mail->Body 	= $NewsletterBody_HTML;
				$mail->AltBody 	= $NewsletterBody_TEXT;
			break;
			case "html":
				$mail->IsHTML(true);
				$mail->Body 	= $NewsletterBody_HTML;
			break;
			case "text":
				$mail->IsHTML(false);
				$mail->Body 	= $NewsletterBody_TEXT;
			break;
			default:
				$mail->Body 	= $NewsletterBody_HTML;
				$mail->AltBody 	= $NewsletterBody_TEXT;
			break;
		}
		$queryATT 		= "SELECT newsletter, file_name FROM ".DBPREFIX."module_newsletter_attachment where newsletter=".$NewsletterID."";
		$objResultATT 	= $objDatabase->Execute($queryATT);
		if ($objResultATT !== false) {
			while (!$objResultATT->EOF) {
				$mail->AddAttachment(ASCMS_NEWSLETTER_ATTACH_PATH."/".$objResultATT->fields['file_name'], $objResultATT->fields['file_name']);
				$objResultATT->MoveNext();
			}
		}

		$mail->AddAddress($TargetEmail);

		if($mail->Send()){
			$ReturnVar = true;
			if($TmpEntry==1){
				// Insert TMP-ENTRY Sended Email & Count++
				// ---------------------------------------
				$objResultIM = $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_tmp_sending
												SET sendt=1 where email='".$TargetEmail."'");
				$count ++;
				$objResultUPDATE 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter
														SET count='".$count."'
														WHERE id=".$NewsletterID."");
				$queryCheck 	= "SELECT newsletter, email, sendt FROM ".DBPREFIX."module_newsletter_tmp_sending where newsletter='".$NewsletterID."' and sendt=0";
				$objResultCheck = $objDatabase->Execute($queryCheck);
				$countCheck 	= $objResultCheck->RecordCount();
				if ($countCheck == 0) {
					$objResultUPDATE 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter
														SET status=1
														WHERE id=".$NewsletterID."");
				}
			}
		}else{
			$ReturnVar = false;
		}
		$mail->ClearAddresses();
		$mail->ClearAttachments();

		return $ReturnVar;
	}

	function GetTemplateSource($TemplateID, $format){
		global $objDatabase;
		$TemplateSource = '';
		$queryPN = "select id, name, description, ".$format." from ".DBPREFIX."module_newsletter_template where id=".$TemplateID."";
		$objResultPN = $objDatabase->Execute($queryPN);
		if ($objResultPN !== false) {
			$TemplateSource = $objResultPN->fields[$format];
		}
		return $TemplateSource;
	}

	function ParseNewsletter($UserID, $subject, $content_text, $TemplateSource, $format, $TargetEmail){
		global $objDatabase, $_ARRAYLANG;
		$NewsletterBody = '';

		if($UserID!=0){
			$queryPN = "select id, code, email, title, lastname, firstname, street, zip, city, country, phone, birthday, status, emaildate from ".DBPREFIX."module_newsletter_user where id=".$UserID."";
			$objResultPN = $objDatabase->Execute($queryPN);

			if ($objResultPN !== false) {
			    $code   = $objResultPN->fields['code'];
			    $lastname  = $objResultPN->fields['lastname'];
			    $firstname  = $objResultPN->fields['firstname'];
			    $street  = $objResultPN->fields['street'];
			    $zip   = $objResultPN->fields['zip'];
			    $city   = $objResultPN->fields['city'];
			    $country  = $objResultPN->fields['country'];
			    $birthday  = $objResultPN->fields['birthday'];
			    $status  = $objResultPN->fields['status'];
			    $email   = $objResultPN->fields['email'];
			    $phone   = $objResultPN->fields['phone'];

			    switch($objResultPN->fields['title']){
					case 'm':
						$title = $_ARRAYLANG['TXT_NEWSLETTER_MALE'];
						break;
					case 'f':
						$title = $_ARRAYLANG['TXT_NEWSLETTER_FEMALE'];
						break;
					default:
						$title = '';
						break;
			    }

			    $array_1 = array('[[email]]', '[[title]]', '[[lastname]]', '[[firstname]]', '[[street]]', '[[zip]]', '[[city]]', '[[country]]', '[[phone]]', '[[birthday]]');
				$array_2 = array($email, $title, $lastname, $firstname, $street, $zip, $city, $country, $phone, $birthday);

				$content_text 	= str_replace($array_1, $array_2, $content_text);
				$TemplateSource = str_replace($array_1, $array_2, $TemplateSource);
			}
		}

		if($format=="text"){
			$array_1 = array('[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$array_2 = array($this->GetProfileSource($code, $UserID, "text"), $this->GetUnsubscribeSource($code, $UserID, "text"), date(d).".".date(m).".".date(Y));
			$content_text = str_replace($array_1, $array_2, $content_text);
		}else{
			$array_1 = array('[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
			$array_2 = array($this->GetProfileSource($code, $UserID, "text"), $this->GetUnsubscribeSource($code, $UserID, "html"), date(d).".".date(m).".".date(Y));
			$content_text = str_replace($array_1, $array_2, $content_text);

			preg_match_all("|src=\"(.*)\"|U",$content_text,$allImg, PREG_PATTERN_ORDER);
			$size = sizeof($allImg[1]);
			$i = 0;
			$port = $_SERVER['SERVER_PORT'] != 80 ? ':'.intval($_SERVER['SERVER_PORT']) : '';
			while ($i < $size) {
				$URLforReplace = $allImg[1][$i];
				$ReplaceWith = '"'.ASCMS_PROTOCOL.'://'.$_SERVER['SERVER_NAME'].$port.$URLforReplace.'"';
				$content_text = str_replace('"'.$URLforReplace.'"', $ReplaceWith, $content_text);
				$i++;
			}

		}

		$array_1 		= array('[[profile_setup]]', '[[unsubscribe]]', '[[date]]');
		$array_2 		= array($this->GetProfileSource($code, $UserID, $format), $this->GetUnsubscribeSource($code, $UserID, $format), date(d).".".date(m).".".date(Y));
		$TemplateSource = str_replace($array_1, $array_2, $TemplateSource);

		$NewsletterBody = str_replace("[[subject]]", $subject, $TemplateSource);
		$NewsletterBody = str_replace("[[content]]", $content_text, $TemplateSource);

		return $NewsletterBody;
	}

	function GetUnsubscribeSource($code, $UserID, $format)
	{
		global $objDatabase, $_ARRAYLANG, $_CONFIG;

		if($format=="html"){
			$UnsubscribeSource = '<a href="'.ASCMS_PROTOCOL.'://'.$_CONFIG['domainUrl'].ASCMS_PATH_OFFSET.'/index.php?section=newsletter&code='.$code.'&cmd=unsubscribe">'.$_ARRAYLANG['TXT_UNSUBSCRIBE'].'</a>';
		}else{
			$UnsubscribeSource = $_ARRAYLANG['TXT_UNSUBSCRIBE'].' '.ASCMS_PROTOCOL.'://'.$_CONFIG['domainUrl'].ASCMS_PATH_OFFSET.'/index.php?section=newsletter&code='.$code.'&cmd=unsubscribe'."\n\n";
		}

		return $UnsubscribeSource;
	}



	function GetProfileSource($code, $UserID, $format)
	{
		global $objDatabase, $_ARRAYLANG, $_CONFIG;

		if($format=="html"){
			$ProfileSource = '<a href="'.ASCMS_PROTOCOL.'://'.$_CONFIG['domainUrl'].ASCMS_PATH_OFFSET.'/index.php?section=newsletter&code='.$code.'&cmd=profile">'.$_ARRAYLANG['TXT_EDIT_PROFILE'].'</a>';
		}else{
			$ProfileSource = $_ARRAYLANG['TXT_EDIT_PROFILE'].' '.ASCMS_PROTOCOL.'://'.$_CONFIG['domainUrl'].ASCMS_PATH_OFFSET.'/index.php?section=newsletter&code='.$code.'&cmd=profile'."\n\n";
		}
		return $ProfileSource;
	}



	function _getNewsPage()
	{
	    global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = 'Newsmeldungen';
	    $this->_objTpl->loadTemplateFile('newsletter_news.html');
	    $this->_objTpl->setVariable(array(
	        'TXT_SHOW_NEWS'                  	=> $_ARRAYLANG['TXT_SHOW_NEWS'],
	        'TXT_SELECT_ALL'                  	=> $_ARRAYLANG['TXT_SELECT_ALL'],
	        'TXT_NEWSLETTER_CREATE_FROM_NEWS'   => $_ARRAYLANG['TXT_NEWSLETTER_CREATE_FROM_NEWS'],
	        'TXT_TITLE'   						=> 'Newsmeldungen',
	        'TXT_COUNT'   						=> 'Anzahl festlegen',
	        'TXT_PREVIEW'   					=> 'Vorschau',
	    ));
	    $this->_objTpl->setVariable("NEWSLETTER_CONTENT_TITLE", $this->_NEWSLETTER_CONFIG['newsletterContentTitle']);
	    if ($_POST['newslimit']=="" OR !is_numeric($_POST['newslimit']) ) {
		    $newslimit = 20;
		} else {
		    $newslimit = intval($_POST['newslimit']);
		}
	    $objNews = $objDatabase->SelectLimit("SELECT `id`, `date`, `title`, `text` FROM ".DBPREFIX."module_news ORDER BY id DESC", $newslimit);
	    if ($objNews !== false) {
		    while (!$objNews->EOF) {
			    $this->_objTpl->setVariable(array(
			    	'NEWSLETTER_NEWS_DATE'	=> date(ASCMS_DATE_SHORT_FORMAT, $objNews->fields['date']),
			    	'NEWSLETTER_NEWS_TITLE'	=> $objNews->fields['title']."\n"
			    ));
			    $this->_objTpl->parse("row");

			    $this->_objTpl->setVariable(array(
			    	'NEWSLETTER_NEWS_DETAIL_DATE'	=> date(ASCMS_DATE_SHORT_FORMAT, $objNews->fields['date']),
			    	'NEWSLETTER_NEWS_DETAIL_TITLE'	=> $objNews->fields['title']
			    ));
			    $newstext = substr(ltrim(strip_tags($objNews->fields['text'])), 0, 800);
			    $newstext .= "[....]";
			    $newslink = $this->newsletterUri.ASCMS_PROTOCOL."://".$_SERVER['HTTP_HOST'].ASCMS_PATH_OFFSET."/index.php?section=news&cmd=details&newsid=".$objNews->fields['id'];
			    $this->_objTpl->setVariable(array(
			    	'NEWSLETTER_NEWS_DETAIL_TEXT' => $newstext,
		        	'TXT_LINK_TO_REPORT_INFO_SOURCES' 	=> $_ARRAYLANG['TXT_LINK_TO_REPORT_INFO_SOURCES'],
			    	'NEWSLETTER_NEWS_DETAIL_LINK' => $newslink
			    ));
			    $this->_objTpl->parse("detailrow");

			    $objNews->MoveNext();
		    }
	    }
	}



	function exportuser(){
		global $objDatabase, $_ARRAYLANG;



		$this->_pageTitle = $_ARRAYLANG['TXT_EXPORT'];

		if (isset($_POST['newsletter_user_export'])) {
			$this->_pageTitle = $_ARRAYLANG['TXT_EXPORT'];
			$this->_objTpl->addBlockfile('NEWSLETTER_USER_FILE', 'module_newsletter_user_export_list', 'module_newsletter_user_export_list.html');
			$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_EXPORT']);


			// Export nach kategorien
			$WhereStatement = " and (";
			if (isset($_POST['selectedCat'])) {
				foreach ($_POST['selectedCat'] as $intKey => $intCatId) {
					if($WhereStatement==" and ("){
						$NextCar = "";
					}else{
						$NextCar = " or ";
					}
					$WhereStatement .= $NextCar." category=".$intCatId." ";
				}
			}
			$WhereStatement .= ")";

			$query		= "SELECT * FROM ".DBPREFIX."module_newsletter_rel_user_cat right join ".DBPREFIX."module_newsletter_user on ".DBPREFIX."module_newsletter_rel_user_cat.user=".DBPREFIX."module_newsletter_user.id where 1=1 ".$WhereStatement." GROUP BY user";
			$objResult 	= $objDatabase->Execute($query);
			$StringForFile = '';
			$separetor = $_POST["separetor"];
			if ($objResult !== false) {
				while (!$objResult->EOF) {

					if($_POST["email"]=="1"){
						$StringForFile .= $objResult->fields['email'].$separetor;
					}
					if($_POST["title"]=="1"){
						$StringForFile .= $objResult->fields['title'].$separetor;
					}
					if($_POST["lastname"]=="1"){
						$StringForFile .= $objResult->fields['lastname'].$separetor;
					}
					if($_POST["firstname"]=="1"){
						$StringForFile .= $objResult->fields['firstname'].$separetor;
					}
					if($_POST["street"]=="1"){
						$StringForFile .= $objResult->fields['street'].$separetor;
					}
					if($_POST["zip"]=="1"){
						$StringForFile .= $objResult->fields['zip'].$separetor;
					}
					if($_POST["city"]=="1"){
						$StringForFile .= $objResult->fields['city'].$separetor;
					}
					if($_POST["country"]=="1"){
						$StringForFile .= $objResult->fields['country'].$separetor;
					}
					if($_POST["phone"]=="1"){
						$StringForFile .= $objResult->fields['phone'].$separetor;
					}
					if($_POST["birthday"]=="1"){
						$StringForFile .= $objResult->fields['birthday'].$separetor;
					}
					$StringForFile .= chr(13).chr(10);
					$objResult->MoveNext();
				}
			}

			$this->_objTpl->setVariable('USER_LIST', $StringForFile);

			$this->_objTpl->parse('module_newsletter_user_export_list');
		} else {
			$this->_objTpl->addBlockfile('NEWSLETTER_USER_FILE', 'module_newsletter_user_export', 'module_newsletter_user_export.html');
			$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_SETTINGS']);


			$category_values = '';
		$query 		= "SELECT id, name FROM ".DBPREFIX."module_newsletter_category order by name";
		$objResult 	= $objDatabase->Execute($query);
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$category_values .= '<input type="checkbox" checked name="selectedCat[]" value="'.$objResult->fields['id'].'"> '.$objResult->fields['name']."<br/>";
				$objResult->MoveNext();
			}
		}

		$this->_objTpl->setVariable(array(
			'TXT_EMAIL_ADDRESS'		=> $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
			'TXT_LASTNAME'			=> $_ARRAYLANG['TXT_LASTNAME'],
			'TXT_FIRSTNAME'			=> $_ARRAYLANG['TXT_FIRSTNAME'],
			'TXT_STREET'			=> $_ARRAYLANG['TXT_STREET'],
			'TXT_ZIP'				=> $_ARRAYLANG['TXT_ZIP'],
			'TXT_CITY'				=> $_ARRAYLANG['TXT_CITY'],
			'TXT_COUNTRY'			=> $_ARRAYLANG['TXT_COUNTRY'],
			'TXT_PHONE'				=> $_ARRAYLANG['TXT_PHONE'],
			'TXT_BIRTHDAY'			=> $_ARRAYLANG['TXT_BIRTHDAY'],
			'TXT_OPEN_ISSUE'		=> $_ARRAYLANG['TXT_OPEN_ISSUE'],
			'TXT_ACTIVE'			=> $_ARRAYLANG['TXT_ACTIVE'],
			'TXT_EXPORT'			=> $_ARRAYLANG['TXT_EXPORT'],
			'TXT_CHOOSE_SEPERATOR' 	=> $_ARRAYLANG['TXT_CHOOSE_SEPERATOR'],
			'TXT_SELECT_ALL'		=> $_ARRAYLANG['TXT_SELECT_ALL'],
			'TXT_EDIT'				=> $_ARRAYLANG['TXT_EDIT'],
			'TXT_ADD'				=> $_ARRAYLANG['TXT_ADD'],
			'TXT_IMPORT'			=> $_ARRAYLANG['TXT_IMPORT'],
			'TXT_EXPORT'			=> $_ARRAYLANG['TXT_EXPORT'],
			'TXT_NEWSLETTER_CATEGORYS'=> $_ARRAYLANG['TXT_NEWSLETTER_CATEGORYS'],
			'CATEGORY_VALUES'		=> $category_values,
			'TXT_USER_TITLE'		=> 'Anrede',
			));


		$this->_objTpl->parse('module_newsletter_user_export');
		}
	}


	function edituserSort()
	{
		global $_CONFIG, $objDatabase;
		$output = '';
		$fieldValues = array('status', 'email', 'lastname', 'firstname', 'street', 'zip', 'city', 'country', 'emaildate', );
		$field = (!empty($_GET['field'])) ? contrexx_addslashes($_GET['field']) : 'emaildate';
		$order = (!empty($_GET['order'])) ? contrexx_addslashes($_GET['order']) : 'asc';
		$listId = (!empty($_GET['list'])) ? intval($_GET['list']) : '';
		$limit = (!empty($_GET['limit'])) ? intval($_GET['limit']) : $_CONFIG['corePagingLimit'];
		if(!in_array($field, $fieldValues) && ( $order != 'asc' || $order != 'desc' )){
			return false;
		}
		if($listId == ''){
			$query = "SELECT id, email, lastname, firstname, street, zip, city, country, `status`, emaildate
			FROM ".DBPREFIX."module_newsletter_user
			ORDER BY $field $order";
		}else{
			$query = "SELECT tblUser.id, email, lastname, firstname, street, zip, city, country, `status`, emaildate
			FROM ".DBPREFIX."module_newsletter_user AS tblUser, "
				  .DBPREFIX."module_newsletter_rel_user_cat AS tblRel
			WHERE tblUser.id=tblRel.user and tblRel.category=".$listId."
			ORDER BY $field $order";
		}

		$objRS = $objDatabase->SelectLimit($query, $limit);
		$limit = ($limit > $objRS->RecordCount()) ? $objRS->RecordCount() : $limit;
		for($i=0; $i<$limit; $i++){
			$output .= $objRS->fields['id'];
			$output .= '#'.$objRS->fields['status'];
			$output .= '#'.$objRS->fields['email'];
			$output .= '#'.$objRS->fields['lastname'];
			$output .= '#'.$objRS->fields['firstname'];
			$output .= '#'.$objRS->fields['street'];
			$output .= '#'.$objRS->fields['zip'];
			$output .= '#'.$objRS->fields['city'];
			$output .= '#'.$objRS->fields['country'];
			$output .= '#'.date(ASCMS_DATE_FORMAT, $objRS->fields['emaildate']);
			$output .= '%';
			$objRS->MoveNext();
		}
		die($output);
	}


	function importuser(){
		global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = $_ARRAYLANG['TXT_IMPORT'];
		$this->_objTpl->addBlockfile('NEWSLETTER_USER_FILE', 'module_newsletter_user_import', 'module_newsletter_user_import.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_UPLOAD_FILE']);
		$this->_objTpl->setVariable(array(
			'JAVASCRIPTCODE'			=> $this->JSimportuser(),
			'TXT_EDIT'					=> $_ARRAYLANG['TXT_EDIT'],
			'TXT_ADD'					=> $_ARRAYLANG['TXT_ADD'],
			'TXT_IMPORT'				=> $_ARRAYLANG['TXT_IMPORT'],
			'TXT_EXPORT'				=> $_ARRAYLANG['TXT_EXPORT'],
			'TXT_HELP'					=> $_ARRAYLANG['TXT_HELP'],
			'TXT_IMPORT_HELP'			=> $_ARRAYLANG['TXT_IMPORT_HELP'],
			'CATEGORY_DROPDOWN' 		=> $this->CategoryDropDown('category', 0, 'onchange="syncDropDown(this.options.selectedIndex);"'),
			'TXT_IMPORT_IN_CATEGORY'	=> $_ARRAYLANG['TXT_IMPORT_IN_CATEGORY'],
			'TXT_ENTER_EMAIL_ADDRESS' 	=> $_ARRAYLANG['TXT_ENTER_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_IMPORT_HINT'=> $_ARRAYLANG['TXT_NEWSLETTER_IMPORT_HINT'],
		));
		if($_REQUEST['category'] == 'selectcategory'){
			$this->_strErrMessage = $_ARRAYLANG['TXT_NEWSLETTER_SELECT_CATEGORY'];
			return false;
		}

		if($_POST["import"]=="exe"){
			$GSdatei_name = $_FILES['GSdatei']['name'];

			if($GSdatei_name!=""){
				$_FILES['GSdatei']['name'] = str_replace("%","",$_FILES['GSdatei']['name']);
				move_uploaded_file($_FILES['GSdatei']['tmp_name'], ASCMS_DOCUMENT_ROOT."/tmp/".$_FILES['GSdatei']['name']);

				$LineArray = file(ASCMS_DOCUMENT_ROOT."/tmp/".$_FILES['GSdatei']['name']);
				$LinesCount = count($LineArray);
				$EmailCount = 0;
				$BadEmails = 0;
				$ExistEmails = 0;
				$NewEmails = 0;

				foreach ($LineArray as $LineValue) {
					list ($email, $lastname, $firstname, $street, $zip, $city, $country, $phone, $birthday) = split("[,;]", $LineValue);
					if($this->check_email($email)!=1){
						$BadEmails ++;
					}else{
						$EmailCount ++;
						$queryCHECK 		= "SELECT id FROM ".DBPREFIX."module_newsletter_user where email='".$email."'";
						$objResultCHECK 	= $objDatabase->Execute($queryCHECK);
						$count 		= $objResultCHECK->RecordCount();
						if ($count > 0) {
							$ExistEmails ++;
						}else{

							$NewEmails ++;
							$objResult 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_user
													(code, email, lastname, firstname, street, zip, city, country, phone, birthday, status, emaildate)
													VALUES ('".$this->EmailCode()."', '".$email."', '".htmlspecialchars(strip_tags($lastname))."', '".htmlspecialchars(strip_tags($firstname))."', '".htmlspecialchars(strip_tags($street))."', '".htmlspecialchars(strip_tags($zip))."', '".htmlspecialchars(strip_tags($city))."', '".htmlspecialchars(strip_tags($country))."', '".htmlspecialchars(strip_tags($phone))."', '".htmlspecialchars(strip_tags($birthday))."', 1, '".$this->DateForDB()."')");

							$queryPS = "select LAST_INSERT_ID() as lastid from ".DBPREFIX."module_newsletter_user";
							$objResultPS = $objDatabase->Execute($queryPS);
							if ($objResultPS !== false) {
								$CreatedID = $objResultPS->fields['lastid'];
							}
							if($_REQUEST['category']==""){
								$queryIC 		= "SELECT id FROM ".DBPREFIX."module_newsletter_category";
								$objResultIC 	= $objDatabase->Execute($queryIC);
								if ($objResultIC !== false) {
									while (!$objResultIC->EOF) {
										$objResultICR 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat
														(user, category)
														VALUES (".$CreatedID.", ".$objResultIC->fields['id'].")");
										$objResultIC->MoveNext();
									}
								}
							}else{
								$objResultICR 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat
												(user, category)
												VALUES (".$CreatedID.", ".$_REQUEST['category'].")");
							}

						}
					}
				}
				$this->_strOkMessage = $_ARRAYLANG['TXT_DATA_IMPORT_SUCCESSFUL']."<br/>".$_ARRAYLANG['TXT_CORRECT_EMAILS'].": ".$EmailCount."<br/>".$_ARRAYLANG['TXT_NOT_VALID_EMAILS'].": ".$BadEmails."<br/>".$_ARRAYLANG['TXT_EXISTING_EMAILS'].": ".$ExistEmails."<br/>".$_ARRAYLANG['TXT_NEW_ADDED_EMAILS'].": ".$NewEmails;
			}elseif($_REQUEST["Emails"]!=""){
				$NLine = chr(13).chr(10);
				$EmailList = str_replace(array(']','[',"\t","\n","\r"), ' ', $_REQUEST["Emails"]);
				$EmailArray = split("[ '\",;:<>".$NLine."]", stripslashes($EmailList));
				$LinesCount = count($EmailArray);
				$EmailCount = 0;
				$BadEmails = 0;
				$ExistEmails = 0;
				$NewEmails = 0;
				foreach ($EmailArray as $email) {
					if(empty($email)){ continue; }
					if(!strpos($email,'@')){ continue; }
					if($this->check_email($email) != 1){
						$BadEmails ++;
					}else{
						$EmailCount ++;
						$queryCHECK 		= "SELECT id FROM ".DBPREFIX."module_newsletter_user where email='".$email."'";
						$objResultCHECK 	= $objDatabase->Execute($queryCHECK);
						$count 		= $objResultCHECK->RecordCount();
						if ($count > 0) {
							$ExistEmails ++;
						}else{
							$NewEmails ++;
							$objResult 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_user
														(code, email, status, emaildate)
														VALUES ('".$this->EmailCode()."', '".$email."', 1, '".$this->DateForDB()."')");
							$queryPS = "select LAST_INSERT_ID() as lastid from ".DBPREFIX."module_newsletter_user";
							$objResultPS = $objDatabase->Execute($queryPS);
							if ($objResultPS !== false) {
								$CreatedID = $objResultPS->fields['lastid'];
							}

							if($_REQUEST['category']==""){
								$queryIC 		= "SELECT id FROM ".DBPREFIX."module_newsletter_category";
								$objResultIC 	= $objDatabase->Execute($queryIC);
								if ($objResultIC !== false) {
									while (!$objResultIC->EOF) {
										$objResultICR 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat
														(user, category)
														VALUES (".$CreatedID.", ".$objResultIC->fields['id'].")");
										$objResultIC->MoveNext();
									}
								}
							}else{
								$objResultICR 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat
												(user, category)
												VALUES (".$CreatedID.", ".$_REQUEST['category'].")");
							}

						}
					}
				}
				$this->_strOkMessage = $_ARRAYLANG['TXT_DATA_IMPORT_SUCCESSFUL']."<br/>".$_ARRAYLANG['TXT_CORRECT_EMAILS'].": ".$EmailCount."<br/>".$_ARRAYLANG['TXT_NOT_VALID_EMAILS'].": ".$BadEmails."<br/>".$_ARRAYLANG['TXT_EXISTING_EMAILS'].": ".$ExistEmails."<br/>".$_ARRAYLANG['TXT_NEW_ADDED_EMAILS'].": ".$NewEmails;
			}

		}

		$this->_objTpl->parse('module_newsletter_user_import');
	}

	function check_email($email) {
		return preg_match('#^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]{2,}(\.[a-zA-Z0-9-]+)*\.(([0-9]{1,3})|([a-zA-Z]{2,3})|(aero|coop|info|museum|name))$#', $email);
	}


	function overview(){
		global $objDatabase, $_ARRAYLANG;
		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_ADMINISTRATION'];
		$this->_objTpl->loadTemplateFile('module_newsletter_administration.html');

		$limit;
		$objSettings = $objDatabase->SelectLimit("SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setname='overview_entries_limit'", 1);
		if ($objSettings !== false) {
			$limit = $objSettings->fields['setvalue'];
		}

		$this->_listOverview($limit);
		$this->_mailOverview($limit);
		$this->_recipientOverview($limit);

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_ADMINISTRATION'	=> $_ARRAYLANG['TXT_NEWSLETTER_ADMINISTRATION'],
			'TXT_NEWSLETTER_CREATE_NEW_EMAIL'	=> $_ARRAYLANG['TXT_NEWSLETTER_CREATE_NEW_EMAIL'],
			'TXT_NEWSLETTER_ADD_NEW_LIST'		=> $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_LIST'],
			'TXT_NEWSLETTER_IMPORT_RECIPIENTS'	=> $_ARRAYLANG['TXT_NEWSLETTER_IMPORT_RECIPIENTS'],
			'TXT_NEWSLETTER_EXPORT_RECIPIENTS'	=> $_ARRAYLANG['TXT_NEWSLETTER_EXPORT_RECIPIENTS'],

		));

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_NOT_SENT_NEWSLETTERS'		=> $_ARRAYLANG['TXT_NEWSLETTER_NOT_SENT_NEWSLETTERS'],
			'TXT_NEWSLETTER_SENT_NEWSLETTERS'			=> $_ARRAYLANG['TXT_NEWSLETTER_SENT_NEWSLETTERS'],
			'TXT_NEWSLETTER_ANNOUNCED_USERS'			=> $_ARRAYLANG['TXT_NEWSLETTER_ANNOUNCED_USERS'],
			'NEWSLETTER_RECIPIENT_COUNT'				=> $this->UserCount(),
			'VALUE_SENT_NEWSLETTERS'					=> $this->NewsletterSendCount(),
			'VALUE_NOT_SENT_NEWSLETTERS'				=> $this->NewsletterNotSendCount()
			));

	}

	function newsletterOverview(){
		global $objDatabase, $_ARRAYLANG;

		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER'];
		$this->_objTpl->loadTemplateFile('newsletter_newsletter.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_ACTION']);

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_EDIT'		=> $_ARRAYLANG['TXT_NEWSLETTER_EDIT'],
			'TXT_NEWSLETTER_NEW'		=> $_ARRAYLANG['TXT_NEWSLETTER_NEW'],
			'TXT_SEND_NEWSLETTER'		=> $_ARRAYLANG['TXT_SEND_NEWSLETTER'],
			'TXT_NEWSLETTER_EDIT_SEND' => $_ARRAYLANG["TXT_NEWSLETTER_EDIT_SEND"]
			));
	}

	function _users()
	{
		global $objDatabase, $_ARRAYLANG;

		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_RECIPIENTS'];
		$this->_objTpl->loadTemplateFile('module_newsletter_user.html');

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_OVERVIEW'	=> $_ARRAYLANG['TXT_NEWSLETTER_OVERVIEW'],
			'TXT_NEWSLETTER_IMPORT'		=> $_ARRAYLANG['TXT_NEWSLETTER_IMPORT'],
			'TXT_NEWSLETTER_EXPORT'		=> $_ARRAYLANG['TXT_NEWSLETTER_EXPORT'],
			'TXT_NEWSLETTER_ADD_USER'	=> $_ARRAYLANG['TXT_NEWSLETTER_ADD_USER'],
		));

		if (!isset($_REQUEST['tpl'])) {
			$_REQUEST['tpl'] = '';
		}

		switch ($_REQUEST['tpl']) {
			case 'edit':
				$this->_editUser();
				break;

			case 'import':
				$this->importuser();
				break;

			case 'export':
				$this->exportuser();
				break;

			default:
				$this->_userList();
				break;
		}
	}

	function configOverview(){
		global $objDatabase, $_ARRAYLANG;

		$this->_pageTitle = $_ARRAYLANG['TXT_SETTINGS'];
		$this->_objTpl->loadTemplateFile('newsletter_configuration.html');
		$this->_objTpl->setVariable('TXT_TITLE', $_ARRAYLANG['TXT_SETTINGS']);


		$this->_objTpl->setVariable(array(
			'TXT_DISPATCH_SETINGS'	=> $_ARRAYLANG['TXT_DISPATCH_SETINGS'],
			'TXT_GENERATE_HTML'		=> $_ARRAYLANG['TXT_GENERATE_HTML'],
			'TXT_CONFIRM_MAIL'		=> "Aktivierungs E-Mail"
			));

	}

	function UserCount(){
		global $objDatabase;
		$objResult_value = $objDatabase->SelectLimit("SELECT
													count(*) as counter
													FROM ".DBPREFIX."module_newsletter_user
													", 1);
		if ($objResult_value !== false && !$objResult_value->EOF) {
			return $objResult_value->fields["counter"];
		}else{
			return 0;
		}
	}

	function NewsletterSendCount(){
		global $objDatabase;
		$objResult_value = $objDatabase->SelectLimit("SELECT
													count(*) as counter
													FROM ".DBPREFIX."module_newsletter
													WHERE status=1", 1);
		if ($objResult_value !== false && !$objResult_value->EOF) {
			return $objResult_value->fields["counter"];
		}else{
			return 0;
		}
	}

	function NewsletterNotSendCount(){
		global $objDatabase;
		$objResult_value = $objDatabase->SelectLimit("SELECT
													count(*) as counter
													FROM ".DBPREFIX."module_newsletter
													WHERE status=0", 1);
		if ($objResult_value !== false && !$objResult_value->EOF) {
			return $objResult_value->fields["counter"];
		}else{
			return 0;
		}
	}

	function _addUser($email, $title, $lastname, $firstname, $street, $zip, $city, $country, $phone, $birthday, $status, $arrLists)
	{
		global $objDatabase;
		
		if ($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_user (
		`code`,
		`email`,
		`title`,
		`lastname`,
		`firstname`,
		`street`,
		`zip`,
		`city`,
		`country`,
		`phone`,
		`birthday`,
		`status`,
		`emaildate`
		) VALUES (
		'".$this->EmailCode()."',
		'".contrexx_addslashes($email)."',
		'".$title."',
		'".contrexx_addslashes($lastname)."',
		'".contrexx_addslashes($firstname)."',
		'".contrexx_addslashes($street)."',
		'".contrexx_addslashes($zip)."',
		'".contrexx_addslashes($city)."',
		'".contrexx_addslashes($country)."',
		'".contrexx_addslashes($phone)."',
		'".contrexx_addslashes($birthday)."',
		".intval($status).",
		".time().")") !== false) {
			if ($this->_setRecipientLists($objDatabase->Insert_ID(), $arrLists)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function _updateUser($id, $email, $title, $lastname, $firstname, $street, $zip, $city, $country, $phone, $birthday, $status, $arrLists)
	{
		global $objDatabase;
		
		if ($objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_user SET
		`email`='".contrexx_addslashes($email)."',
		`title`='".$title."',
		`lastname`='".contrexx_addslashes($lastname)."',
		`firstname`='".contrexx_addslashes($firstname)."',
		`street`='".contrexx_addslashes($street)."',
		`zip`='".contrexx_addslashes($zip)."',
		`city`='".contrexx_addslashes($city)."',
		`country`='".contrexx_addslashes($country)."',
		`phone`='".contrexx_addslashes($phone)."',
		`birthday`='".contrexx_addslashes($birthday)."',
		`status`=".intval($status)."
		WHERE id=".$id) !== false) {
			if ($this->_setRecipientLists($id, $arrLists)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function _isUniqueRecipientEmail($email, $recipientId)
	{
		global $objDatabase;
		
		$objRecipient = $objDatabase->SelectLimit("SELECT id FROM ".DBPREFIX."module_newsletter_user WHERE email='".contrexx_addslashes($email)."' AND id!=".$recipientId);
		if ($objRecipient !== false && $objRecipient->RecordCount() == 0) {
			return true;
		} else {
			return false;
		}
	}
	
	function _editUser()
	{
		global $objDatabase, $_ARRAYLANG;

		$recipientId = isset($_REQUEST['id']) ? intval($_REQUEST['id']) : 0;
		$recipientEmail = '';
		$recipientTitle = '';
		$recipientLastname = '';
		$recipientFirstname = '';
		$recipientStreet = '';
		$recipientZip = '';
		$recipientCity = '';
		$recipientCountry = '';
		$recipientPhone = '';
		$recipientBirthday = '';
		$recipientStatus = 1;
		$arrAssociatedLists = array();

		if (isset($_POST['newsletter_recipient_email'])) {
			$recipientEmail = $_POST['newsletter_recipient_email'];
		}
		if (isset($_POST['newsletter_recipient_title'])) {
			$recipientTitle = in_array($_POST['newsletter_recipient_title'], array('f', 'm')) ? $_POST['newsletter_recipient_title'] : '';
		}
		if (isset($_POST['newsletter_recipient_lastname'])) {
			$recipientLastname = $_POST['newsletter_recipient_lastname'];
		}
		if (isset($_POST['newsletter_recipient_firstname'])) {
			$recipientFirstname = $_POST['newsletter_recipient_firstname'];
		}
		if (isset($_POST['newsletter_recipient_street'])) {
			$recipientStreet = $_POST['newsletter_recipient_street'];
		}
		if (isset($_POST['newsletter_recipient_zip'])) {
			$recipientZip = $_POST['newsletter_recipient_zip'];
		}
		if (isset($_POST['newsletter_recipient_city'])) {
			$recipientCity = $_POST['newsletter_recipient_city'];
		}
		if (isset($_POST['newsletter_recipient_country'])) {
			$recipientCountry = $_POST['newsletter_recipient_country'];
		}
		if (isset($_POST['newsletter_recipient_phone'])) {
			$recipientPhone = $_POST['newsletter_recipient_phone'];
		}
		if (isset($_POST['newsletter_recipient_birthday'])) {
			$recipientBirthday = $_POST['newsletter_recipient_birthday'];
		}
		if (isset($_POST['newsletter_recipient_status'])) {
			$recipientStatus = $_POST['newsletter_recipient_status'];
		} else {
			$recipientStatus = 0;
		}
		
		if (isset($_POST['newsletter_recipient_associated_list'])) {
			foreach ($_POST['newsletter_recipient_associated_list'] as $listId => $status) {
				if (intval($status) == 1) {
					array_push($arrAssociatedLists, intval($listId));
				}
			}
		}  

		if (isset($_POST['newsletter_recipient_save'])) {
			$objValidator = &new FWValidator();

			if ($objValidator->isEmail($recipientEmail)) {
				if ($this->_isUniqueRecipientEmail($recipientEmail, $recipientId)) {
					if ($recipientId > 0) {
						if ($this->_updateUser($recipientId, $recipientEmail, $recipientTitle, $recipientLastname, $recipientFirstname, $recipientStreet, $recipientZip, $recipientCity, $recipientCountry, $recipientPhone, $recipientBirthday, $recipientStatus, $arrAssociatedLists)) {
							$this->_strOkMessage .= $_ARRAYLANG['TXT_NEWSLETTER_RECIPIENT_UPDATED_SUCCESSFULLY'];
							return $this->_userList();
						} else {
							$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_UPDATE_RECIPIENT'];
						}
					} else {
						if ($this->_addUser($recipientEmail, $recipientTitle, $recipientLastname, $recipientFirstname, $recipientStreet, $recipientZip, $recipientCity, $recipientCountry, $recipientPhone, $recipientBirthday, $recipientStatus, $arrAssociatedLists)) {
							$this->_strOkMessage .= $_ARRAYLANG['TXT_NEWSLETTER_RECIPIENT_SAVED_SUCCESSFULLY'];
							return $this->_userList();
						} else {
							$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_ERROR_SAVE_RECIPIENT'];
						}
					}
				} else {
					$this->_strErrMessage .= $_ARRAYLANG['TXT_NEWSLETTER_DUPLICATE_EMAIL_ADDRESS'];
				}
			} else {
				$this->_strErrMessage .= "Sie mssen eine gltige E-Mail Adresse angeben!";
			}
		} elseif ($recipientId > 0) {
			$objRecipient = $objDatabase->SelectLimit("SELECT email, title, lastname, firstname, street, zip, city, country, phone, birthday, status FROM ".DBPREFIX."module_newsletter_user WHERE id=".$recipientId, 1);
			if ($objRecipient !== false && $objRecipient->RecordCount() == 1) {
				$recipientEmail = $objRecipient->fields['email'];
				$recipientTitle = $objRecipient->fields['title'];
				$recipientLastname = $objRecipient->fields['lastname'];
				$recipientFirstname = $objRecipient->fields['firstname'];
				$recipientStreet = $objRecipient->fields['street'];
				$recipientZip = $objRecipient->fields['zip'];
				$recipientCity = $objRecipient->fields['city'];
				$recipientCountry = $objRecipient->fields['country'];
				$recipientPhone = $objRecipient->fields['phone'];
				$recipientBirthday = $objRecipient->fields['birthday'];
				$recipientStatus = $objRecipient->fields['status'];

				$objList = $objDatabase->Execute("SELECT category FROM ".DBPREFIX."module_newsletter_rel_user_cat WHERE user=".$recipientId);
				if ($objList !== false) {
					while (!$objList->EOF) {
						array_push($arrAssociatedLists, $objList->fields['category']);
						$objList->MoveNext();
					}
				}
			} else {
				return $this->_userList();
			}
		}
		
		$this->_pageTitle = $recipientId > 0 ? $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_RECIPIENT'] : $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_RECIPIENT'];
		$this->_objTpl->addBlockfile('NEWSLETTER_USER_FILE', 'module_newsletter_user_edit', 'module_newsletter_user_edit.html');
		$this->_objTpl->setVariable('TXT_NEWSLETTER_USER_TITLE', $recipientId > 0 ? $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_RECIPIENT'] : $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_RECIPIENT']);

		$arrLists = &$this->_getLists('tblCategory.name');
		$listNr = 0;
		foreach ($arrLists as $listId => $arrList) {
			$column = $listNr % 3;
			$this->_objTpl->setVariable(array(
				'NEWSLETTER_LIST_ID'						=> $listId,
				'NEWSLETTER_LIST_NAME'						=> $arrList['name'],
				'NEWSLETTER_SHOW_RECIPIENTS_OF_LIST_TXT'	=> sprintf($_ARRAYLANG['TXT_NEWSLETTER_SHOW_RECIPIENTS_OF_LIST'], $arrList['name']),
				'NEWSLETTER_LIST_ASSOCIATED'				=> in_array($listId, $arrAssociatedLists) ? 'checked="checked"' : ''
			));
			$this->_objTpl->parse('newsletter_mail_associated_list_'.$column);

			$listNr++;
		}

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_RECIPIENT_ID'			=> $recipientId,
			'NEWSLETTER_RECIPIENT_EMAIL'		=> htmlentities($recipientEmail, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_FEMALE'		=> $recipientTitle == 'f' ? 'checked="checked"' : '',
			'NEWSLETTER_RECIPIENT_MALE'			=> $recipientTitle == 'm' ? 'checked="checked"' : '',
			'NEWSLETTER_RECIPIENT_LASTNAME'		=> htmlentities($recipientLastname, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_FIRSTNAME'	=> htmlentities($recipientFirstname, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_STREET'		=> htmlentities($recipientStreet, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_ZIP'			=> htmlentities($recipientZip, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_CITY'			=> htmlentities($recipientCity, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_COUNTRY'		=> htmlentities($recipientCountry, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_PHONE'		=> htmlentities($recipientPhone, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_BIRTHDAY'		=> htmlentities($recipientBirthday, ENT_QUOTES),
			'NEWSLETTER_RECIPIENT_STATUS'		=> $recipientStatus == '1' ? 'checked="checked"' : ''
		));

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_EMAIL_ADDRESS'	=> $_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_TITLE'			=> $_ARRAYLANG['TXT_NEWSLETTER_TITLE'],
			'TXT_NEWSLETTER_FEMALE'			=> $_ARRAYLANG['TXT_NEWSLETTER_FEMALE'],
			'TXT_NEWSLETTER_MALE'			=> $_ARRAYLANG['TXT_NEWSLETTER_MALE'],
			'TXT_NEWSLETTER_LASTNAME'		=> $_ARRAYLANG['TXT_NEWSLETTER_LASTNAME'],
			'TXT_NEWSLETTER_FIRSTNAME'		=> $_ARRAYLANG['TXT_NEWSLETTER_FIRSTNAME'],
			'TXT_NEWSLETTER_STREET'			=> $_ARRAYLANG['TXT_NEWSLETTER_STREET'],
			'TXT_NEWSLETTER_ZIP'			=> $_ARRAYLANG['TXT_NEWSLETTER_ZIP'],
			'TXT_NEWSLETTER_CITY'			=> $_ARRAYLANG['TXT_NEWSLETTER_CITY'],
			'TXT_NEWSLETTER_COUNTRY'		=> $_ARRAYLANG['TXT_NEWSLETTER_COUNTRY'],
			'TXT_NEWSLETTER_PHONE'			=> $_ARRAYLANG['TXT_NEWSLETTER_PHONE'],
			'TXT_NEWSLETTER_BIRTHDAY'		=> $_ARRAYLANG['TXT_NEWSLETTER_BIRTHDAY'],
			'TXT_NEWSLETTER_ASSOCIATED_LISTS' => $_ARRAYLANG['TXT_NEWSLETTER_ASSOCIATED_LISTS'],
			'TXT_NEWSLETTER_STATUS'			=> $_ARRAYLANG['TXT_NEWSLETTER_STATUS'],
			'TXT_NEWSLETTER_SAVE'			=> $_ARRAYLANG['TXT_NEWSLETTER_SAVE'],

			'JAVASCRIPTCODE'		=> $this->JSadduser()
		));

		$this->_objTpl->parse('module_newsletter_user_edit');
	}

	function _userList()
	{
		global $objDatabase, $_ARRAYLANG, $_CONFIG, $_CORELANG;

		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_USER_ADMINISTRATION'];
		$this->_objTpl->addBlockfile('NEWSLETTER_USER_FILE', 'module_newsletter_user_overview', 'module_newsletter_user_overview.html');

		$limit = (!empty($_GET['limit'])) ? intval($_GET['limit']) : $_CONFIG['corePagingLimit'];

		$this->_objTpl->setVariable(array(
			'TXT_TITLE'							=> $_ARRAYLANG['TXT_SEARCH'],
			'TXT_CHANGELOG_SUBMIT'	   			=> $_CORELANG['TXT_MULTISELECT_SELECT'],
			'TXT_CHANGELOG_SUBMIT_DEL' 			=> $_CORELANG['TXT_MULTISELECT_DELETE'],
			'TXT_SELECT_ALL'         			=> $_CORELANG['TXT_SELECT_ALL'],
			'TXT_DESELECT_ALL'       			=> $_CORELANG['TXT_DESELECT_ALL'],
			'TXT_DELETE_HISTORY_MSG_ALL'		=> $_CORELANG['TXT_DELETE_HISTORY_ALL'],
			'TXT_NEWSLETTER_REGISTRATION_DATE'	=> $_ARRAYLANG['TXT_NEWSLETTER_REGISTRATION_DATE'],
			'TXT_NEWSLETTER_ROWS_PER_PAGE'		=> $_ARRAYLANG['TXT_NEWSLETTER_ROWS_PER_PAGE'],
			'TXT_NEWSLETTER_RECIPIENTS'			=> $_ARRAYLANG['TXT_NEWSLETTER_RECIPIENTS'],
			'NEWSLETTER_PAGING_LIMIT'			=> $limit
		));

		if (isset($_REQUEST['newsletterListId'])) {
			$newsletterListId = intval($_REQUEST['newsletterListId']);
		}

		$this->_objTpl->setVariable('NEWSLETTER_LIST_MENU', $this->CategoryDropDown('newsletterListId', $newsletterListId, "id='newsletterListId' onchange=\"window.location.replace('index.php?cmd=newsletter&act=users&newsletterListId='+this.value)\""));


		if($_GET["addmailcode"]=="exe"){

			$query		= "SELECT id, code FROM ".DBPREFIX."module_newsletter_user where code=''";
			$objResult 	= $objDatabase->Execute($query);
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					$objResultUPDATE 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_user
														SET code='".$this->EmailCode()."'
														WHERE id=".$objResult->fields['id']."");
					$objResult->MoveNext();
				}
			}

		}

		if($_GET["delete"]=="exe"){
			if($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_user WHERE id=".intval($_GET["id"])) !== false){
				$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_user_cat WHERE user=".$_GET["id"]);
				$this->_strOkMessage = $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
			}else{
				$this->_strErrMessage = $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];
			}
		}

		if($_GET["bulkdelete"]=="exe"){
			$error=0;
			if(!empty($_POST['userid'])){
				foreach ($_POST['userid'] as $userid){
					$userid=intval($userid);
					if($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_user WHERE id=$userid") !== false){
						$objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_user_cat WHERE user=$userid");
					}else{
						$error=1;
					}
				}
				if($error){
					$this->_strErrMessage = $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];
				}else{
					$this->_strOkMessage = $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
				}
			}
		}


		$queryCHECK 		= "SELECT id, code FROM ".DBPREFIX."module_newsletter_user where code=''";
		$objResultCHECK 	= $objDatabase->Execute($queryCHECK);
		$count 		= $objResultCHECK->RecordCount();
		if ($count > 0) {
			$email_code_check = '<div style="color: red;">'.$_ARRAYLANG['TXT_EMAIL_WITHOUT_CODE_MESSAGE'].'!<br/><a href="index.php?cmd=newsletter&act=users&addmailcode=exe">'.$_ARRAYLANG['TXT_ADD_EMAIL_CODE_LINK'].' ></a></div/><br/>';
			$this->_objTpl->setVariable('EMAIL_CODE_CHECK', $email_code_check);
		}

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_CHECK_ALL'	=> $_ARRAYLANG['TXT_NEWSLETTER_CHECK_ALL'],
			'TXT_NEWSLETTER_UNCHECK_ALL'	=> $_ARRAYLANG['TXT_NEWSLETTER_UNCHECK_ALL'],
			'TXT_NEWSLETTER_WITH_SELECTED'	=> $_ARRAYLANG['TXT_NEWSLETTER_WITH_SELECTED'],
			'TXT_NEWSLETTER_DELETE'			=> $_ARRAYLANG['TXT_NEWSLETTER_DELETE'],



			'TXT_STATUS'			=> $_ARRAYLANG['TXT_STATUS'],
			'TXT_SEARCH'			=> $_ARRAYLANG['TXT_SEARCH'],
			'TXT_EMAIL_ADDRESS'		=> $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
			'TXT_LASTNAME'			=> $_ARRAYLANG['TXT_LASTNAME'],
			'TXT_FIRSTNAME'			=> $_ARRAYLANG['TXT_FIRSTNAME'],
			'TXT_STREET'			=> $_ARRAYLANG['TXT_STREET'],
			'TXT_ZIP'				=> $_ARRAYLANG['TXT_ZIP'],
			'TXT_CITY'				=> $_ARRAYLANG['TXT_CITY'],
			'TXT_COUNTRY'			=> $_ARRAYLANG['TXT_COUNTRY'],
			'TXT_PHONE'				=> $_ARRAYLANG['TXT_PHONE'],
			'TXT_BIRTHDAY'			=> $_ARRAYLANG['TXT_BIRTHDAY'],
			'TXT_USER_DATA'			=> $_ARRAYLANG['TXT_USER_DATA'],
			'TXT_NEWSLETTER_CATEGORYS'	=> $_ARRAYLANG['TXT_NEWSLETTER_CATEGORYS'],
			'TXT_STATUS'			=> $_ARRAYLANG['TXT_STATUS'],
			'SELECTLIST_FIELDS'		=> $this->SelectListFields(),
			'SELECTLIST_CATEGORY'	=> $this->SelectListCategory(),
			'SELECTLIST_STATUS'		=> $this->SelectListStatus(),
			'JAVASCRIPTCODE'		=> $this->JSedituser(),
			'TXT_EDIT'				=> $_ARRAYLANG['TXT_EDIT'],
			'TXT_ADD'				=> $_ARRAYLANG['TXT_ADD'],
			'TXT_IMPORT'			=> $_ARRAYLANG['TXT_IMPORT'],
			'TXT_EXPORT'			=> $_ARRAYLANG['TXT_EXPORT'],
			'TXT_FUNCTIONS'			=> $_CORELANG['TXT_FUNCTIONS'],
			));

		$this->_objTpl->setGlobalVariable(array(
			'TXT_NEWSLETTER_MODIFY_RECIPIENT'	=> $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_RECIPIENT'],
			'TXT_NEWSLETTER_DELETE_RECIPIENT'	=> $_ARRAYLANG['TXT_NEWSLETTER_DELETE_RECIPIENT'],
		));

		$where_statement = '';
		if($_POST["keyword"]!=""){
			if($_POST["SearchFields"]!=""){
				$where_statement .= ' and '.contrexx_addslashes($_POST["SearchFields"]).' LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" ';
			}else{
				$where_statement .= '	and (email LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or lastname LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or firstname LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or street LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or zip LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or city LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or country LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or phone LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%" 
										or birthday LIKE "%'.contrexx_addslashes($_POST["keyword"]).'%")';
			}
		}
		// kategoriesuche noch einbauen
		if($_POST["SearchCategory"]!=""){
			$where_statement .= ' ';
		}

		if($_POST["SearchStatus"]!=""){
			$where_statement .= ' and status='.intval($_POST["SearchStatus"]).' ';
		}

		if ($newsletterListId > 0) {
			$where_statement .= " and tblUser.id=tblRel.user and tblRel.category=".$newsletterListId;
		}

		$pos = intval($_GET['pos']);

		if($where_statement == ''){
			$query 		= "	SELECT id, email, lastname, firstname, street, zip, city, country, emaildate, `status`
							FROM ".DBPREFIX."module_newsletter_user
							GROUP BY id
							ORDER BY emaildate DESC";
		}else{
			$query 		= "	SELECT tblUser.id, email, lastname, firstname, street, zip, city, country, emaildate, `status`
							FROM ".DBPREFIX."module_newsletter_user AS tblUser, "
							.DBPREFIX."module_newsletter_rel_user_cat AS tblRel
							where 1=1 ".$where_statement."
							GROUP BY tblUser.id
							ORDER BY emaildate DESC";
		}
//		$objResult = $objDatabase->SelectLimit($query, $limit, $pos);

		//show only one record set if _REQUEST['id'] is set (meaning the client comes from user details)
		if(!empty($_REQUEST['id']) && $_GET['delete'] != 'exe' && $_GET['bulkdelete'] != 'exe'){
			$objResult = $objDatabase->Execute('SELECT tblUser.id, email, lastname, firstname, street, zip, city, country, emaildate, `status`
												FROM '.DBPREFIX.'module_newsletter_user AS tblUser, '.DBPREFIX.'module_newsletter_rel_user_cat AS tblRel
												WHERE tblUser.id ='.intval($_REQUEST['id'])
												.' GROUP BY tblUser.id order by email LIMIT 1');
		}else{
			$objResult = $objDatabase->SelectLimit($query, $limit, $pos);
		}

		if($where_statement == ''){
			$query_2 = "	SELECT COUNT(1) as cnt
							FROM ".DBPREFIX."module_newsletter_user";
		}else{
			$query_2 = "	SELECT COUNT(1) as cnt
							FROM ".DBPREFIX."module_newsletter_user AS tblUser, "
							.DBPREFIX."module_newsletter_rel_user_cat AS tblRel
							WHERE 1=1 ".$where_statement;
		}
		$objResult_2 	= $objDatabase->Execute($query_2);

		$count 		= $objResult_2->fields['cnt'];
		if($count<1){
			$NoUser = $_ARRAYLANG['TXT_NO_USER'];
		}else{
			$NoUser = "";
		}

		$rowNr = 0;
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				if($objResult->fields['status']==1){
					$StatusImg = '<img src="'.ASCMS_ADMIN_WEB_PATH.'/images/icons/led_green.gif" width="13" height="13" border="0" alt="'.$_ARRAYLANG['TXT_ACTIVE'].'" />';
				}else{
					$StatusImg = '<img src="'.ASCMS_ADMIN_WEB_PATH.'/images/icons/led_red.gif" width="13" height="13" border="0" alt="'.$_ARRAYLANG['TXT_OPEN_ISSUE'].'" />'; 
				}
				$this->_objTpl->setVariable(array(
	                'NEWSLETTER_USER_ID'					=> $objResult->fields['id'],
	                'NEWSLETTER_USER_EMAIL'					=> $objResult->fields['email'],
	                'NEWSLETTER_USER_LASTNAME'				=> empty($objResult->fields['lastname']) ? '&nbsp;' : htmlentities($objResult->fields['lastname'], ENT_QUOTES),
	                'NEWSLETTER_USER_FIRSTNAME'				=> empty($objResult->fields['firstname']) ? '&nbsp;' : htmlentities($objResult->fields['firstname'], ENT_QUOTES),
	                'NEWSLETTER_USER_STREET'				=> empty($objResult->fields['street']) ? '&nbsp;' : htmlentities($objResult->fields['street'], ENT_QUOTES),
	                'NEWSLETTER_USER_ZIP'					=> empty($objResult->fields['zip']) ? '&nbsp;' : htmlentities($objResult->fields['zip'], ENT_QUOTES),
	                'NEWSLETTER_USER_CITY'					=> empty($objResult->fields['city']) ? '&nbsp;' : htmlentities($objResult->fields['city'], ENT_QUOTES),
	                'NEWSLETTER_USER_COUNTRY'				=> empty($objResult->fields['country']) ? '&nbsp;' : htmlentities($objResult->fields['country'], ENT_QUOTES),
                	'NEWSLETTER_USER_REGISTRATION_DATE'		=> empty($objResult->fields['emaildate']) ? '&nbsp;' : date(ASCMS_DATE_FORMAT, $objResult->fields['emaildate']),
	                'STATUS_IMG'							=> $StatusImg,
	                'ROW_CLASS'								=> $rowNr % 2 == 1 ? 'row1' : 'row2'
				));
				$rowNr++;
				$this->_objTpl->parse("newsletter_user");
				$objResult->MoveNext();
			}
		}
		if(!empty($limit)){
			$_CONFIG['corePagingLimit'] = $limit;
		}


		$paging = getPaging($count, $pos, "&amp;cmd=newsletter&amp;act=users&amp;limit=".$_CONFIG['corePagingLimit'], "", true, $_CONFIG['corePagingLimit']);
		$this->_objTpl->setVariable("USER_PAGING", $paging);
		$this->_objTpl->setVariable('TXT_EDIT', $_ARRAYLANG['TXT_EDIT']);
		$this->_objTpl->parse('module_newsletter_user_overview');
	}

	function SelectListStatus(){
		global $objDatabase, $_ARRAYLANG;
		$ReturnVar = '
			<select name="SearchStatus">
				<option value="">-- '.$_ARRAYLANG['TXT_STATUS'].' --</option>
				<option value="0">'.$_ARRAYLANG['TXT_OPEN_ISSUE'].'</option>
				<option value="1">'.$_ARRAYLANG['TXT_ACTIVE'].'</option>
			</select>
		';
		return $ReturnVar;
	}


	function SelectListCategory(){
		global $objDatabase, $_ARRAYLANG;
		$ReturnVar = '<select name="SearchCategory">';
		$ReturnVar .= '<option value="">-- '.$_ARRAYLANG['TXT_NEWSLETTER_CATEGORYS'].' --</option>';
		$queryPS 		= "SELECT * FROM ".DBPREFIX."module_newsletter_category order by name";
		$objResultPS 	= $objDatabase->Execute($queryPS);
		if ($objResultPS !== false) {
			while (!$objResultPS->EOF) {
				$ReturnVar .= '<option value="'.$objResultPS->fields['id'].'" >'.$objResultPS->fields['name'].'</option>';
				$objResultPS->MoveNext();
			}
		}
		$ReturnVar .= '</select>';
		return $ReturnVar;
	}


	function SelectListFields(){
		global $objDatabase, $_ARRAYLANG;
		$ReturnVar = '
			<select name="SearchFields">
				<option value="">-- '.$_ARRAYLANG['TXT_SEARCH_ON'].' --</option>
				<option value="email">'.$_ARRAYLANG['TXT_EMAIL_ADDRESS'].'</option>
				<option value="lastname">'.$_ARRAYLANG['TXT_LASTNAME'].'</option>
				<option value="firstname">'.$_ARRAYLANG['TXT_FIRSTNAME'].'</option>
				<option value="street">'.$_ARRAYLANG['TXT_STREET'].'</option>
				<option value="zip">'.$_ARRAYLANG['TXT_ZIP'].'</option>
				<option value="city">'.$_ARRAYLANG['TXT_CITY'].'</option>
				<option value="country">'.$_ARRAYLANG['TXT_COUNTRY'].'</option>
				<option value="phone">'.$_ARRAYLANG['TXT_PHONE'].'</option>
				<option value="birthday">'.$_ARRAYLANG['TXT_BIRTHDAY'].'</option>
			</select>
		';
		return $ReturnVar;
	}


	function JSadduser(){
		global $objDatabase, $_ARRAYLANG;
		Return '
			<script language="javascript">
				function SubmitAddForm(){
					if(CheckMail(document.adduser.email.value)==true){
							document.adduser.submit();
					}else{
						alert("'.$_ARRAYLANG['TXT_MAILERROR'].'");
						document.adduser.email.focus();
					}
				}

				function CheckMail(s){
	 				var a = false;
	 				var res = false;
 					if(typeof(RegExp) == "function"){
  						var b = new RegExp("abc");
  						if(b.test("abc") == true){a = true;}
  					}
					if(a == true){
	  					reg = new RegExp("^([a-zA-Z0-9\\-\\.\\_]+)"+
						                   "(\\@)([a-zA-Z0-9\\-\\.]+)"+
						                   "(\\.)([a-zA-Z]{2,4})$");
						res = (reg.test(s));
					}else{
						res = (s.search("@") >= 1 &&
						s.lastIndexOf(".") > s.search("@") &&
						s.lastIndexOf(".") >= s.length-5)
					}
					return(res);
				}
			</script>
		';
	}

	function JSimportuser(){
		global $_ARRAYLANG;
		Return '
			<script type="text/javascript">
			//<![CDATA[
				function SubmitImportForm(){
					if(document.importuser.GSdatei.value!="" || document.importuser.Emails.value!=""){
						document.importuser.submit();
					}
				}

				var syncDropDown = function(index){
					document.getElementsByName("category")[0].options.selectedIndex = index;
					document.getElementsByName("category")[1].options.selectedIndex = index;
				}
			//]]>
			</script>
		';
	}

	function JSedituser(){
		global $_ARRAYLANG;
		Return '
			<script type="text/javascript">
			//<![CDATA[
				function DeleteUser(UserID){
					if(confirm("'.$_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'].'")){
						document.location.href = "index.php?cmd=newsletter&act=users&delete=exe&id="+UserID;
					}
				}

				function MultiAction()
				{
					with (document.userlist)
					{
						switch (userlist_MultiAction.value) {
							case \'delete\':
								if (confirm(\''.$_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'].'\')) {
									submit();
								}
							break;
							default: //do nothing

						}
					}
				}
			//]]>
			</script>
		';
	}

	function DateForDB(){
		return date("Y")."-".date("m")."-".date("d");
	}

	function EmailCode(){
		$ReturnVar = '';
		$pool = "qwertzupasdfghkyxcvbnm";
		$pool .= "23456789";
		$pool .= "WERTZUPLKJHGFDSAYXCVBNM";
		srand ((double)microtime()*1000000);
		for($index = 0; $index < 10; $index++){
			$ReturnVar .= substr($pool,(rand()%(strlen ($pool))), 1);
		}
		return $ReturnVar;
	}

	function _getTemplateMenu($selectedTemplate = '', $attributes = '')
	{
		$menu = "<select".(!empty($attributes) ? " ".$attributes : "").">\n";
		foreach ($this->_getTemplates() as $templateId => $arrTemplate) {
			$menu .= "<option value=\"".$templateId."\"".($templateId == $selectedTemplate ? "selected=\"selected\"" : "").">".htmlentities($arrTemplate['name'], ENT_QUOTES)."</option>\n";
		}
		$menu .= "</select>\n";

		return $menu;
	}


	function _getTemplates()
	{
		global $objDatabase;

		$arrTemplates = array();

		$objTemplate = $objDatabase->Execute("SELECT id, name, description, html, text FROM ".DBPREFIX."module_newsletter_template");
		if ($objTemplate !== false) {
			while (!$objTemplate->EOF) {
				$arrTemplates[$objTemplate->fields['id']] = array(
					'name'			=> $objTemplate->fields['name'],
					'description'	=> $objTemplate->fields['description'],
					'html'			=> $objTemplate->fields['html'],
					'text'			=> $objTemplate->fields['text']
				);
				$objTemplate->MoveNext();
			}
		}

		return $arrTemplates;
	}

	
	function CategoryDropDown($name = 'category', $selected = 0, $attrs = ''){
		global $objDatabase, $_ARRAYLANG;
		$ReturnVar = '<select name="'.$name.'"'.(!empty($attrs) ? ' '.$attrs : '').'>
		<option value="selectcategory">'.$_ARRAYLANG['TXT_NEWSLETTER_SELECT_CATEGORY'].'</option>
		<option value="">'.$_ARRAYLANG['TXT_NEWSLETTER_ALL'].'</option>';
		$queryCS 		= "SELECT id, name FROM ".DBPREFIX."module_newsletter_category";
		$objResultCS 	= $objDatabase->Execute($queryCS);
		if ($objResultCS !== false) {
			$CategorysFounded = 1;
			while (!$objResultCS->EOF) {
				$ReturnVar .= '<option value="'.$objResultCS->fields['id'].'"'.($objResultCS->fields['id'] == $selected ? 'selected="selected"' : '').'>'.htmlentities($objResultCS->fields['name'], ENT_QUOTES).'</option>';
				$objResultCS->MoveNext();
			}
		}
		$ReturnVar .= '</select>';
		if($CategorysFounded!=1){
			$ReturnVar = '';
		}
		return $ReturnVar;
	}

	function _listOverview($limit = 10)
	{
		global $objDatabase, $_ARRAYLANG;

		$rowNr = 0;

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_LISTS'	=> $_ARRAYLANG['TXT_NEWSLETTER_LISTS']
		));

		$objList = $objDatabase->SelectLimit("SELECT tblList.id AS listId, tblList.status, tblList.name, tblMail.id AS mailId, tblMail.subject, tblMail.date_sent
          	FROM ".DBPREFIX."module_newsletter_category AS tblList
          	LEFT JOIN ".DBPREFIX."module_newsletter_rel_cat_news AS tblRel ON tblRel.category=tblList.id
          	LEFT JOIN ".DBPREFIX."module_newsletter AS tblMail ON tblMail.id=tblRel.newsletter
            GROUP BY tblList.id
            ORDER BY date_sent DESC", $limit);

		if ($objList !== false && $objList->RecordCount() > 0) {
			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_ID_UC'						=> $_ARRAYLANG['TXT_NEWSLETTER_ID_UC'],
				'TXT_NEWSLETTER_STATUS'						=> $_ARRAYLANG['TXT_NEWSLETTER_STATUS'],
				'TXT_NEWSLETTER_NAME'						=> $_ARRAYLANG['TXT_NEWSLETTER_NAME'],
				'TXT_NEWSLETTER_LAST_EMAIL'					=> $_ARRAYLANG['TXT_NEWSLETTER_LAST_EMAIL'],
				'TXT_NEWSLETTER_RECIPIENTS'					=> $_ARRAYLANG['TXT_NEWSLETTER_RECIPIENTS'],
				'TXT_NEWSELTTER_GO_TO_LIST_ADMINISTRATION'	=> $_ARRAYLANG['TXT_NEWSELTTER_GO_TO_LIST_ADMINISTRATION'],
				'TXT_NEWSLETTER_LIST_COUNT'					=> $_ARRAYLANG['TXT_NEWSLETTER_LIST_COUNT']
			));

			$this->_objTpl->setGlobalVariable('TXT_NEWSLETTER_MODIFY_LIST', $_ARRAYLANG['TXT_NEWSLETTER_MODIFY_LIST']);

			while (!$objList->EOF) {
				$objRecipient = $objDatabase->SelectLimit("SELECT COUNT(1) AS recipients_count FROM ".DBPREFIX."module_newsletter_rel_user_cat AS tblRel WHERE tblRel.category=".$objList->fields['listId']." GROUP BY tblRel.category", 1);
				if ($objRecipient !== false && $objRecipient->RecordCount() == 1) {
					$recipientCount = $objRecipient->fields['recipients_count'];
				} else {
					$recipientCount = 0;
				}

				$this->_objTpl->setVariable(array(
					'NEWSLETTER_LIST_ROW_CLASS'			=> $rowNr % 2 == 1 ? "row1" : "row2",
					'NEWSLETTER_LIST_ID'				=> $objList->fields['listId'],
					'NEWSLETTER_LIST_STATUS_IMG'		=> $objList->fields['status'] == 1 ? "folder_on.gif" : "folder_off.gif",
					'NEWSLETTER_LIST_NAME'				=> htmlentities($objList->fields['name'], ENT_QUOTES),
					'NEWSLETTER_LIST_RECIPIENT_COUNT'	=> $recipientCount > 0 ? '<a href="index.php?cmd=newsletter&amp;act=users&amp;newsletterListId='.$objList->fields['listId'].'" title="'.sprintf($_ARRAYLANG['TXT_NEWSLETTER_SHOW_RECIPIENTS_OF_LIST'], htmlentities($objList->fields['name'], ENT_QUOTES)).'">'.$recipientCount.'</a>' : '-',
					'NEWSLETTER_LIST_LAST_SENT_MAIL'	=> $objList->fields['date_sent'] > 0 ? '<a href="index.php?cmd=newsletter&amp;act=showMail&amp;id='.$objList->fields['mailId'].'" title="'.$_ARRAYLANG['TXT_NEWSLETTER_DISPLAY_EMAIL'].'">'.htmlentities($objList->fields['subject'], ENT_QUOTES).' ('.date(ASCMS_DATE_FORMAT, $objList->fields['date_sent']).')</a>' : '-',
				));

				$rowNr++;
				$this->_objTpl->parse('newsletter_lists');

				$objList->MoveNext();
			}

			$objList = $objDatabase->Execute("SELECT COUNT(1) AS list_count FROM ".DBPREFIX."module_newsletter_category");
			if ($objList !== false) {
				$listCount = $objList->fields['list_count'];
			} else {
				$listCount = '-';
			}
			
			$this->_objTpl->setVariable('NEWSLETTER_LIST_COUNT', $listCount);
			
			$this->_objTpl->touchBlock('newsletter_lists_list');
			$this->_objTpl->hideBlock('newsletter_lists_no_list');
		} else {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_ADD_NEW_LIST_MSG', $_ARRAYLANG['TXT_NEWSLETTER_ADD_NEW_LIST_MSG']);

			$this->_objTpl->hideBlock('newsletter_lists_list');
			$this->_objTpl->touchBlock('newsletter_lists_no_list');
		}

	}

	function _mailOverview($limit = 10)
	{
		global $objDatabase, $_ARRAYLANG;

		$rowNr = 0;
		$this->_objTpl->setVariable('TXT_NEWSLETTER_SENT_EMAILS', $_ARRAYLANG['TXT_NEWSLETTER_SENT_EMAILS']);

		$objMail = $objDatabase->SelectLimit("SELECT id, subject, date_sent FROM ".DBPREFIX."module_newsletter WHERE status='1' ORDER BY date_sent DESC", $limit);
		if ($objMail !== false && $objMail->RecordCount() > 0) {
			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_ID_UC'						=> $_ARRAYLANG['TXT_NEWSLETTER_ID_UC'],
				'TXT_NEWSLETTER_SUBJECT'					=> $_ARRAYLANG['TXT_NEWSLETTER_SUBJECT'],
				'TXT_NEWSLETTER_SENT'						=> $_ARRAYLANG['TXT_NEWSLETTER_SENT'],
				'TXT_NEWSLETTER_GO_TO_EMAIL_ADMINISTRATION'	=> $_ARRAYLANG['TXT_NEWSLETTER_GO_TO_EMAIL_ADMINISTRATION'],
				'TXT_NEWSLETTER_TOTAL_SENT_EMAILS'			=> $_ARRAYLANG['TXT_NEWSLETTER_TOTAL_SENT_EMAILS'],
				'TXT_NEWSLETTER_UNSENDET_EMAILS'			=> $_ARRAYLANG['TXT_NEWSLETTER_UNSENDET_EMAILS']
			));

			$this->_objTpl->setGlobalVariable('TXT_NEWSLETTER_DISPLAY_EMAIL', $_ARRAYLANG['TXT_NEWSLETTER_DISPLAY_EMAIL']);

			while (!$objMail->EOF) {
				$this->_objTpl->setVariable(array(
					'NEWSLETTER_MAIL_ROW_CLASS'	=> $rowNr % 2 == 1 ? "row1" : "row2",
					'NEWSLETTER_MAIL_ID'		=> $objMail->fields['id'],
					'NEWSLETTER_MAIL_SUBJECT'	=> htmlentities($objMail->fields['subject'], ENT_QUOTES),
					'NEWSLETTER_MAIL_SENT_DATE'	=> date(ASCMS_DATE_FORMAT, $objMail->fields['date_sent'])
				));

				$rowNr++;
				$this->_objTpl->parse('newsletter_mails');
				$objMail->MoveNext();
			}

			$this->_objTpl->touchBlock('newsletter_mails_list');
			$this->_objTpl->hideBlock('newsletter_mails_no_mail');
		} else {
			$this->_objTpl->setVariable('TXT_NEWSLETTER_CREATE_NEW_EMAIL_MSG', $_ARRAYLANG['TXT_NEWSLETTER_CREATE_NEW_EMAIL_MSG']);

			$this->_objTpl->touchBlock('newsletter_mails_no_mail');
			$this->_objTpl->hideBlock('newsletter_mails_list');
		}
	}


	function _getHTML(){
		global $_ARRAYLANG;

		$listId = isset($_GET['id']) ? intval($_GET['id']) : 0;
		if ($listId == 0) {
			return $this->_lists();
		}

		$this->_pageTitle = $_ARRAYLANG['TXT_NEWSLETTER_LISTS'];
		$this->_objTpl->loadTemplateFile('module_newsletter_list_sourcecode.html');
		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_GENERATE_HTML_SOURCE_CODE'	=> $_ARRAYLANG['TXT_NEWSLETTER_GENERATE_HTML_SOURCE_CODE'],
			'TXT_NEWSLETTER_BACK'						=> $_ARRAYLANG['TXT_NEWSLETTER_BACK']
		));

		$html_code = '<form name="newsletter" action="?section=newsletter&amp;act=subscribe" method="post">'.chr(13).chr(10);
		$html_code .= '<input type="hidden" name="subscribe" value="exe" />'.chr(13).chr(10);
		$html_code .= '<input type="hidden" name="block" value="1" />'.chr(13).chr(10);
		$html_code .= '<input type="hidden" name="category_'.$id.'" value="1" />'.chr(13).chr(10);
		$html_code .= '<input type="text" onfocus="this.value=\'\'" name="email" value="'.$_ARRAYLANG['TXT_NEWSLETTER_EMAIL_ADDRESS'].'" style="width: 165px;" maxlength="250" /><br /><br />'.chr(13).chr(10);
		$html_code .= '<input type="submit" value="'.$_ARRAYLANG['TXT_NEWSLETTER_SUBSCRIBE'].'" />'.chr(13).chr(10).'</form>';

		$this->_objTpl->setVariable('NEWSLETTER_HTML_CODE', htmlentities($html_code, ENT_QUOTES));
	}
}
?>
