<?PHP
/**
* Newsletter Modul
*
* frontend newsletter class
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>
* @module newsletter
* @modulegroup modules
* @access public
* @version 1.0.1
*/


class newsletter
{
    var $langId;
    var $_objTpl;
    var $statusMessage;
    var $arrSettings = array();


	/**
    * Constructor
    *
    * @param  string
    * @access public
    */
    function newsletter($pageContent)
    {
    	$this->__construct($pageContent);
    }



    /**
     * PHP5 constructor
     * @param  string  $pageContent
     * @global string  $_LANGID
     * @access public
     */
    function __construct($pageContent)
    {
	    global $_LANGID;

	    $this->pageContent = $pageContent;
	    $this->langId = $_LANGID;

	    $this->_objTpl = &new HTML_Template_Sigma('.');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);

	}




	function getPage()
	{
		global $_LANGID, $_ARRAYLANG;
    	if(!isset($_REQUEST['cmd'])){
    		$_REQUEST['cmd'] = '';
    	}

    	switch($_REQUEST['cmd']){
    		case 'profile':
		    	$this->_profile();
		    	break;
		    case 'unsubscribe':
		    	$this->_unsubscribe();
		    	break;
		     case 'subscribe':
		    	$this->_subscribe();
		    	break;
		    case 'confirm':
		    	$this->_confirm();
		    	break;
		    default:
		        $this->_subscribe();
		        break;
    	}
    	return $this->_objTpl->get();
    }

    function _confirm(){
    	global $objDatabase, $_ARRAYLANG;
		$this->_objTpl->setTemplate($this->pageContent, true, true);

		$query 		= "SELECT id FROM ".DBPREFIX."module_newsletter_user where status=0 and email='".contrexx_addslashes($_GET['email'])."'";
		$objResult 	= $objDatabase->Execute($query);
		$count	 	= $objResult->RecordCount();

		if($count == 1){
			$objResult 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_user SET status=1 where email='".contrexx_addslashes($_GET['email'])."'");
			if ($objResult !== false) {
				$this->_objTpl->setVariable("NEWSLETTER_MESSAGE", $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_SUCCESSFUL']);

				//send mail
				$query = "SELECT id, title, firstname, lastname, email, code FROM ".DBPREFIX."module_newsletter_user WHERE email='".contrexx_addslashes($_GET['email'])."'";
				$objResult = $objDatabase->Execute($query);

				if ($objResult !== false) {
					$userFirstname	= $objResult->fields['firstname'];
					$userLastname	= $objResult->fields['lastname'];
					$userTitle		= $objResult->fields['title'];
					switch($userTitle){
						case "m":
							$userTitle = $_ARRAYLANG['TXT_NEWSLETTER_MALE'];
							break;

						case "f":
							$userTitle = $_ARRAYLANG['TXT_NEWSLETTER_FEMALE'];
							break;

						default:
							$userTitle = '';
							break;
					}

					$query_conf 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setid=1";
					$objResult_conf 	= $objDatabase->Execute($query_conf);
					if ($objResult_conf !== false) {
						$value_sender_emailDEF 	= $objResult_conf->fields['setvalue'];
					}

					$query_conf 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setid=2";
					$objResult_conf 	= $objDatabase->Execute($query_conf);
					if ($objResult_conf !== false) {
						$value_sender_nameDEF 	= $objResult_conf->fields['setvalue'];
					}

					$query_conf 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setid=3";
					$objResult_conf 	= $objDatabase->Execute($query_conf);
					if ($objResult_conf !== false) {
						$value_reply_mailDEF 	= $objResult_conf->fields['setvalue'];
					}

					$query_content 		= "SELECT title, content FROM ".DBPREFIX."module_newsletter_confirm_mail WHERE id='2'";
					$objResult_content  	= $objDatabase->Execute($query_content );
					if ($objResult_content !== false) {
						$subject 	= $objResult_content->fields['title'];
						$content 	= $objResult_content->fields['content'];
					}

					require_once ASCMS_LIBRARY_PATH . '/phpmailer/class.phpmailer.php';

					$url			= $_SERVER['SERVER_NAME'];
					$now 			= date(ASCMS_DATE_FORMAT);



					//replase placeholder
					$array_1 = array('[[title]]', '[[firstname]]', '[[lastname]]', '[[url]]', '[[date]]');
					$array_2 = array($userTitle, $userFirstname, $userLastname, $url, $now);

					$mailTitle = str_replace($array_1, $array_2, $subject);
					$mailContent = str_replace($array_1, $array_2, $content);


					$mail = new phpmailer();
					$mail->From 			= $value_sender_emailDEF;
					$mail->FromName 		= $value_sender_nameDEF;
					$mail->AddReplyTo($value_reply_mailDEF);
					$mail->Subject 			= $mailTitle;
					$mail->Priority 		= 3;
					$mail->IsHTML(false);
					$mail->Body 			= $mailContent;
					$mail->AddAddress($_GET['email']);
					$mail->Send();

				}
			}
		}else{
			$this->_objTpl->setVariable("NEWSLETTER_MESSAGE", '<font color="red">'.$_ARRAYLANG['TXT_NOT_VALID_EMAIL'].'</font>');
		}
    }

	function _profile(){
		global $objDatabase, $_ARRAYLANG;
		$this->_objTpl->setTemplate($this->pageContent, true, true);

		$PageSource = '';
		$UserCode = $_REQUEST['code'];

		// Profile Update
		// --------------------------------------
		if($_REQUEST['profileupdate']=="exe"){

			$cat_selected = 0;
			$query 		= "SELECT id, status, name FROM ".DBPREFIX."module_newsletter_category where status=1 order by name";
			$objResult 	= $objDatabase->Execute($query);
			$cat_code = '';
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					if($_REQUEST['category_'.$objResult->fields['id']]=="1"){
						$cat_selected = 1;
					}
					$objResult->MoveNext();
				}
			}

			$objValidator = &new FWValidator();
			if($cat_selected==0){
				$Message = '<font color="red">'.$_ARRAYLANG['TXT_CATEGORY_ERROR'].'</font><br /><br />';
			}elseif (!$objValidator->isEmail($_REQUEST['email'])){
				$Message = '<font color="red">'.$_ARRAYLANG['TXT_NOT_VALID_EMAIL'].'</font><br /><br />';
			}else{
				$objResult 	= $objDatabase->Execute("UPDATE ".DBPREFIX."module_newsletter_user
												SET email='".$_REQUEST["email"]."', title='".$_REQUEST["title"]."', lastname='".$_REQUEST["lastname"]."', firstname='".$_REQUEST["firstname"]."', street='".$_REQUEST["street"]."', zip='".$_REQUEST["zip"]."', city='".$_REQUEST["city"]."', country='".$_REQUEST["country"]."', phone='".$_REQUEST["phone"]."', birthday='".$_REQUEST["birthday"]."' where code='".$_REQUEST['code']."'");

				$objResult 	= $objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_user_cat where user=".$this->GetUserID($UserCode)."");

				$query 		= "SELECT id, name FROM ".DBPREFIX."module_newsletter_category order by name";
				$objResult 	= $objDatabase->Execute($query);
				if ($objResult !== false) {
					while (!$objResult->EOF) {
						if($_REQUEST['category_'.$objResult->fields['id']]=="1"){
							$objResult_in 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat
												(user, category)
												VALUES (".$this->GetUserID($UserCode).", ".$objResult->fields['id'].")");
						}
						$objResult->MoveNext();
					}
				}

			}
		}
		$query = "SELECT * FROM ".DBPREFIX."module_newsletter_user
				     WHERE code='".$UserCode."'";
		$objResult = $objDatabase->Execute($query);
		$count_users 		= $objResult->RecordCount();

		if ($count_users > 0 && $UserCode!='') {

			$query_c 		= "SELECT id, status, name FROM ".DBPREFIX."module_newsletter_category where status=1 order by name";
			$objResult_c 	= $objDatabase->Execute($query_c);
			$count 		= $objResult_c->RecordCount();

			$cat_code = '';
			if ($objResult_c !== false) {
				while (!$objResult_c->EOF) {
					if($count<2){
						$cat_code .= '<input type="hidden" name="category_'.$objResult_c->fields['id'].'" value="1" />';
					}else{
						$cat_code .= '<input type="checkbox" name="category_'.$objResult_c->fields['id'].'" value="1" '.$this->CatChecked($objResult_c->fields['id'], $objResult->fields['id']).' /> '.$objResult_c->fields['name'].'<br />';
					}
					$objResult_c->MoveNext();
				}
			}

			$checked_male = '';
			$checked_female = '';

			if($objResult->fields["title"] == 'f'){
				$checked_female = 'checked="checked"';
			}else{
				$checked_male = 'checked="checked"';
			}


			$this->_objTpl->setVariable(array(
				'TXT_NEWSLETTER_EMAIL_ADDRESS'		=> $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
				'TXT_NEWSLETTER_USER_TITLE'			=> $_ARRAYLANG['TXT_USER_TITLE'],
				'TXT_NEWSLETTER_LASTNAME'			=> $_ARRAYLANG['TXT_LASTNAME'],
				'TXT_NEWSLETTER_FIRSTNAME'			=> $_ARRAYLANG['TXT_FIRSTNAME'],
				'TXT_NEWSLETTER_STREET'				=> $_ARRAYLANG['TXT_STREET'],
				'TXT_NEWSLETTER_ZIP'				=> $_ARRAYLANG['TXT_ZIP'],
				'TXT_NEWSLETTER_CITY'				=> $_ARRAYLANG['TXT_CITY'],
				'TXT_NEWSLETTER_COUNTRY'			=> $_ARRAYLANG['TXT_COUNTRY'],
				'TXT_NEWSLETTER_PHONE'				=> $_ARRAYLANG['TXT_PHONE'],
				'NEWSLETTER_BIRTHDAY'				=> $_ARRAYLANG['TXT_BIRTHDAY'],
				'NEWSLETTER_EMAIL_ADDRESS'			=> $objResult->fields["email"],
				'NEWSLETTER_USER_TITLE'				=> $objResult->fields["title"],
				'NEWSLETTER_LASTNAME'				=> $objResult->fields["lastname"],
				'NEWSLETTER_FIRSTNAME'				=> $objResult->fields["firstname"],
				'NEWSLETTER_STREET'					=> $objResult->fields["street"],
				'NEWSLETTER_ZIP'					=> $objResult->fields["zip"],
				'NEWSLETTER_CITY'					=> $objResult->fields["city"],
				'NEWSLETTER_COUNTRY'				=> $objResult->fields["country"],
				'NEWSLETTER_PHONE'					=> $objResult->fields["phone"],
				'NEWSLETTER_BIRTHDAY'				=> $objResult->fields["birthday"],
				'NEWSLETTER_CATEGORIES'				=> $cat_code,
				'NEWSLETTER_USER_CODE'				=> $UserCode,
				'TXT_NEWSLETTER_SAVE'				=> $_ARRAYLANG['TXT_SAVE'],
				'TXT_NEWSLETTER_MALE'				=> $_ARRAYLANG['TXT_NEWSLETTER_MALE'],
				'TXT_NEWSLETTER_FEMALE'				=> $_ARRAYLANG['TXT_NEWSLETTER_FEMALE'],
				'CHECKED_MALE'						=> $checked_male,
				'CHECKED_FEMALE'					=> $checked_female,

			));




			$this->_objTpl->setVariable(array(
				'NEWSLETTER_MESSAGE'		=> $Message,
			));

			$this->_objTpl->hideBlock('newsletterFailed');
			$this->_objTpl->parse('newsletterForm');
		}else{
			$this->_objTpl->setVariable(array(
				'NEWSLETTER_FAILED_AUTH'		=> '<font color="red">'.$_ARRAYLANG['TXT_AUTHENTICATION_FAILED'].'</font>',
			));

			$this->_objTpl->parse('newsletterFailed');
			$this->_objTpl->hideBlock('newsletterForm');
		}
	}

	function _unsubscribe(){
		global $objDatabase, $_ARRAYLANG;
		$this->_objTpl->setTemplate($this->pageContent, true, true);
		$PageSource = '';


			$query_g = "SELECT code FROM ".DBPREFIX."module_newsletter_user
				     WHERE code='".$_REQUEST['code']."'";
			$objResult_g = $objDatabase->Execute($query_g);
			$count_cc 		= $objResult_g->RecordCount();
			if ($count_cc > 0) {
				$UserID = $this->GetUserID($_REQUEST['code']);
				$objResult 	= $objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_user where id=".$UserID."");
				$objResult 	= $objDatabase->Execute("DELETE FROM ".DBPREFIX."module_newsletter_rel_user_cat where user=".$UserID."");
				$PageSource = $_ARRAYLANG['TXT_EMAIL_SUCCESSFULLY_DELETED'];
			}else{
				$PageSource = '<font color="red">'.$_ARRAYLANG['TXT_AUTHENTICATION_FAILED'].'</font>';
			}


		$this->_objTpl->setVariable("NEWSLETTER_MESSAGE", $PageSource);
	}

	function _subscribe(){
		global $objDatabase, $_CONFIG, $_ARRAYLANG;

		$this->_objTpl->setTemplate($this->pageContent, true, true);
		$Message 		= '';
		$PageSource 	= '';
		$error 			= true;

		// Insert
		// -----------------------
		if($_REQUEST['subscribe']=="exe"){

			$cat_selected = 0;
			$query 		= "SELECT id, name FROM ".DBPREFIX."module_newsletter_category order by name";
			$objResult 	= $objDatabase->Execute($query);
			$cat_code = '';
			if ($objResult !== false) {
				while (!$objResult->EOF) {
					if($_POST['category_'.$objResult->fields['id']]=="1"){
						$cat_selected = 1;
					}
					$objResult->MoveNext();
				}
			}

			$objValidator = &new FWValidator();
			if($cat_selected==0){
				$Message 	= '<font color="red">'.$_ARRAYLANG['TXT_CATEGORY_ERROR'].'</font><br /><br />';
				$error 		= true;
			}elseif (!$objValidator->isEmail($_REQUEST['email'])){
				$Message = '<font color="red">'.$_ARRAYLANG['TXT_NOT_VALID_EMAIL'].'</font><br /><br />';
				$error 		= true;
			}elseif($this->ExistEmail($_REQUEST['email'])){
				$Message = '<font color="red">'.$_ARRAYLANG['TXT_NEWSLETTER_SUBSCRIBER_ALREADY_INSERTED'].'</font><br /><br />';
				$error 		= true;
			}else{
				$objResult 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_user
													(code, email, title, lastname, firstname, street, zip, city, country, phone, birthday, status, emaildate)
													VALUES ('".$this->EmailCode()."', '".$_REQUEST["email"]."', '".$_REQUEST["title"]."', '".$_REQUEST["lastname"]."', '".$_REQUEST["firstname"]."', '".$_REQUEST["street"]."', '".$_REQUEST["zip"]."', '".$_REQUEST["city"]."', '".$_REQUEST["country"]."', '".$_REQUEST["phone"]."', '".$_REQUEST["birthday"]."', 0, '".time()."')");

				$queryPS = "select LAST_INSERT_ID() as lastid from ".DBPREFIX."module_newsletter_user";
				$objResultPS = $objDatabase->Execute($queryPS);
				if ($objResultPS !== false) {
					$CreatedID = $objResultPS->fields['lastid'];
				}

				$query 		= "SELECT id, status, name FROM ".DBPREFIX."module_newsletter_category where status=1 order by name";
				$objResult 	= $objDatabase->Execute($query);
				if ($objResult !== false) {
					while (!$objResult->EOF) {
						if($_REQUEST['category_'.$objResult->fields['id']]=="1"){
							$objResult_in 	= $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_newsletter_rel_user_cat
												(user, category)
												VALUES (".$CreatedID.", ".$objResult->fields['id'].")");
						}
						$objResult->MoveNext();
					}
				}

				// Authorize Email
				// ---------------
				$query = "SELECT id, title, firstname, lastname, email, code FROM ".DBPREFIX."module_newsletter_user WHERE id=".$CreatedID." LIMIT 1";
				$objResult = $objDatabase->Execute($query);

				if ($objResult !== false) {
					$userFirstname	= $objResult->fields['firstname'];
					$userLastname	= $objResult->fields['lastname'];
					$userTitle		= $objResult->fields['title'];
					switch($userTitle){
						case "m":
							$userTitle = $_ARRAYLANG['TXT_NEWSLETTER_MALE'];
							break;

						case "f":
							$userTitle = $_ARRAYLANG['TXT_NEWSLETTER_FEMALE'];
							break;

						default:
							$userTitle = '';
							break;
					}



					$query_conf 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setid=1";
					$objResult_conf 	= $objDatabase->Execute($query_conf);
					if ($objResult_conf !== false) {
						$value_sender_emailDEF 	= $objResult_conf->fields['setvalue'];
					}

					$query_conf 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setid=2";
					$objResult_conf 	= $objDatabase->Execute($query_conf);
					if ($objResult_conf !== false) {
						$value_sender_nameDEF 	= $objResult_conf->fields['setvalue'];
					}

					$query_conf 		= "SELECT setvalue FROM ".DBPREFIX."module_newsletter_settings WHERE setid=3";
					$objResult_conf 	= $objDatabase->Execute($query_conf);
					if ($objResult_conf !== false) {
						$value_reply_mailDEF 	= $objResult_conf->fields['setvalue'];
					}

					$query_content 		= "SELECT title, content FROM ".DBPREFIX."module_newsletter_confirm_mail WHERE id='1'";
					$objResult_content  	= $objDatabase->Execute($query_content );
					if ($objResult_content !== false) {
						$subject 	= $objResult_content->fields['title'];
						$content 	= $objResult_content->fields['content'];
					}

					require_once ASCMS_LIBRARY_PATH . '/phpmailer/class.phpmailer.php';

					$url			= $_SERVER['SERVER_NAME'];
					$now 			= date(ASCMS_DATE_FORMAT);
					$code 			= ASCMS_PROTOCOL.'://'.$_CONFIG['domainUrl'].ASCMS_PATH_OFFSET.'/index.php?section=newsletter&cmd=confirm&email='.$_REQUEST["email"];



					//replase placeholder
					$array_1 = array('[[title]]', '[[firstname]]', '[[lastname]]', '[[code]]', '[[url]]', '[[date]]');
					$array_2 = array($userTitle, $userFirstname, $userLastname, $code, $url, $now);

					$mailTitle = str_replace($array_1, $array_2, $subject);
					$mailContent = str_replace($array_1, $array_2, $content);


					$mail = new phpmailer();
					$mail->From 			= $value_sender_emailDEF;
					$mail->FromName 		= $value_sender_nameDEF;
					$mail->AddReplyTo($value_reply_mailDEF);
					$mail->Subject 			= $mailTitle;
					$mail->Priority 		= 3;
					$mail->IsHTML(false);
					$mail->Body 			= $mailContent;
					$mail->AddAddress($_REQUEST["email"]);
					if($mail->Send()){
						$Message 	= $_ARRAYLANG['TXT_NEWSLETTER_SUBSCRIBE_OK']."<br /><br />";
						$error 		= false;
					}

				}
			}

		}

		$query_c 			= "SELECT id, status, name FROM ".DBPREFIX."module_newsletter_category where status=1 order by name";
		$objResult_c 		= $objDatabase->Execute($query_c);
		$count 				= $objResult_c->RecordCount();
		$cat_code 			= '';
		if ($objResult_c !== false) {
			while (!$objResult_c->EOF) {
				if($count<2){
					$cat_code .= '<input type="hidden" name="category_'.$objResult_c->fields['id'].'" value="1" />';
				}else{
					$cat_code .= '<input type="checkbox" name="category_'.$objResult_c->fields['id'].'" value="1" /> '.$objResult_c->fields['name'].'<br />';
				}
				$objResult_c->MoveNext();
			}
		}

		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_EMAIL_ADDRESS'		=> $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
			'TXT_NEWSLETTER_USER_TITLE'			=> $_ARRAYLANG['TXT_USER_TITLE'],
			'TXT_NEWSLETTER_LASTNAME'			=> $_ARRAYLANG['TXT_LASTNAME'],
			'TXT_NEWSLETTER_FIRSTNAME'			=> $_ARRAYLANG['TXT_FIRSTNAME'],
			'TXT_NEWSLETTER_STREET'				=> $_ARRAYLANG['TXT_STREET'],
			'TXT_NEWSLETTER_ZIP'				=> $_ARRAYLANG['TXT_ZIP'],
			'TXT_NEWSLETTER_CITY'				=> $_ARRAYLANG['TXT_CITY'],
			'TXT_NEWSLETTER_COUNTRY'			=> $_ARRAYLANG['TXT_COUNTRY'],
			'TXT_NEWSLETTER_PHONE'				=> $_ARRAYLANG['TXT_PHONE'],
			'TXT_NEWSLETTER_BIRTHDAY'			=> $_ARRAYLANG['TXT_BIRTHDAY'],
			'NEWSLETTER_CATEGORIES'				=> $cat_code,
			'TXT_NEWSLETTER_SAVE'				=> $_ARRAYLANG['TXT_SAVE'],
			'TXT_NEWSLETTER_MALE'				=> $_ARRAYLANG['TXT_NEWSLETTER_MALE'],
			'TXT_NEWSLETTER_FEMALE'				=> $_ARRAYLANG['TXT_NEWSLETTER_FEMALE'],
		));

		if($error == 1){
			$this->_objTpl->parse('newsletterForm');
		}else{
			$this->_objTpl->hideBlock('newsletterForm');
		}


		$this->_objTpl->setVariable(array(
			'NEWSLETTER_MESSAGE'		=> $Message,
		));
	}

	function CatChecked($CatID, $UserID){
		global $objDatabase;

		$query_cc = "SELECT user FROM ".DBPREFIX."module_newsletter_rel_user_cat
				     WHERE user='".$UserID."' and category='".$CatID."'";
		$objResult_cc = $objDatabase->Execute($query_cc);
		$count_cc 		= $objResult_cc->RecordCount();
		if ($count_cc > 0) {
			return 'checked';
		}else{
			return '2';
		}
	}

	function GetUserID($UserCode){
		global $objDatabase;
		$query_g = "SELECT id FROM ".DBPREFIX."module_newsletter_user
				     WHERE code='".$UserCode."'";
		$objResult_g = $objDatabase->Execute($query_g);
		if ($objResult_g !== false) {
			return $objResult_g->fields["id"];
		}else{
			return '';
		}
	}

	function ExistEmail($email){
		global $objDatabase;
		$query_g = "SELECT email FROM ".DBPREFIX."module_newsletter_user
				     WHERE email='".$email."'";
		$objResult_g = $objDatabase->Execute($query_g);
		$count_cc 		= $objResult_g->RecordCount();
		if ($count_cc > 0) {
			return true;
		}else{
			return false;
		}
	}

	function EmailCode(){
		$ReturnVar = '';
		$pool = "qwertzupasdfghkyxcvbnm";
		$pool .= "23456789";
		$pool .= "WERTZUPLKJHGFDSAYXCVBNM";
		srand ((double)microtime()*1000000);
		for($index = 0; $index < 10; $index++){
			$ReturnVar .= substr($pool,(rand()%(strlen ($pool))), 1);
		}
		return $ReturnVar;
	}

	function setBlock(&$code){
		$html = $this->getHTML();

		$code = str_replace("{NEWSLETTER_BLOCK}", $html, $code);
	}

	function getHTML(){
		global $objDatabase;
		$query 		= "SELECT id, name FROM ".DBPREFIX."module_newsletter_category WHERE status='1' order by name";
		$objResult 	= $objDatabase->Execute($query);
		$count 		= $objResult->RecordCount();
		if($count<1){
			$this->_objTpl->setVariable('TXT_NO_CATEGORIES', $_ARRAYLANG['TXT_NO_CATEGORIES']);
		}else{
			$NoCats = "";
		}
		if ($objResult !== false) {
			$html_code = '<form name="newsletter" action="?section=newsletter&amp;act=subscribe" method="post">'.chr(13).chr(10);
			$html_code .= '<input type="hidden" name="subscribe" value="exe" />'.chr(13).chr(10);
			$html_code .= '<input type="hidden" name="block" value="1" />'.chr(13).chr(10);
			while (!$objResult->EOF) {

				if($count==1){
					$html_code .= '<input type="hidden" name="category_'.$objResult->fields['id'].'" value="1" />'.chr(13).chr(10);
				}else{
					$html_code .= '<input type="checkbox" name="category_'.$objResult->fields['id'].'" value="1"  /> '.$objResult->fields['name'].'<br />'.chr(13).chr(10);
				}

				$objResult->MoveNext();
			}
			if($count>=1){
				$html_code .= '<br />';
			}

			$html_code .= '<input type="text" onfocus="this.value=\'\'" name="email" value=" E-mail Adresse" style="width: 165px;" maxlength="250" /><br /><br />'.chr(13).chr(10).'<input type="submit" value="Eintragen" />'.chr(13).chr(10).'</form>';
		}

		return $html_code;
	}
}
?>
